
package org.act.wsc.bpel4wsmodeling.debug.operate;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import org.act.services.workflow.debug.IDebugEngineListener;
import org.act.wsc.bpel4wsmodeling.debug.debugclient.clientTest;
import org.act.wsc.bpel4wsmodeling.debug.engine.WSWF;
import org.act.wsc.bpel4wsmodeling.global.Application;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.FlowFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.GraphLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Layer;
import org.act.wsc.bpel4wsmodeling.projectdata.process.PickFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.ScopeFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.SequenceFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.StructFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.SwitchFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.WhileFigure;
import org.act.wsc.bpel4wsmodeling.utils.FileUtility;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class DebugOp implements IDebugEngineListener {
    private static DebugOp instance = null;
    private ResourceBundle res = ResChoose.getLanguage();
    private Figure stopFigure = null;
    List listeners = new Vector();
    Thread clientThread=null;
    
    public DebugOp() {
        super();
            }

    public void addListener(IDebugStateListener debugStateListener) {
        listeners.add(debugStateListener);
    }

    public void removeListener(IDebugStateListener debugStateListener) {
        listeners.remove(debugStateListener);
    }
    protected void fireDebugEntered() {
        for (Iterator iter = listeners.iterator(); iter.hasNext();) {
            IDebugStateListener listener = (IDebugStateListener) iter.next();
            listener.entered();
        }
    }
    protected void fireDebugStarted() {
        for (Iterator iter = listeners.iterator(); iter.hasNext();) {
            IDebugStateListener listener = (IDebugStateListener) iter.next();
            listener.start();
        }
    }
    protected void fireDebugRunning() {
        for (Iterator iter = listeners.iterator(); iter.hasNext();) {
            IDebugStateListener listener = (IDebugStateListener) iter.next();
            listener.running();
        }
    }
    protected void fireDebugPaused() {
        for (Iterator iter = listeners.iterator(); iter.hasNext();) {
            IDebugStateListener listener = (IDebugStateListener) iter.next();
            listener.pause();
        }
    }
    protected void fireDebugTerminated() {
        for (Iterator iter = listeners.iterator(); iter.hasNext();) {
            IDebugStateListener listener = (IDebugStateListener) iter.next();
            listener.terminate();
        }
    }
    protected void fireDebugQuited() {
        for (Iterator iter = listeners.iterator(); iter.hasNext();) {
            IDebugStateListener listener = (IDebugStateListener) iter.next();
            listener.quited();
        }
    }

    public void enterDebug() {
                Layer layer = WorkSpace.getInstance().getActiveProject()
                .getActiveLayer();
        if (layer != null) {
            if (layer instanceof GraphLayer) {
                ((GraphLayer) layer).setInDebug(true);
            }
                        fireDebugEntered();
                        WSWF.addListener(this);
            Print.showMessage(res.getString("DO_InToFlowDebug"),Print.MESSAGE_TYPE_DEBUG);
        }
    }

    public void quitDebug() {
                Layer layer = WorkSpace.getInstance().getActiveProject()
                .getActiveLayer();
        if (layer != null) {
            if (layer instanceof GraphLayer) {
                ((GraphLayer) layer).setInDebug(false);
            }
            stopFigure = null;
            fireDebugQuited();
                        WSWF.removeListener(this);
            Print.showMessage(res.getString("DO_OutFlowDebug"),Print.MESSAGE_TYPE_DEBUG);
        }
    }
    
    public void startDebug() {
                        List files = new Vector();
        Project project = WorkSpace.getInstance().getActiveProject();
        File importDir = new File(project.getImportDirPath());
        File bpelDir = new File(project.getBpelDirPath());
                for (int i = 0; i < importDir.listFiles().length; i++) {
            File file = importDir.listFiles()[i];
            if (file.getName().endsWith(".wsdl")) {
                files.add(file);
            }
        }
                for (int i = 0; i < bpelDir.listFiles().length; i++) {
            File file = bpelDir.listFiles()[i];
            if (file.getName().endsWith("_property.wsdl")
                    || file.getName().endsWith("_ext.wsdl")) {
                files.add(file);
            }
        }
                File debugDir = new File(project.getDebugDirPath());
        if (!debugDir.exists()) {
            debugDir.mkdir();
        }
        else{
                        for (int i = 0; i < debugDir.listFiles().length; i++) {
                File file = debugDir.listFiles()[i];
                file.delete();
            }
        }
                for (Iterator iter = files.iterator(); iter.hasNext();) {
            File file = (File) iter.next();
            FileUtility.copyFile(file.getAbsolutePath(), project
                    .getDebugDirPath()
                    + File.separator + file.getName());
        }
                FileOutputStream f = null;
        try {
            f = new FileOutputStream(project.getDebugDirPath() + File.separator
                    + project.getProcess().getAtNameValue() + ".bpel"); 
            f.write("<?xml version=\"1.0\" encoding=\"gb2312\"?>".getBytes());
            f.write(project.getProcess().getProcess().toXML().getBytes());
            f.close();
        } catch (IOException ex1) {
            ex1.printStackTrace();
        }
        fireDebugStarted();
                WSWF.start(project.getDebugDirPath() + File.separator);
        
        this.clientThread = new Thread() {
            public void run() {
                try {
                                        new clientTest().sendMessage();
                } catch (Exception e) {
                                        e.printStackTrace();
                }
            }
        };
        clientThread.start();
        Print.showMessage(res.getString("DO_StartFlow"),Print.MESSAGE_TYPE_DEBUG);
        
    }
    
    public void resume() {
                if(stopFigure!=null){
            stopFigure.setStopped(false);
            System.out.println(res.getString("DO_InvokeEngine")+this.stopFigure.getServicesSet().getName());
            WSWF.restart(null);
            fireDebugRunning();
        }
    }
    
    public void terminateDebug() {
        if (stopFigure != null) {
            fireDebugTerminated();
                        stopFigure.setStopped(false);
                        WSWF.stop();
            Print.showMessage(res.getString("DO_FlowRunEnd"),Print.MESSAGE_TYPE_DEBUG);
        }
    }

    public void stepInto() {
        if (stopFigure != null) {
            fireDebugRunning();
                        stopFigure.setStopped(false);
            List figureList= getStepIntoFigurelist(stopFigure);
            System.out.println(res.getString("DO_InvokeEngine")+this.stopFigure.getServicesSet().getName());
            if(!figureList.isEmpty()){
                                                for (Iterator iter = figureList.iterator(); iter.hasNext();) {
                    Figure figure = (Figure) iter.next();
                                }
                
                List debugIds = this.getDebugIDFromFigure(figureList);
                                
                WSWF.restart(debugIds);
            }
            else{
                WSWF.restart(null);
            }
            
        }
    }

    public void stepOver() {
        if (stopFigure != null) {
            fireDebugRunning();
                        stopFigure.setStopped(false);
            List figureList= getStepOverFigurelist(stopFigure);
            if(!figureList.isEmpty()){
                List debugIds = this.getDebugIDFromFigure(figureList);
                                WSWF.restart(debugIds);
            }
            else{
                WSWF.restart(null);
            }
           
        }
    }

    public void stepOut() {
        if (stopFigure != null) {
            fireDebugRunning();
                        stopFigure.setStopped(false);
            List figureList= getStepOutFigurelist(stopFigure);
            if(!figureList.isEmpty()){
                List debugIds = this.getDebugIDFromFigure(figureList);
                                WSWF.restart(debugIds);
            }
            else{
                WSWF.restart(null);
            }
            
        }
    }
    private List getDebugIDFromFigure(List figures) {
        List debugIDs = new Vector();
        for (Iterator iter = figures.iterator(); iter.hasNext();) {
            Figure figure = (Figure) iter.next();
            debugIDs.add(figure.getDebugId());
        }
        return debugIDs;
    }
    private List getStepIntoFigurelist(Figure figure) {
        if (figure == null) {
            return null;
        }
        List figures = new Vector();
        if (!(figure instanceof StructFigure)) {
            figures.addAll(this.getStepOverFigurelist(figure));
        } else if (figure instanceof ScopeFigure
                || figure instanceof SequenceFigure
                || figure instanceof PickFigure || figure instanceof FlowFigure) {
            figures.addAll(((StructFigure) figure).getFirstChilds());
        } else if (figure instanceof WhileFigure
                || figure instanceof SwitchFigure) {
            figures.addAll(((StructFigure) figure).getFirstChilds());
            figures.addAll(this.getStepOverFigurelist(figure));
        }
        return figures;
    }
    private List getStepOverFigurelist(Figure figure) {
        if (figure == null) {
            return null;
        }
        List figures = new Vector();
        Figure tempFigure = figure;
        while (tempFigure.getNextExecuteFigure() == null&&tempFigure.getParent()!=null) {
            tempFigure = tempFigure.getParent();
        }
        if(tempFigure.getNextExecuteFigure()!=null){
            figures.add(tempFigure.getNextExecuteFigure());
        }
        return figures;
    }
    private List getStepOutFigurelist(Figure figure) {
        if (figure == null) {
            return null;
        }
        List figures = new Vector();
        if (figure.getParent() != null) {
            figures.addAll(this.getStepOverFigurelist(figure.getParent()));
        }
        return figures;
    }
    
    public static DebugOp getInstance() {
        if (instance == null) {
            instance = new DebugOp();
        }
        return instance;
    }
    
    
    public void stopped(String stoppedId) {
        if (stoppedId != null) {
                        stopFigure = DebugIdToFigure.INSTANCE.lookup(stoppedId);
            if(stopFigure!=null){
                if(Application.isDebug()){
                    System.out.println("stopFigure:"+stopFigure.getServicesSet().getName());
                }
                                stopFigure.setStopped(true);
            }
            else{
                if(Application.isDebug()){
                    System.out.println(res.getString("DO_NoFindMapping"));
                }
                
            }
            fireDebugPaused();
        } else {
            if(Application.isDebug()){
                System.out.println("stopFigure: null");
            }        
            
                        stopFigure = null;
            fireDebugTerminated();
        }
    }
    
    public Figure getStopFigure() {
                return stopFigure;
    }
}
