package org.act.wsc.bpel4wsmodeling.def.process;
import java.util.List;
import java.util.Vector;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IActivityPropertyListener;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IActivityChildListener;
import org.act.wsc.bpel4wsmodeling.utils.CreateDebugId;
import java.util.Iterator;
//<p></p><p></p><p></p><p></p>
public class Activity extends Metaset {
    Attribute name;
    Attribute joinCondition;
    Attribute suppressJoinFailure;
        Attribute debugId;
    Attribute breakPoint;
    Target target;
    Source source;
    protected List propertyListners = new Vector();
    protected List childListeners = new Vector();
    public Activity() {
        this.name = new Attribute("name", "");
        this.joinCondition = new Attribute("joinCondition", "OR");
        this.suppressJoinFailure = new Attribute("suppressJoinFailure", "no");
                this.debugId = new Attribute("debugId",CreateDebugId.getDebugId() );
        this.breakPoint = new Attribute("breakPoint", "false");
        this.target = new Target();
        this.source = new Source();
        this.add(name);
        this.add(joinCondition);
        this.add(suppressJoinFailure);
                this.add(this.debugId);
        this.add(this.breakPoint);
    }
    public void setAtNameValue(String s) {
        this.name.setValue(s);
        this.fireNameUpdated(s);
    }
    public String getAtNameValue() {
        return this.name.getValue();
    }
    public void setAtJoinConditionValue(String s) {
        this.joinCondition.setValue(s);
        this.fireJoinConditionUpdated(s);
    }
    public String getAtJoinConditionValue() {
        return this.joinCondition.getValue();
    }
    public void setAtSuppressJoinFailureValue(String s) {
        this.suppressJoinFailure.setValue(s);
        this.fireSuppressJoinFailureUpdated(s);
    }
    public String getAtsuppressJoinFailureValue() {
        return this.suppressJoinFailure.getValue();
    }
        public void setAtDebugIdValue(String s) {
        this.debugId.setValue(s);
    }
        public String getAtDebugIdValue() {
        return this.debugId.getValue();
    }
        public void setAtBreakPointValue(String s) {
        this.breakPoint.setValue(s);
    }
        public String getAtBreakPointValue() {
        return this.breakPoint.getValue();
    }
        public void setBreakPoint() {
        if (this.getAtBreakPointValue().equals("true")) {
            this.setAtBreakPointValue("false");
        } else if (this.getAtBreakPointValue().equals("false")) {
            this.setAtBreakPointValue("true");
        }
    }
        public boolean isBreakPoint() {
        if (this.getAtBreakPointValue().equals("true")) {
            return true;
        } else {
            return false;
        }
    }
    public void addTarget(Target t) {
        this.add(t);
        t.setFather(this);
        this.fireTargetAdded(t);
    }
    public void deleteTarget(Target t) {
        this.fireTargetDeleted(t);
        this.remove(t);
    }
    public Target getTarget() {
        return this.target;
    }
    public void addSource(Source s) {
        this.add(s);
        s.setFather(this);
        this.fireSourceAdded(s);
    }
    public void deleteSource(Source s) {
        this.fireSourceDeleted(s);
        this.remove(s);
    }
    public Source getSource() {
        return this.source;
    }
    public void addAtt(Attribute att) {
        this.add(att);
    }
    public void deleteAtt(Attribute att) {
        this.remove(att);
    }
    public void addPropertyListeners(IActivityPropertyListener l) {
        if (!this.propertyListners.contains(l)) {
            this.propertyListners.add(l);
        }
    }
    public void addChildListeners(IActivityChildListener l) {
        if (!this.childListeners.contains(l)) {
            this.childListeners.add(l);
        }
    }
    private void fireNameUpdated(String name) {
        for (Iterator iter = this.propertyListners.iterator(); iter.hasNext();) {
            IActivityPropertyListener element = (IActivityPropertyListener) iter
                    .next();
            element.nameUpdate(name);
        }
    }
    private void fireJoinConditionUpdated(String joinCondition) {
        for (Iterator iter = this.propertyListners.iterator(); iter.hasNext();) {
            IActivityPropertyListener element = (IActivityPropertyListener) iter
                    .next();
            element.joinConditionUpdate(joinCondition);
        }
    }
    private void fireSuppressJoinFailureUpdated(String suppressJoinFailure) {
        for (Iterator iter = this.propertyListners.iterator(); iter.hasNext();) {
            IActivityPropertyListener element = (IActivityPropertyListener) iter
                    .next();
            element.suppressJoinFailureUpdate(suppressJoinFailure);
        }
    }
    private void fireTargetAdded(Target t) {
        for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            IActivityChildListener element = (IActivityChildListener) iter
                    .next();
            element.addTarget(t);
        }
    }
    private void fireTargetDeleted(Target t) {
        for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            IActivityChildListener element = (IActivityChildListener) iter
                    .next();
            element.deleteTartget(t);
        }
    }
    private void fireSourceAdded(Source source) {
        for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            IActivityChildListener element = (IActivityChildListener) iter
                    .next();
            element.addSource(source);
            ;
        }
    }
    private void fireSourceDeleted(Source source) {
        for (Iterator iter = this.childListeners.iterator(); iter.hasNext();) {
            IActivityChildListener element = (IActivityChildListener) iter
                    .next();
            element.deleteSource(source);
        }
    }
}
