package org.act.wsc.bpel4wsmodeling.def.process;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;
import java.util.Vector;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IProcessPropertyListener;
import java.util.Iterator;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IProcessChildListener;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
//<p></p><p></p><p></p><p></p>
public class BPELProcess {
  Metaset process;
  Attribute name;
  Attribute targetNamespace;
  Attribute queryLanguage;
  Attribute expressionLanguage;
  Attribute suppressJoinFailure;
  Attribute enableInstanceCompensation;
  Attribute abstractProcess;
  Attribute xmlns;
  Attribute plinkNs;
  Attribute props;
  Partners partners;
  PartnerLinks partnerLinks;
  Variables variables;
  CorrelationSets correlationSets;
  FaultHandlers faultHandlers;
  CompensationHandler compensationHandler;
  EventHandlers eventHandlers;
  private List propertyListners = new Vector();
  private List childListeners = new Vector();
  public BPELProcess() {
    this.process = new Metaset("process");
    this.name = new Attribute("name", "process");     this.targetNamespace = new Attribute("targetNamespace",
                                         "http://your.target.namespace/" +
                                         this.name.getValue());
    this.queryLanguage = new Attribute("queryLanguage",
                                       "http://www.w3.org/TR/1999/REC-xpath-19991116");
    this.expressionLanguage = new Attribute("expressionLanguage",
                                            "http://www.w3.org/TR/1999/REC-xpath-19991116");
    this.suppressJoinFailure = new Attribute("suppressJoinFailure", "no");
    this.enableInstanceCompensation = new Attribute(
        "enableInstanceCompensation", "no");
    this.abstractProcess = new Attribute("abstractProcess", "yes");
    this.xmlns = new Attribute("xmlns",
                               "http://schemas.xmlsoap.org/ws/2003/03/business-process/");
    this.plinkNs = new Attribute("xmlns:tns", "http://your.target.namespace/" +
                                 this.name.getValue());
    this.props = new Attribute("xmlns:props", "http://org.act/properties");
    this.process.add(this.name);
    this.process.add(this.targetNamespace);
    this.process.add(this.xmlns);
    this.process.add(this.queryLanguage);
    this.process.add(this.expressionLanguage);
    this.process.add(this.suppressJoinFailure);
    this.process.add(this.enableInstanceCompensation);
    this.process.add(this.abstractProcess);
    this.process.add(this.plinkNs);
    this.process.add(this.props);
    
        this.renameFiles();
    
  }
  
  public BPELProcess(Metaset proc) {
        Metaset process = createLableByServicesSet(proc);
        allChilds(process, proc);
  }
  
  public void allChilds(Metaset ssProcess, Metaset ssXml) {
    for (int i = 0; i < ssXml.getChilds().size(); i++) {
      Metaset ssTemp = (Metaset) ssXml.getChilds().get(i);
      Metaset ssPro = createLableByServicesSet(ssTemp);
      ssProcess.add(ssPro);
      ssPro.setFather(ssProcess);
      allChilds(ssPro, ssTemp);
    }
  }
  public Metaset createLableByServicesSet(Metaset ss) {
    String name = ss.getName();
    if (name == "process") {
      Metaset process = new Metaset("process");
      this.process = process;
      this.name = new Attribute("name", "process");       this.targetNamespace = new Attribute("targetNamespace",
                                           "http://your.target.namespace/" +
                                           this.name.getValue());
      this.queryLanguage = new Attribute("queryLanguage",
                                         "http://www.w3.org/TR/1999/REC-xpath-19991116");
      this.expressionLanguage = new Attribute("expressionLanguage",
                                              "http://www.w3.org/TR/1999/REC-xpath-19991116");
      this.suppressJoinFailure = new Attribute("suppressJoinFailure", "no");
      this.enableInstanceCompensation = new Attribute(
          "enableInstanceCompensation", "no");
      this.abstractProcess = new Attribute("abstractProcess", "yes");
      this.xmlns = new Attribute("xmlns",
                                 "http://schemas.xmlsoap.org/ws/2003/03/business-process/");
      this.plinkNs = new Attribute("xmlns:tns", "http://your.target.namespace/" +
                                   this.name.getValue());
      this.props = new Attribute("xmlns:props", "http://org.act/properties");
      this.process.add(this.name);
      this.process.add(this.targetNamespace);
      this.process.add(this.xmlns);
      this.process.add(this.queryLanguage);
      this.process.add(this.expressionLanguage);
      this.process.add(this.suppressJoinFailure);
      this.process.add(this.enableInstanceCompensation);
      this.process.add(this.abstractProcess);
      this.process.add(this.plinkNs);
      this.process.add(this.props);
      setAttValueBySS(this.process, ss);
      return process;
    }
    else if (name == "partnerLinks") {
      PartnerLinks plks = new PartnerLinks();
      return plks;
    }
    else if (name == "partnerLink") {
      PartnerLink pl = new PartnerLink();
      setAttValueBySS(pl, ss);
      return pl;
    }
    else if (name == "variables") {
      Variables vars = new Variables();
      return vars;
    }
    else if (name == "variable") {       Variable var = new Variable();
      setAttValueBySS(var, ss);
      return var;
    }else if(name=="transactionSet"){
        TransactionSet tset=new TransactionSet();
        this.setAttValueBySS( tset,ss);
        return tset;
    }else if(name=="transactionSets"){
        TransactionSet tsets=new TransactionSet();
        return tsets;
    }else if(name=="transaction"){
        Transaction t=new Transaction();
        setAttValueBySS(t, ss);
        return t;
    }
    else if (name == "sequence") {
      Sequence sequence = new Sequence();
      setAttValueBySS(sequence, ss);
      return sequence;
    }
    else if (name == "receive") {
      Receive receive = new Receive();
      setAttValueBySS(receive, ss);
      return receive;
    }
    else if (name == "reply") {
      Reply reply = new Reply();
      setAttValueBySS(reply, ss);
      return reply;
    }
    else if (name == "invoke") {
      Invoke invoke = new Invoke();
      setAttValueBySS(invoke, ss);
      return invoke;
    }
    else if (name == "assign") {
      Assign assign = new Assign();
      setAttValueBySS(assign, ss);
      return assign;
    }
    else if (name == "switch") {
      Switch switch1 = new Switch();
      setAttValueBySS(switch1, ss);
      return switch1;
    }
    else if (name == "case") {
      Case case1 = new Case();
      setAttValueBySS(case1, ss);
      return case1;
    }
    else if (name == "otherwise") {
      OtherWise otherwise = new OtherWise();
      return otherwise;
    }
    else if (name == "while") {
      While while1 = new While();
      setAttValueBySS(while1, ss);
      return while1;
    }
    else if (name == "flow") {
      Flow flow = new Flow();
      setAttValueBySS(flow, ss);
      return flow;
    }
    else if (name == "terminate") {
      Terminate terminate = new Terminate();
      setAttValueBySS(terminate, ss);
      return terminate;
    }
    else if (name == "scope") {
      Scope scope = new Scope();
      setAttValueBySS(scope, ss);
      return scope;
    }
    else if (name == "pick") {
      Pick pick = new Pick();
      setAttValueBySS(pick, ss);
      return pick;
    }
    else if (name == "onMessage") {
      OnMessage onMessage = new OnMessage();
      setAttValueBySS(onMessage, ss);
      return onMessage;
    }
    else if (name == "onAlarm") {
      OnAlarm onAlarm = new OnAlarm();
      setAttValueBySS(onAlarm, ss);
      return onAlarm;
    }
    else if (name == "wait") {
      Wait wait = new Wait();
      setAttValueBySS(wait, ss);
      return wait;
    }
    else if (name == "empty") {
      Empty empty = new Empty();
      setAttValueBySS(empty, ss);
      return empty;
    }
    else if (name == "throw") {
      Throw throw1 = new Throw();
      setAttValueBySS(throw1, ss);
      return throw1;
    }
    else if (name == "compensate") {
      Compensate compensate = new Compensate();
      setAttValueBySS(compensate, ss);
      return compensate;
    }
    else if (name == "correlationSets") {
      CorrelationSets corsets = new CorrelationSets();
      return corsets;
    }
    else if (name == "correlationSet") {
      CorrelationSet corset = new CorrelationSet();
      setAttValueBySS(corset, ss);
      return corset;
    }
    else if (name == "faultHandlers") {
      FaultHandlers fls = new FaultHandlers();
      return fls;
    }
    else if (name == "catch") {
      Catch catch1 = new Catch();
      setAttValueBySS(catch1, ss);
      return catch1;
    }
    else if (name == "catchAll") {
      CatchAll catchAll = new CatchAll();
      return catchAll;
    }
    else if (name == "compensationHandler") {
      CompensationHandler comH = new CompensationHandler();
      return comH;
    }
    else if (name == "eventHandlers") {
      EventHandlers eH = new EventHandlers();
      return eH;
    }
    else if (name == "correlations") {
      Correlations cors = new Correlations();
      return cors;
    }
    else if (name == "correlation") {
      Correlation cor = new Correlation();
      setAttValueBySS(cor, ss);
      return cor;
    }
    else if (name == "target") {
      Target target = new Target();
      setAttValueBySS(target, ss);
      return target;
    }
    else if (name == "source") {
      Source source = new Source();
      setAttValueBySS(source, ss);
      return source;
    }
    else if (name == "links") {
      Links links = new Links();
      return links;
    }
    else if (name == "link") {
      Link link = new Link();
      setAttValueBySS(link, ss);
      return link;
    }
    else if (name == "copy") {
      Copy copy = new Copy();
      return copy;
    }
    else if (name == "from") {
      From from = new From();
      setAttValueBySS(from, ss);
      return from;
    }
    else if (name == "to") {
      To to = new To();
      setAttValueBySS(to, ss);
      return to;
    }
    else {
            Metaset ss1 = new Metaset(name);
      setAttValueBySS(ss1, ss);
      return ss1;
    }
  }
  
  public void setAttValueBySS(Metaset ssProcess, Metaset ssXml) {
    for (int i = 0; i < ssXml.getAttributes().size(); i++) {
      Attribute attXml = (Attribute) ssXml.getAttributes().get(i);
      boolean flag = false;
      for (int j = 0; j < ssProcess.getAttributes().size(); j++) {
        Attribute attProcess = (Attribute) ssProcess.getAttributes().get(j);
        if (attXml.getName().equals(attProcess.getName())) {
          attProcess.setValue(attXml.getValue());
          flag = true;
          break;
        }
      }
      if (flag == false) {
        Attribute attNew = attXml;
        ssProcess.add(attNew);
      }
    }
  }
  public void addAttribute(Attribute att) {
    this.process.add(att);
  }
  public void deleteAttribute(Attribute att) {
    this.process.remove(att);
  }
  public void setAtNameValue(String n) {
      String oldName=this.getAtNameValue();
      if(!oldName.equals(n)){
          this.name.setValue(n);
          this.setAtTargetNamespaceValue("http://your.target.namespace/" + n);
          this.renameFiles();
          fireNameUpdated(n);
      }
    
  }
  
private void renameFiles() {
    String root=GetActiveProjectDir.getactiveprodir();
    File dir=new File(root+File.separator+"output"+File.separator+"bpel");
    if(dir.isDirectory()){
        for (int i = 0; i < dir.listFiles().length; i++) {
            File file = dir.listFiles()[i];
            if(file.isFile()){
                if(file.getName().endsWith("_ext.wsdl")){
                    file.renameTo(new File(dir.getAbsolutePath()+File.separator+this.getAtNameValue()+"_ext.wsdl"));
                }
                else if(file.getName().endsWith("_property.wsdl")){
                    file.renameTo(new File(dir.getAbsolutePath()+File.separator+this.getAtNameValue()+"_property.wsdl"));
                }
                else if(file.getName().endsWith(".bpel")){
                    file.renameTo(new File(dir.getAbsolutePath()+File.separator+this.getAtNameValue()+".bpel"));
                }
            }
        }
    }
}
public String getAtNameValue() {
    return this.name.getValue();
  }
  public void setAtTargetNamespaceValue(String v) {
    this.targetNamespace.setValue(v);
      }
  public String getAtTargetNamespaceValue() {
    return this.targetNamespace.getValue();
  }
  public void setAtQueryLanguageValue(String n) {
    this.queryLanguage.setValue(n);
  }
  public String getAtQueryLanguageValue() {
    return this.queryLanguage.getValue();
  }
  public void setAtExpressionLanguageValue(String n) {
    this.expressionLanguage.setValue(n);
  }
  public String getAtExpressionLanguageValue() {
    return this.expressionLanguage.getValue();
  }
  public void setAtSuppressJoinFailureValue(String n) {
    this.suppressJoinFailure.setValue(n);
  }
  public String getAtSuppressJoinFailureValue() {
    return this.suppressJoinFailure.getValue();
  }
  public void setAtEnableInstanceCompensationValue(String n) {
    this.enableInstanceCompensation.setValue(n);
  }
  public String getAtEnableInstanceCompensationValue() {
    return this.enableInstanceCompensation.getValue();
  }
  public void setAtAbstractProcessValue(String n) {
    this.abstractProcess.setValue(n);
  }
  public String getAtAbstractProcessValue() {
    return this.abstractProcess.getValue();
  }
  public void setAtXmlnsValue(String n) {
    this.xmlns.setValue(n);
  }
  public String getAtXmlnsValue() {
    return this.xmlns.getValue();
  }
  public void addPartners(Partners partners) {
    if (this.process.filter(".\\partners") == null) {
      this.process.add(partners);
      partners.setFather(this.process);
    }
  }
  public void deletesPartners() {
    this.process.remove(partners);
  }
  public Metaset getPartners() {
    return this.process.filter(".\\partners");
  }
  public void addPartnerLink(PartnerLink partnerLink) {
    if (this.process.filter(".\\partnerLinks") == null) {
      this.partnerLinks = new PartnerLinks();
      this.process.insert(partnerLinks, 0);       partnerLinks.setFather(this.process);
    }
    else {
      this.partnerLinks = (PartnerLinks)this.getPartnerLinks().car();
    }
    if(this.partnerLinks.addPartnerLink(partnerLink)==true){
    firePartnerLinkAdded(partnerLink);
    }
  }
  public void deletePartnerLink(PartnerLink partnerLink) {
    firePartnerLinkDeleted(partnerLink);
    this.partnerLinks = (PartnerLinks)this.getPartnerLinks().car();
    this.partnerLinks.deletePartnerLink(partnerLink);
    if (this.partnerLinks.getChilds().size() == 0) {
      this.deletePartnerLinks();
    }
  }
  public void addPartnerLinks(PartnerLinks partnerLinks) {
    if (this.process.filter(".\\partnerLinks") == null) {
      this.process.add(partnerLinks);
      partnerLinks.setFather(this.process);
      this.partnerLinks = partnerLinks;
    }
  }
  public void deletePartnerLinks() {
    this.process.remove(partnerLinks);
  }
  public Metaset getPartnerLinks() {
    return this.process.filter(".\\partnerLinks");
  }
  public void addVariable(Variable variable) {
    if (this.process.filter(".\\variables") == null) {
      this.variables = new Variables();
      if (process.filter(".\\partnerLinks") == null) {
        this.process.insert(variables, 0);
        variables.setFather(this.process);
      }
      else {
        int i = this.process.getServicesSetPosition(process.filter(
            ".\\partnerLinks").car());
        this.process.insert(variables, i + 1);
        variables.setFather(this.process);
      }
    }
    else {
      this.variables = (Variables)this.getVariables().car();
    }
    if(this.variables.addVariable(variable)==true){
    fireVariableAdded(variable);
    }
  }
  public void deleteVariable(Variable variable) {
    this.fireVariableDeleted(variable);
    this.variables = (Variables)this.getVariables().car();
    this.variables.deleteVariable(variable);
    if (this.variables.getChilds().size() == 0) {
      this.deleteVariables();
    }
  }
  public void addVariables(Variables variables) {
    if (this.process.filter(".\\variables") == null) {
      this.process.add(variables);
      variables.setFather(this.process);
      this.variables = variables;
    }
  }
  public void deleteVariables() {
    this.process.remove(variables);
  }
  public Metaset getVariables() {
    return this.process.filter(".\\variables");
  }
  public void addCorrelationSets(CorrelationSets correlationSets) {
    if (this.process.filter(".\\correlationSets") == null) {
      this.process.add(correlationSets);
      correlationSets.setFather(this.process);
    }
  }
  public void addCorrelationSet(CorrelationSet correlationSet) {
    if (this.process.filter(".\\correlationSets") == null) {
      this.correlationSets = new CorrelationSets();
      if (process.filter(".\\variables") == null) {
        if (process.filter(".\\partnerLinks") == null) {
          this.process.insert(correlationSets, 0);
          correlationSets.setFather(this.process);
        }
        else {
          int i = this.process.getServicesSetPosition(process.filter(
              ".\\partnerLinks").car());
          this.process.insert(correlationSets, i + 1);
          correlationSets.setFather(this.process);
        }
      }
      else {
        this.process.insert(correlationSets,
                            this.process.getServicesSetPosition(process.filter(
            ".\\variables").car()) + 1);
        correlationSets.setFather(this.process);
      }
    }
    else {
      this.correlationSets = (CorrelationSets)this.getCorrelationSets().car();
    }
    if(this.correlationSets.addCorrelationSet(correlationSet)==true){
    fireCorrelationSetAdded(correlationSet);
    }
  }
  public void deleteCorrelationSet(CorrelationSet correlationSet) {
    fireCorrelationSetDeleted(correlationSet);
    this.correlationSets  = (CorrelationSets)this.getCorrelationSets() .car();
    this.correlationSets .deleteCorrelationSet(correlationSet);
    if (this.correlationSets .getChilds().size() == 0) {
      this.deleteCorrelationSets() ;
    }
  }
  public void deleteCorrelationSets() {
    this.process.remove(correlationSets);
  }
  public Metaset getCorrelationSets() {
    return this.process.filter(".\\correlationSets");
  }
  public void addFaultHandlers(FaultHandlers faultHandlers) {
    if (this.process.filter(".\\faultHandlers") == null) {
      this.process.add(faultHandlers);
      faultHandlers.setFather(this.process);
    }
  }
  public void deleteFaultHandlers() {
    this.process.remove(faultHandlers);
  }
  public Metaset getFaultHandlers() {
    return this.process.filter(".\\faultHandlers");
  }
  public void addCompensationHandler(CompensationHandler compensationHandler) {
    if (this.process.filter(".\\compensationHandler") == null) {
      this.process.add(compensationHandler);
      compensationHandler.setFather(this.process);
    }
  }
  public void deleteCompensationHandler() {
    this.process.remove(compensationHandler);
  }
  public Metaset getCompensationHandler() {
    return this.process.filter(".\\compensationHandler");
  }
  public void addEventHandlers(EventHandlers eventHandlers) {
    if (this.process.filter(".\\eventHandlers") == null) {
      this.process.add(eventHandlers);
      eventHandlers.setFather(this.process);
    }
  }
  public void deleteEventHandlers() {
    this.process.remove(eventHandlers);
  }
  public Metaset getEventHandlers() {
    return this.process.filter(".\\eventHandlers");
  }
  public void addActivity(Activity activity) {
    if (
        (this.process.filter(".\\invoke") == null) &&
        (this.process.filter(".\\receive") == null) &&
        (this.process.filter(".\\reply") == null) &&
        (this.process.filter(".\\assign") == null) &&
        (this.process.filter(".\\wait") == null) &&
        (this.process.filter(".\\throw") == null) &&
        (this.process.filter(".\\scope") == null) &&
        (this.process.filter(".\\sequence") == null) &&
        (this.process.filter(".\\while") == null) &&
        (this.process.filter(".\\switch") == null) &&
        (this.process.filter(".\\flow") == null) &&
        (this.process.filter(".\\pick") == null) &&
        (this.process.filter(".\\empty") == null) &&
        (this.process.filter(".\\compensate") == null) &&
        (this.process.filter(".\\terminate") == null)
        ) {
      this.process.add(activity);
      activity.setFather(this.process);
    }
  }
  public Activity getActivity() {
    if (this.process.filter(".\\invoke") != null) {
      return (Invoke)this.process.filter(".\\invoke").car();
    }
    if (this.process.filter(".\\receive") != null) {
      return (Receive)this.process.filter(".\\receive").car();
    }
    if (this.process.filter(".\\reply") != null) {
      return (Reply)this.process.filter(".\\reply").car();
    }
    if (this.process.filter(".\\assign") != null) {
      return (Assign)this.process.filter(".\\assign").car();
    }
    if (this.process.filter(".\\wait") != null) {
      return (Wait)this.process.filter(".\\wait").car();
    }
    if (this.process.filter(".\\throw") != null) {
      return (Throw)this.process.filter(".\\throw").car();
    }
    if (this.process.filter(".\\scope") != null) {
      return (Scope)this.process.filter(".\\scope").car();
    }
    if (this.process.filter(".\\sequence") != null) {
      return (Sequence)this.process.filter(".\\sequence").car();
    }
    if (this.process.filter(".\\while") != null) {
      return (While)this.process.filter(".\\while").car();
    }
    if (this.process.filter(".\\switch") != null) {
      return (Switch)this.process.filter(".\\switch").car();
    }
    if (this.process.filter(".\\flow") != null) {
      return (Flow)this.process.filter(".\\flow").car();
    }
    if (this.process.filter(".\\pick") != null) {
      return (Pick)this.process.filter(".\\pick").car();
    }
    if (this.process.filter(".\\empty") != null) {
      return (Empty)this.process.filter(".\\empty").car();
    }
    if (this.process.filter(".\\compensate") != null) {
      return (Compensate)this.process.filter(".\\compensate").car();
    }
    if (this.process.filter(".\\terminate") != null) {
      return (Terminate)this.process.filter(".\\terminate").car();
    }
    return null;
  }
  public void deleteactivity(Activity activity) {
    this.process.remove(activity);
  }
  public Metaset getProcess() {
    return this.process;
  }
  public void addPropertyListeners(IProcessPropertyListener l) {
    if (!this.propertyListners.contains(l)) {
      this.propertyListners.add(l);
    }
  }
  public void addChildListeners(IProcessChildListener l) {
    if (!this.childListeners.contains(l)) {
      this.childListeners.add(l);
    }
  }
  private void fireNameUpdated(String name) {
    for (Iterator iter = this.propertyListners.iterator(); iter.hasNext(); ) {
      IProcessPropertyListener element = (IProcessPropertyListener) iter.next();
      element.nameUpdate(name);
    }
  }
  private void fireVariableAdded(Variable var) {
    for (Iterator iter = this.childListeners.iterator(); iter.hasNext(); ) {
      IProcessChildListener element = (IProcessChildListener) iter.next();
      element.addVariable(var);
    }
  }
  private void fireVariableDeleted(Variable var) {
    for (Iterator iter = this.childListeners.iterator(); iter.hasNext(); ) {
      IProcessChildListener element = (IProcessChildListener) iter.next();
      element.deleteVariable(var);
    }
  }
  private void firePartnerLinkAdded(PartnerLink plink) {
    for (Iterator iter = this.childListeners.iterator(); iter.hasNext(); ) {
      IProcessChildListener element = (IProcessChildListener) iter.
          next();
      element.addPartnerLink(plink);
    }
  }
  private void firePartnerLinkDeleted(PartnerLink plink) {
    for (Iterator iter = this.childListeners.iterator(); iter.hasNext(); ) {
      IProcessChildListener element = (IProcessChildListener) iter.
          next();
      element.deletePartnerLink(plink);
    }
  }
  private void fireCorrelationSetAdded(CorrelationSet c) {
    for (Iterator iter = this.childListeners.iterator(); iter.hasNext(); ) {
      IProcessChildListener element = (IProcessChildListener) iter.next();
      element.addCorrelationSet(c);
    }
  }
  private void fireCorrelationSetDeleted(CorrelationSet c) {
    for (Iterator iter = this.childListeners.iterator(); iter.hasNext(); ) {
      IProcessChildListener element = (IProcessChildListener) iter.next();
      element.deleteCorrelationSet(c);
    }
  }
  public void write() {
    FileOutputStream f = null;
    try {
      f = new FileOutputStream(GetActiveProjectDir.getactiveprodir() +
                               File.separator + "output" + File.separator +
                               "bpel" + File.separator + this.getAtNameValue() + ".bpel");       f.write("<?xml version=\"1.0\" encoding=\"gb2312\"?>".getBytes());
      f.write(this.process.toXMLModel().getBytes());
      f.close();
    }
    catch (IOException ex1) {
    }
  }
  
  
}
