
package org.act.wsc.bpel4wsmodeling.def.property;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.def.MetaSetExNS;
import org.act.wsc.bpel4wsmodeling.def.resource.AttributeText;
import org.act.wsc.bpel4wsmodeling.def.resource.LabelText;
import org.act.wsc.bpel4wsmodeling.def.resource.NamespaceText;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;

public class PropertyWsdl extends MetaSetExNS {
    
    Attribute targetNamespace; 
    Attribute xmlns;
    Attribute bpwsNs;
    
    public PropertyWsdl() {
        super(LabelText.DEFINITION);
        this.setTargetNamespace(NamespaceText.PROPERTY);
        this.addNamespace(AttributeText.XMLNS,NamespaceText.XMLNS_WSDL);
        this.addNamespace(AttributeText.BPWS_NS,NamespaceText.BPWS);
    }
    
    public PropertyWsdl(String path){
        try {
            Metaset metaset=Metaset.create(path);
            
        } catch (Exception e) {
                        e.printStackTrace();
        }
    }
    
    public PropertyWsdl(Metaset metaset){
        
    }
    
    private void init(Metaset metaset){
        
    }
    
    public void addProperty(Property property){
        this.add(property);
        property.setFather(this);
    }
    public void removeProperty(Property property){
        this.remove(property);
    }
    public Property getProperty(String name){
        return (Property)this.filter(LabelText.PROPERTY,AttributeText.PROPERTY_NAME,name);
    }
    public void addPropertyAlias(PropertyAlias propertyAlias){
        this.add(propertyAlias);
        propertyAlias.setFather(this);
    }
    public void removeProperty(PropertyAlias propertyAlias){
        this.remove(propertyAlias);
    }
    
    public void addNamespace(String prefix,String ns){
        this.add(new Attribute(prefix,ns));
    }
    public void removeNamespace(String prefix){
        for (Iterator iter = this.getAttributes().iterator(); iter.hasNext();) {
            Attribute attribute = (Attribute) iter.next();
            if(attribute.getName().equals(prefix)){
                this.remove(attribute);
                break;
            }
        }
    }
    public void write() {
        FileOutputStream f = null;
        try {
          f = new FileOutputStream(GetActiveProjectDir.getactiveprodir() +
                                   File.separator + "output" + File.separator +
                                   "bpel" + File.separator );           f.write("<?xml version=\"1.0\" encoding=\"gb2312\"?>".getBytes());
          f.write(this.toXMLModel().getBytes());
          f.close();
        }
        catch (IOException ex1) {
        }
      }
}
