package org.act.wsc.bpel4wsmodeling.projectdata;
import java.io.File;
import java.util.ResourceBundle;
import javax.wsdl.Definition;
import javax.wsdl.PortType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.ExtWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PartnerLinkType;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Role;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistryEntry;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ExtWsdlReader {
    Project project;
    
    private ResourceBundle res = ResChoose.getLanguage();
    public ExtWsdlReader(Project pro) {
        this.project = pro;
    }

    public void readExtWsdl(String extWsdlFile) {
        ExtWsdl extWsdl = new ExtWsdl();
        Definition extWsdlDefinition = extWsdl.getExtWsdl();
        this.project.setExtWsdl(extWsdl);
                File fileProject = new java.io.File(extWsdlFile);
                DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        Document docExtWsdl = null;
        try {
                        db = dbf.newDocumentBuilder();
                        docExtWsdl = db.parse(fileProject);
        } catch (Exception e) {
            e.printStackTrace();
        }
                Element rootElement = (Element) docExtWsdl.getFirstChild();                 for (int i = 0; i < rootElement.getAttributes().getLength(); i++) {
            Node node = rootElement.getAttributes().item(i);
            if (node.getNodeName().startsWith("xmlns:")) {
                extWsdlDefinition.addNamespace(node.getNodeName().substring(
                        node.getNodeName().indexOf(":") + 1,
                        node.getNodeName().length()), node.getNodeValue());
            } else if (node.getNodeName().equals("targetNamespace")) {
                extWsdlDefinition.setTargetNamespace(node.getNodeValue());
            } else {
                Print.showMessage(res.getString("EWR_ErrorWSDL"),Print.MESSAGE_TYPE_WARNING);
            }
        }
                NodeList importList = rootElement.getElementsByTagName("import");
        for (int i = 0; i < importList.getLength(); i++) {
            Element importEle = (Element) importList.item(i);
            javax.wsdl.Import thisImport = extWsdlDefinition.createImport();
            thisImport.setLocationURI(importEle.getAttribute("location"));
            thisImport.setNamespaceURI(importEle.getAttribute("namespace"));
            extWsdlDefinition.addImport(thisImport);
        }
                NodeList partnerLinkTypeList = rootElement
                .getElementsByTagName("plnk:partnerLinkType");
                                for (int j = 0; j < partnerLinkTypeList.getLength(); j++) {
            Element plinkTypeEle = (Element) partnerLinkTypeList.item(j);
            String plinkTypeName = plinkTypeEle.getAttribute("name");
            PartnerLinkType plinkType = new PartnerLinkType();
            plinkType.setName(plinkTypeName);
            for (int i = 0; i < plinkTypeEle.getElementsByTagName("plnk:role")
                    .getLength(); i++) {
                Element roleEle = (Element) plinkTypeEle.getElementsByTagName(
                        "plnk:role").item(i);                 String roleName = roleEle.getAttribute("name");
                Role role = null;
                if (this.project.getRoleByName(roleName) == null) {
                    role = new Role();
                    role.setName(roleName);
                    Element portTypeEle = (Element) roleEle
                            .getElementsByTagName("plnk:portType").item(0);
                                        String portTypeName = portTypeEle.getAttribute("name");
                                        String nsPrefix;
                    String ns;
                    String na;
                    nsPrefix = portTypeName.substring(0, portTypeName
                            .indexOf(":"));
                    if (nsPrefix.equals("null")) {
                        ns = "";
                    } else {
                        ns = extWsdlDefinition.getNamespace(nsPrefix);
                    }
                                        na = portTypeName.substring(portTypeName.indexOf(":") + 1,
                            portTypeName.length());
                                        if (this.project.getWSDLRegistry().findPortType(ns, na) != null) {
                        WSDLRegistryEntry wre = this.project.getWSDLRegistry()
                                .findPortType(ns, na);
                                                                        PortType pt = (PortType) wre.userObject;
                        role.setPortType(pt);
                        this.project.addRole(role);
                        if(i==0){
                            plinkType.addPartnerRole(role);
                        }
                        else if(i==1){
                            plinkType.addMyRole(role);
                        }
                    }
                                                                            } else {
                 }
            }
            this.project.addPlinkType(plinkType,false);
            javax.wsdl.extensions.UnknownExtensibilityElement uee = new javax.wsdl.extensions.UnknownExtensibilityElement();
            org.w3c.dom.Element userElement = getElementByPartnerLinkTypeImpl(
                    plinkType, extWsdlDefinition);
            uee.setElement(userElement);
            extWsdlDefinition.addExtensibilityElement(uee);
        }
            }
    private org.w3c.dom.Element getElementByPartnerLinkTypeImpl(
            PartnerLinkType plt, Definition wsdlExt) {
        org.w3c.dom.Element eleResult = null;
        javax.xml.parsers.DocumentBuilderFactory dbf = javax.xml.parsers.DocumentBuilderFactory
                .newInstance();
        try {
            javax.xml.parsers.DocumentBuilder db = dbf.newDocumentBuilder();
            org.w3c.dom.Document doc = db.newDocument();
                        String nsUri = plt.getElementType().getNamespaceURI();
            eleResult = doc.createElement("plnk:partnerLinkType");
            eleResult.setAttribute("name", plt.getName());
                                                org.w3c.dom.Element elePRole = null;
            org.w3c.dom.Element eleMyRole = null;
                        if (plt.getPartnerRole() != null) {
                Role pRole = plt.getPartnerRole();
                elePRole = doc.createElement("plnk:role");
                elePRole.setAttribute("name", pRole.getName());
                                                eleResult.appendChild(elePRole);
                org.w3c.dom.Element elePPt = doc.createElement("plnk:portType");
                                                String strPrefix = wsdlExt.getPrefix(pRole.getPortType()
                        .getQName().getNamespaceURI());
                elePPt.setAttribute("name", strPrefix + ":"
                        + pRole.getPortType().getQName().getLocalPart());
                                                                elePRole.appendChild(elePPt);
            }
                        if (plt.getMyRole() != null) {
                Role myRole = plt.getMyRole();
                eleMyRole = doc.createElement("plnk:role");
                eleMyRole.setAttribute("name", myRole.getName());
                                                eleResult.appendChild(eleMyRole);
                org.w3c.dom.Element eleMyPt = doc
                        .createElement("plnk:portType");
                                                String strPrefix1 = wsdlExt.getPrefix(myRole.getPortType()
                        .getQName().getNamespaceURI());
                eleMyPt.setAttribute("name", strPrefix1 + ":"
                        + myRole.getPortType().getQName().getLocalPart());
                                                                eleMyRole.appendChild(eleMyPt);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return eleResult;
    }
}
