package org.act.wsc.bpel4wsmodeling.projectdata;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.def.process.Assign;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.def.process.Case;
import org.act.wsc.bpel4wsmodeling.def.process.Compensate;
import org.act.wsc.bpel4wsmodeling.def.process.Empty;
import org.act.wsc.bpel4wsmodeling.def.process.Flow;
import org.act.wsc.bpel4wsmodeling.def.process.Invoke;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.OtherWise;
import org.act.wsc.bpel4wsmodeling.def.process.Pick;
import org.act.wsc.bpel4wsmodeling.def.process.Receive;
import org.act.wsc.bpel4wsmodeling.def.process.Reply;
import org.act.wsc.bpel4wsmodeling.def.process.Scope;
import org.act.wsc.bpel4wsmodeling.def.process.Sequence;
import org.act.wsc.bpel4wsmodeling.def.process.Switch;
import org.act.wsc.bpel4wsmodeling.def.process.Terminate;
import org.act.wsc.bpel4wsmodeling.def.process.Throw;
import org.act.wsc.bpel4wsmodeling.def.process.Transaction;
import org.act.wsc.bpel4wsmodeling.def.process.Wait;
import org.act.wsc.bpel4wsmodeling.def.process.While;
import org.act.wsc.bpel4wsmodeling.projectdata.process.CaseFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.FlowFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.MetaFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.OnAlarmFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.OnMessageFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.OtherwiseFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.PickFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.ScopeFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.SequenceFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.SwitchFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.WhileFigure;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class ProcessReader {
	
	private static ResourceBundle res = ResChoose.getLanguage();
	  
  public ProcessReader(String path, Project project) {
    try {
            Metaset processSS = Metaset.create(path);
      BPELProcess bpelProcess = new BPELProcess(processSS);
      project.setProcess(bpelProcess);
    }
    catch (Exception ex) {
        Print.showMessage(res.getString("PR_ErrorInBPELFile"),Print.MESSAGE_TYPE_FATAL_ERROR);
    }
  }
  
  
  public static Figure createFigureByServicesSet(Metaset ss) {
    if (ss instanceof Invoke || ss instanceof Receive || ss instanceof Reply ||
        ss instanceof Assign || ss instanceof Empty || ss instanceof Terminate ||
        ss instanceof Throw || ss instanceof Wait || ss instanceof Compensate||ss instanceof Transaction ) {
      MetaFigure mf = new MetaFigure(ss);
      return mf;
    }
    else if (ss instanceof Sequence) {       List figures = new Vector();
      for (int i = 0; i < ss.getChilds().size(); i++) {
        Metaset st = (Metaset) ss.getChilds().get(i);
        Figure f = createFigureByServicesSet(st);
        figures.add(f);
      }
      SequenceFigure sf = new SequenceFigure(ss, figures);
      return sf;
    }
    else if (ss instanceof Scope) {
      List figures = new Vector();
      Scope sp = (Scope) ss;
      if (sp.getActivity() != null) {
        Activity act = sp.getActivity();
        Figure f = createFigureByServicesSet(act);
        figures.add(f);
      }
      ScopeFigure spf = new ScopeFigure(sp, figures);
      return spf;
    }
    else if (ss instanceof While) {
      List figures = new Vector();
      While wh = (While) ss;
      if (wh.getActivity() != null) {
        Activity act = wh.getActivity();
        Figure f = createFigureByServicesSet(act);
        figures.add(f);
      }
      WhileFigure wf = new WhileFigure(wh, figures);
      return wf;
    }
    else if (ss instanceof Pick) {
      List figures = new Vector();
      Pick pick = (Pick) ss;
      List onMessages = new Vector();
      List onAlarms = new Vector();
      if (pick.getOnMessages().getChilds() != null) {
        for (int i = 0; i < pick.getOnMessages().getChilds().size(); i++) {
          OnMessage onMessage = (OnMessage) pick.getOnMessages().getChilds().
              get(i);
          Figure f = createFigureByServicesSet(onMessage);
          figures.add(f);
          onMessages.add(f);
        }
      }
      if (pick.getOnAlarms().getChilds() != null) {
        for (int j = 0; j < pick.getOnAlarms().getChilds().size(); j++) {
          OnAlarm onAlarm = (OnAlarm) pick.getOnAlarms().getChilds().get(j);
          Figure f = createFigureByServicesSet(onAlarm);
          figures.add(f);
          onAlarms.add(f);
        }
      }
      PickFigure pf = new PickFigure(pick, figures, onMessages, onAlarms);
      return pf;
    }
    else if (ss instanceof Switch) {
      List figures = new Vector();
      Switch swt = (Switch) ss;
      List cases = new Vector();
      List otherwises = new Vector();
      if (swt.getCases().getChilds() != null) {
        for (int i = 0; i < swt.getCases().getChilds().size(); i++) {
          Case caseclause = (Case) swt.getCases().getChilds().get(i);
          Figure f = createFigureByServicesSet(caseclause);
          figures.add(f);
          cases.add(f);
        }
      }
      if (swt.getOtherWise() != null) {
        OtherWise otherwise = swt.getOtherWise();
        Figure f = createFigureByServicesSet(otherwise);
        figures.add(f);
        otherwises.add(f);
      }
      SwitchFigure swf = new SwitchFigure(swt, figures, cases, otherwises);
      return swf;
    }
    else if (ss instanceof Flow) {
      List figures = new Vector();
      Flow flow = (Flow) ss;
      if (flow.getActivities().size() > 0) {
        for (int i = 0; i < flow.getActivities().size(); i++) {
          Activity act = (Activity) flow.getActivities().get(i);
          Figure f = createFigureByServicesSet(act);
          figures.add(f);
        }
      }
      FlowFigure ff = new FlowFigure(ss, figures);
      return ff;
    }
    else if (ss instanceof Case) {
      List figures = new Vector();
      Case caseClause = (Case) ss;
      if (caseClause.getActivity() != null) {
        Activity act = caseClause.getActivity();
        Figure f = createFigureByServicesSet(act);
        figures.add(f);
      }
      CaseFigure cf = new CaseFigure(caseClause, figures);
      return cf;
    }
    else if (ss instanceof OtherWise) {
      List figures = new Vector();
      OtherWise otherwise = (OtherWise) ss;
      if (otherwise.getActivity() != null) {
        Activity act = otherwise.getActivity();
        Figure f = createFigureByServicesSet(act);
        figures.add(f);
      }
      OtherwiseFigure of = new OtherwiseFigure(otherwise, figures);
      return of;
    }
    else if (ss instanceof OnAlarm) {
      List figures = new Vector();
      OnAlarm onAlarm = (OnAlarm) ss;
      if (onAlarm.getActivity() != null) {
        Activity act = onAlarm.getActivity();
        Figure f = createFigureByServicesSet(act);
        figures.add(f);
      }
      OnAlarmFigure oaf = new OnAlarmFigure(onAlarm, figures);
      return oaf;
    }
    else if (ss instanceof OnMessage) {
      List figures = new Vector();
      OnMessage onMessage = (OnMessage) ss;
      if (onMessage.getActivity() != null) {
        Activity act = onMessage.getActivity();
        Figure f = createFigureByServicesSet(act);
        figures.add(f);
      }
      OnMessageFigure omf = new OnMessageFigure(onMessage, figures);
      return omf;
    }
    else {
      Print.showMessage(res.getString("PR_NoStandardLabelName"),Print.MESSAGE_TYPE_WARNING);
      return null;
    }
  }
}
