
package org.act.wsc.bpel4wsmodeling.projectdata;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.wsdl.Definition;
import javax.wsdl.Import;
import javax.wsdl.Message;
import javax.wsdl.WSDLException;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.wsdl.extensions.UnknownExtensibilityElement;
import javax.wsdl.factory.WSDLFactory;
import javax.wsdl.xml.WSDLReader;
import javax.wsdl.xml.WSDLWriter;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.act.metaset.utils.MetasetUtil;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IProjectChildListener;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.ILayerListener;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.GraphLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Layer;
import org.act.wsc.bpel4wsmodeling.projectdata.process.StructFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.ExtWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PartnerLinkType;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Property;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyAlias;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Role;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.ImportedWSDL;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistry;
import org.act.wsc.bpel4wsmodeling.utils.FileUtility;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.utils.XMLUtils;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class Project {
	
	private ResourceBundle res = ResChoose.getLanguage();
    String name = null;
        String path = null;
    String description = null;
    List layers = new Vector();
    Layer activeLayer = null;
    List listeners = new Vector();     List propertyListeners = new Vector();
    public Map imports = new HashMap();
    private Document docment = null;
        public WSDLRegistry wsdlRegistry = new WSDLRegistry(this);
    BPELProcess process = null;
    ExtWsdl wsdlExtClass;
    public Definition wsdlExt = null;
        public List plinkTypes = new Vector();
    public List roles = new Vector();
    public List properties = new Vector();
    public List propertyAliases = new Vector();
    PropertyWsdl propertyWsdl;
    Definition wsdlProperty;
    ElementWriter eleWriter;
    ElementReader elementReader;
    
    protected Project() {
        super();
    }
    
    protected Project(String name) {
        super();
        this.name = name;
    }
        protected Project(String name, String description, String path) {
        super();
        this.name = name;
        this.description = description;
        this.path = path;
    }
    
    public void setProjectName(String name) {
        this.name = name;
    }
    
    public String getProjectName() {
        return this.name;
    }
    
    public void setProjectPath(String path) {
        this.path = path;
    }
    
    public String getProjectPath() {
        return this.path;
    }
    
    public String getImportDirPath() {
        return this.path + File.separator + "imports";
    }
    
    public String getBpelDirPath() {
        return this.path + File.separator + "output" + File.separator + "bpel";
    }
    
    public String getDebugDirPath() {
        return this.path + File.separator + "debug";
    }
    
    public void setProjectDes(String description) {
        this.description = description;
    }
    
    public String getProjectDes() {
        return this.description;
    }
    
    public WSDLLayer createWSDLLayer() {
        WSDLLayer layer = new WSDLLayer(new DefinitionEx());
        this.layers.add(layer);
        this.fireLayerCreated(layer);
        return layer;
    }
    
    public WSDLLayer createWSDLLayer(DefinitionEx definitionEx) {
        WSDLLayer layer = new WSDLLayer(definitionEx);
        this.layers.add(layer);
        this.fireLayerCreated(layer);
        return layer;
    }
    
    public GraphLayer createGraphLayer() {
        GraphLayer graphLayer = null;
        if (this.process == null) {
            graphLayer = new GraphLayer();
        } else {
            graphLayer = new GraphLayer(this.process);
        }
        this.setProcess(graphLayer.getBPELProcess());                         this.layers.add(graphLayer);
        this.fireLayerCreated(graphLayer);
        if (graphLayer.getFigureProcess() != null) {
            Figure figure = graphLayer.getFigureProcess();
            graphLayer.setMainFigure(figure, true);
            if (graphLayer.getMainFigure() instanceof StructFigure) {
                StructFigure sf = (StructFigure) graphLayer.getMainFigure();
                sf.setLayout();
                sf.fireFigureLayoutUpated();
            }
        }
        return graphLayer;
    }
    
    public void openLayer(Layer layer) {
        this.fireLayerOpened(layer);
    }
    
    public void closeLayer(Layer layer) {
        this.fireLayerClosed(layer);
    }
                    private void fireLayerCreated(Layer layer) {
        this.activeLayer = layer;
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((ILayerListener) iter.next()).layerCreated(layer);
        }
    }
    private void fireLayerOpened(Layer layer) {
        this.activeLayer = layer;
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((ILayerListener) iter.next()).layerOpened(layer);
        }
    }
    private void fireLayerClosed(Layer layer) {
        this.activeLayer = null;
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((ILayerListener) iter.next()).layerClosed(layer);
        }
    }
    private void fireLayerRemoved(Layer layer) {
        this.activeLayer = null;
        for (Iterator iter = this.listeners.iterator(); iter.hasNext();) {
            ((ILayerListener) iter.next()).layerRemoved(layer);
        }
    }
    private void fireRoleAdded(Role role) {
        for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            ((IProjectChildListener) iter.next()).addRole(role);
        }
    }
    private void fireRoleDeleted(Role role) {
        for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            ((IProjectChildListener) iter.next()).deleteRole(role);
        }
    }
    private void firePartnerLinkTypeAdded(PartnerLinkType partnerLinkType) {
        for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            ((IProjectChildListener) iter.next())
                    .addPartnerLinkType(partnerLinkType);
        }
    }
    private void firePartnerLinkTypeDeleted(PartnerLinkType partnerLinkType) {
        for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            ((IProjectChildListener) iter.next())
                    .deletePartnerLinkType(partnerLinkType);
        }
    }
    private void firePropertyAdded(Property property) {
        for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            ((IProjectChildListener) iter.next()).addProperty(property);
        }
    }
    private void firePropertyDeleted(Property property) {
        for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            ((IProjectChildListener) iter.next()).deleteProperty(property);
        }
    }
    private void firePropertyAliasAdded(PropertyAlias propertyAlias) {
        for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            ((IProjectChildListener) iter.next())
                    .addPropertyAlias(propertyAlias);
        }
    }
    private void firePropertyAliasDeleted(PropertyAlias propertyAlias) {
        for (Iterator iter = this.propertyListeners.iterator(); iter.hasNext();) {
            ((IProjectChildListener) iter.next())
                    .deletePropertyAlias(propertyAlias);
        }
    }
    
    public void addListener(ILayerListener l) {
        if (!this.listeners.contains(l)) {
            this.listeners.add(l);
        }
    }
    
    public void removeListener(ILayerListener l) {
        if (this.listeners.contains(l)) {
            this.listeners.remove(l);
        }
    }
    
    public void addPropertyListener(IProjectChildListener l) {
        if (!this.propertyListeners.contains(l)) {
            this.propertyListeners.add(l);
        }
    }
    
    public void removePropertyListener(IProjectChildListener l) {
        if (this.propertyListeners.contains(l)) {
            this.propertyListeners.remove(l);
        }
    }
    
    public File newUserDefWSDL(DefinitionEx def) {
                String fileName = null;
        fileName = "userDefined";                String WSDLRelativePath = java.io.File.separator + "imports"
                + java.io.File.separator + fileName + ".wsdl";
        ImportedWSDL udWsdl = new ImportedWSDL();
        udWsdl.wsdlLocation = res.getString("Pro_UDWSDLFile");
        udWsdl.wsdlRetrieveMode = ImportedWSDL.MOD_USERDEF;
        udWsdl.wsdlReplicaUrl = WSDLRelativePath;
        imports.put(WSDLRelativePath, udWsdl);
        udWsdl.wsdlTargetNamespace = def.getTargetNamespace();
                if (this.wsdlExtClass == null) {
            this.wsdlExtClass = new ExtWsdl();
            setExtWsdl(this.wsdlExtClass);
            this.wsdlExt = this.wsdlExtClass.getExtWsdl();
            wsdlExt.addNamespace("plnk",
                    "http://schemas.xmlsoap.org/ws/2003/05/partner-link/");
        } else {
            this.wsdlExt = this.wsdlExtClass.getExtWsdl();
        }
                if (this.propertyWsdl == null) {
            this.propertyWsdl = new PropertyWsdl();
            this.setPropertyWsdl(this.propertyWsdl);
            this.wsdlProperty = this.propertyWsdl.getPropertyWsdl();
            this.wsdlProperty.setTargetNamespace("http://org.act/properties");             this.wsdlProperty.addNamespace("bpws",
                    "http://schemas.xmlsoap.org/ws/2003/03/business-process/");
        } else {
            this.wsdlProperty = this.propertyWsdl.getPropertyWsdl();
        }
                Iterator importedWSDLIterator = this.imports.values().iterator();
        while (importedWSDLIterator.hasNext()) {
            ImportedWSDL thisImportedWSDL = (ImportedWSDL) importedWSDLIterator
                    .next();
            java.io.File thiswsdlFile = new java.io.File(
                    thisImportedWSDL.wsdlReplicaUrl);
            boolean f = false;
            Iterator wsdlExtIterator = wsdlExt.getImports().values().iterator();
            while (wsdlExtIterator.hasNext()) {
                java.util.Vector v = (java.util.Vector) wsdlExtIterator.next();
                for (int i = 0; i < v.size(); i++) {
                    Import importWsdl = (Import) v.get(i);
                    if (thiswsdlFile.getName().equals(
                            importWsdl.getLocationURI())
                            && thisImportedWSDL.wsdlTargetNamespace
                                    .equals(importWsdl.getNamespaceURI())) {
                        f = true;
                        break;
                    }
                }
                if (f == true) {
                    break;
                }
            }
            if (f == false) {
                javax.wsdl.Import thisImport = wsdlExt.createImport();
                thisImport.setLocationURI(thiswsdlFile.getName());
                thisImport
                        .setNamespaceURI(thisImportedWSDL.wsdlTargetNamespace);
                wsdlExt.addImport(thisImport);
                                if (wsdlExt.getPrefix(thisImportedWSDL.wsdlTargetNamespace) == null) {
                    wsdlExt.addNamespace(Project.getCandidateName(wsdlExt
                            .getNamespaces(), "ns"),
                            thisImportedWSDL.wsdlTargetNamespace);
                }
            }
                        if (this.wsdlProperty
                    .getPrefix(thisImportedWSDL.wsdlTargetNamespace) == null) {
                this.wsdlProperty.addNamespace(Project.getCandidateName(
                        this.wsdlProperty.getNamespaces(), "ns"),
                        thisImportedWSDL.wsdlTargetNamespace);
            }
            
                        if (this.getProcess() != null) {
                if (MetasetUtil.getPrefix(this.getProcess().getProcess(),
                        thisImportedWSDL.wsdlTargetNamespace) == null) {
                    MetasetUtil.addNameSpace(this.getProcess().getProcess(),
                            Project.getCandidateName(MetasetUtil
                                    .getNameSpaces(this.getProcess()
                                            .getProcess()), "ns"),
                            thisImportedWSDL.wsdlTargetNamespace);
                }
            }
        }
                this.wsdlRegistry.registeWSDL(WSDLRelativePath, def);
        return new File(GetActiveProjectDir.getactiveprodir()
                + WSDLRelativePath);
    }
    
    public boolean importWSDL(String importType, String wsdlFile) {
                try {
                        String activeProDir = GetActiveProjectDir.getactiveprodir();
                        int beginIndex = 0;            if (wsdlFile.lastIndexOf(File.separator) != -1) {
                beginIndex = wsdlFile.lastIndexOf(File.separator) + 1;
            } else if (wsdlFile.lastIndexOf('/') != -1) {
                beginIndex = wsdlFile.lastIndexOf('/') + 1;
            }
                        String fileName = wsdlFile.substring(beginIndex, wsdlFile
                    .lastIndexOf(".wsdl"));
                        String replicaWSDLFile = java.io.File.separator + "imports"
                    + java.io.File.separator + fileName + ".wsdl";
            String wsdlFullPath = activeProDir + replicaWSDLFile;
                        if ((new java.io.File(wsdlFullPath)).exists()) {
                Print
                        .showMessage(res.getString("Pro_WSDLInError_Exist"),
                                Print.MESSAGE_TYPE_ERROR);
                JOptionPane.showConfirmDialog(MainFrame.getmainFrame(),
                		res.getString("Pro_SameServiceExist"), res.getString("Pro_Warning"), JOptionPane.WARNING_MESSAGE);
                return false;
            }
                                    if (importType.equals("local")) {
                                FileUtility.copyFile(wsdlFile, wsdlFullPath);
            }
            if (importType.equals("uddi")) {
                                                                                WSDLFactory wsdlfactory = javax.wsdl.factory.WSDLFactory
                        .newInstance();
                WSDLReader wsdlreader = wsdlfactory.newWSDLReader();
                Definition p = wsdlreader.readWSDL(wsdlFile);                                 FileOutputStream fos = new FileOutputStream(wsdlFullPath);
                (wsdlfactory.newWSDLWriter()).writeWSDL(p, fos);
                fos.close();
            }
                        ImportedWSDL wsdl = new ImportedWSDL();
            wsdl.wsdlLocation = wsdlFile;
            wsdl.wsdlReplicaUrl = replicaWSDLFile;
            wsdl.wsdlRetrieveMode = importType;             imports.put(wsdl.wsdlReplicaUrl, wsdl);
            Definition def = this.getWSDLDefinition(replicaWSDLFile);             wsdl.wsdlTargetNamespace = def.getTargetNamespace();
                        if (this.wsdlExtClass == null) {
                this.wsdlExtClass = new ExtWsdl();
                setExtWsdl(this.wsdlExtClass);
                this.wsdlExt = this.wsdlExtClass.getExtWsdl();
                wsdlExt.addNamespace("plnk",
                        "http://schemas.xmlsoap.org/ws/2003/05/partner-link/");
            } else {
                this.wsdlExt = this.wsdlExtClass.getExtWsdl();
            }
                                                                                                                                                                        
            Iterator importedWSDLIterator = this.imports.values().iterator();
            while (importedWSDLIterator.hasNext()) {
                ImportedWSDL thisImportedWSDL = (ImportedWSDL) importedWSDLIterator
                        .next();
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                if (wsdlExt.getPrefix(thisImportedWSDL.wsdlTargetNamespace) == null) {
                    wsdlExt.addNamespace(Project.getCandidateName(wsdlExt
                            .getNamespaces(), "ns"),
                            thisImportedWSDL.wsdlTargetNamespace);
                }
                                if (this.getProcess() != null) {
                    if (MetasetUtil.getPrefix(this.getProcess().getProcess(),
                            thisImportedWSDL.wsdlTargetNamespace) == null) {
                        MetasetUtil.addNameSpace(
                                this.getProcess().getProcess(), Project
                                        .getCandidateName(MetasetUtil
                                                .getNameSpaces(this
                                                        .getProcess()
                                                        .getProcess()), "ns"),
                                thisImportedWSDL.wsdlTargetNamespace);
                    }
                }
            }
                        this.wsdlRegistry.registeWSDL(replicaWSDLFile, def);
            return true;
        } catch (Exception e) {
            Print.showMessage(res.getString("WSDLʧ"), Print.MESSAGE_TYPE_FATAL_ERROR);
        }
        return false;
    }
    
    public Definition getWSDLDefinition(String wsdlFile) {
        Definition p = null;
        try {
            WSDLFactory wsdlfactory = javax.wsdl.factory.WSDLFactory
                    .newInstance();
            WSDLReader wsdlreader = wsdlfactory.newWSDLReader();
            if (wsdlFile != null) {
                if (wsdlFile.indexOf(GetActiveProjectDir.getactiveprodir()) == -1) {
                    wsdlFile = GetActiveProjectDir.getactiveprodir() + wsdlFile;
                }
                this.docment = XMLUtils.getDOMBuilder().parse(
                        new File(wsdlFile));                                                                 p = wsdlreader.readWSDL(wsdlFile, this.docment);                             } else {
                                p = wsdlfactory.newDefinition();
            }
        } catch (Exception e) {
            e.printStackTrace();         }
        return p;
    }
    
    public DefinitionEx getUserWSDLDefinition(String wsdlFile) {
        DefinitionEx definitionEx = null;
        if (wsdlFile != null) {
            if (wsdlFile.indexOf(GetActiveProjectDir.getactiveprodir()) == -1) {
                wsdlFile = GetActiveProjectDir.getactiveprodir() + wsdlFile;
            }
            org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLReader reader = new org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLReader(
                    new File(wsdlFile));
            definitionEx = reader.readWSDL();
        }
        return definitionEx;
    }
    
    public static String getCandidateName(Map container, String prifix) {
        int count = 1;
        String candidateName = prifix + String.valueOf(count);
        while (container.get(candidateName) != null) {
            candidateName = prifix + String.valueOf(++count);
        }
        return candidateName;
    }
    
    public ExtWsdl getExtWsdl() {
        return this.wsdlExtClass;
    }
    
    public void setExtWsdl(ExtWsdl extWsdl) {
        this.wsdlExtClass = extWsdl;
    }
    
    public PropertyWsdl getPropertyWsdl() {
        return this.propertyWsdl;
    }
    
    public void setPropertyWsdl(PropertyWsdl proWsdl) {
        this.propertyWsdl = proWsdl;
    }
    
    public List getRoles() {
        return this.roles;
    }
    
    public boolean addRole(Role r) {
        if (this.getRoleByName(r.getName()) == null && this.roles.add(r)) {
            this.fireRoleAdded(r);
            return true;
        }
        return false;
    }
    
    public void deleteRole(Role r) {
        if (this.roles.remove(r)) {
            this.fireRoleDeleted(r);
        }
    }
    
    public Role getRoleByName(String name) {
        if (this.roles.size() > 0) {
            for (int i = 0; i < this.roles.size(); i++) {
                Role r = (Role) this.roles.get(i);
                if (r.getName().equals(name)) {
                    return r;
                }
            }
        }
        return null;
    }
    
    public boolean addPlinkType(PartnerLinkType plinkType) {
        if (this.getPLinkTypeByName(plinkType.getName()) == null
                && this.plinkTypes.add(plinkType)) {
            reWriteExtWSDL();
            this.firePartnerLinkTypeAdded(plinkType);
            return true;
        }
        return false;
    }
    
    public boolean addPlinkType(PartnerLinkType plinkType, boolean isWriteToFile) {
        if (this.getPLinkTypeByName(plinkType.getName()) == null
                && this.plinkTypes.add(plinkType)) {
            this.firePartnerLinkTypeAdded(plinkType);
            return true;
        }
        return false;
    }
    
    public void deletePartnerLinkType(PartnerLinkType partnerLinkType) {
        if (this.plinkTypes.remove(partnerLinkType)) {
            reWriteExtWSDL();
            this.firePartnerLinkTypeDeleted(partnerLinkType);
        }
    }
    
    public void modifyPartnerLinkType() {
        reWriteExtWSDL();
    }
    
    public void reWriteExtWSDL() {
        if (this.wsdlExtClass == null) {
            this.wsdlExtClass = new ExtWsdl();
            setExtWsdl(this.wsdlExtClass);
            this.wsdlExt = this.wsdlExtClass.getExtWsdl();
            wsdlExt.addNamespace("plnk",
                    "http://schemas.xmlsoap.org/ws/2003/05/partner-link/");
        } else {
            this.wsdlExt = this.wsdlExtClass.getExtWsdl();
        }
                int i = 0;
        while (i < wsdlExt.getExtensibilityElements().size()) {
            ExtensibilityElement element = (ExtensibilityElement) wsdlExt
                    .getExtensibilityElements().get(i);
            i++;
            if (element instanceof UnknownExtensibilityElement) {
                Element propertyElement = ((UnknownExtensibilityElement) element)
                        .getElement();
                if (propertyElement.getNodeName()
                        .equals("plnk:partnerLinkType")) {
                    wsdlExt.getExtensibilityElements().remove(element);
                    i--;
                }
            }
        }
                for (Iterator iter = this.getPlinkType().iterator(); iter.hasNext();) {
            PartnerLinkType partnerLinkType = (PartnerLinkType) iter.next();
            javax.wsdl.extensions.UnknownExtensibilityElement uee = new javax.wsdl.extensions.UnknownExtensibilityElement();
            org.w3c.dom.Element userElement = getElementByPartnerLinkTypeImpl(partnerLinkType);
            uee.setElement(userElement);
            wsdlExt.addExtensibilityElement(uee);
        }
        WSDLWriter wsdlWriter = wsdlExtClass.getWSDLFactory().newWSDLWriter();
        try {
            String fileName;
            if (this.getProcess() != null) {
                fileName = this.getProcess().getAtNameValue();
            } else {
                fileName = "work";
            }
            String path = GetActiveProjectDir.getactiveprodir()
                    + java.io.File.separator + "output"
                    + java.io.File.separator + "bpel" + java.io.File.separator
                    + fileName + "_ext.wsdl";
            Document doc = wsdlWriter.getDocument(wsdlExt);
            try {
                writeXmlFile(path, doc);
                            } catch (Exception e1) {
                                e1.printStackTrace();
            }
        } catch (WSDLException ex) {
        }
    }
    private long writeXmlFile(String name, Document document) throws Exception {
        DOMSource doms = new DOMSource(document);
        File file = new File(name);
        StreamResult result = new StreamResult(file);
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer transformer = tf.newTransformer();
        Properties properties = transformer.getOutputProperties();
        properties.setProperty(OutputKeys.ENCODING, "GB2312");
        properties.setProperty(OutputKeys.METHOD, "xml");
        properties.setProperty(OutputKeys.INDENT, "yes");
        transformer.setOutputProperties(properties);
        transformer.transform(doms, result);
        return 0;
    }
    
    private org.w3c.dom.Element getElementByPartnerLinkTypeImpl(
            PartnerLinkType plt) {
        org.w3c.dom.Element eleResult = null;
        javax.xml.parsers.DocumentBuilderFactory dbf = javax.xml.parsers.DocumentBuilderFactory
                .newInstance();
        try {
            javax.xml.parsers.DocumentBuilder db = dbf.newDocumentBuilder();
            org.w3c.dom.Document doc = db.newDocument();
                        String nsUri = plt.getElementType().getNamespaceURI();
            eleResult = doc.createElement("plnk:partnerLinkType");
            eleResult.setAttribute("name", plt.getName());
                        org.w3c.dom.Element elePRole = null;
            org.w3c.dom.Element eleMyRole = null;
                        if (plt.getPartnerRole() != null) {
                Role pRole = plt.getPartnerRole();
                elePRole = doc.createElement("plnk:role");
                elePRole.setAttribute("name", pRole.getName());
                eleResult.appendChild(elePRole);
                org.w3c.dom.Element elePPt = doc.createElement("plnk:portType");
                String strPrefix = wsdlExt.getPrefix(pRole.getPortType()
                        .getQName().getNamespaceURI());
                elePPt.setAttribute("name", strPrefix + ":"
                        + pRole.getPortType().getQName().getLocalPart());
                elePRole.appendChild(elePPt);
            }
                        if (plt.getMyRole() != null) {
                Role myRole = plt.getMyRole();
                eleMyRole = doc.createElement("plnk:role");
                eleMyRole.setAttribute("name", myRole.getName());
                eleResult.appendChild(eleMyRole);
                org.w3c.dom.Element eleMyPt = doc
                        .createElement("plnk:portType");
                String strPrefix1 = wsdlExt.getPrefix(myRole.getPortType()
                        .getQName().getNamespaceURI());
                eleMyPt.setAttribute("name", strPrefix1 + ":"
                        + myRole.getPortType().getQName().getLocalPart());
                eleMyRole.appendChild(eleMyPt);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return eleResult;
    }
    
    public List getPlinkType() {
        return this.plinkTypes;
    }
    
    public PartnerLinkType getPLinkTypeByName(String name) {
        if (this.plinkTypes.size() > 0) {
            for (int i = 0; i < this.plinkTypes.size(); i++) {
                PartnerLinkType plnkType = (PartnerLinkType) this.plinkTypes
                        .get(i);
                if (plnkType.getName().equals(name)) {
                    return plnkType;
                }
            }
        }
        return null;
    }
    
    public boolean addProperty(Property property) {
        if (this.getPropertyByName(property.getName()) == null
                && this.properties.add(property)) {
            this.reWritePropertyWSDL();
            this.firePropertyAdded(property);
            return true;
        }
        return false;
    }
    
    public boolean addProperty(Property property,boolean isWriteToFile) {
        if (this.getPropertyByName(property.getName()) == null
                && this.properties.add(property)) {
            this.firePropertyAdded(property);
            return true;
        }
        return false;
    }
    
    
    
    
    public void deleteProperty(Property property) {
        if (this.properties.remove(property)) {
                        PropertyAlias propertyAlias;
            if ((propertyAlias = this
                    .getPropertyAliasByName(property.getName())) != null) {
                this.propertyAliases.remove(propertyAlias);
                this.firePropertyAliasDeleted(propertyAlias);
            }
            this.reWritePropertyWSDL();
            this.firePropertyDeleted(property);
        }
    }
    public void modifyProperty() {
        reWritePropertyWSDL();
    }
    
    private void reWritePropertyWSDL() {
        if (this.propertyWsdl == null) {
            this.propertyWsdl = new PropertyWsdl();
            this.setPropertyWsdl(this.propertyWsdl);
            this.wsdlProperty = this.propertyWsdl.getPropertyWsdl();
            this.wsdlProperty.setTargetNamespace("http://org.act/properties");             this.wsdlProperty.addNamespace("bpws",
                    "http://schemas.xmlsoap.org/ws/2003/03/business-process/");
        } else {
            this.wsdlProperty = this.propertyWsdl.getPropertyWsdl();
        }
                int i = 0;
        while (i < wsdlProperty.getExtensibilityElements().size()) {
            ExtensibilityElement element = (ExtensibilityElement) wsdlProperty
                    .getExtensibilityElements().get(i);
            i++;
            if (element instanceof UnknownExtensibilityElement) {
                Element propertyElement = ((UnknownExtensibilityElement) element)
                        .getElement();
                if (propertyElement.getNodeName().equals("bpws:property")
                        || propertyElement.getNodeName().equals(
                                "bpws:propertyAlias")) {
                    wsdlProperty.getExtensibilityElements().remove(element);
                    i--;
                }
            }
        }
                for (Iterator iter = this.getProperties().iterator(); iter.hasNext();) {
            Property property = (Property) iter.next();
            javax.wsdl.extensions.UnknownExtensibilityElement uee = new javax.wsdl.extensions.UnknownExtensibilityElement();
            org.w3c.dom.Element userElement = getElementByPropertyImpl(property);
            uee.setElement(userElement);
            wsdlProperty.addExtensibilityElement(uee);
        }
                Iterator importedWSDLIterator = this.imports.values().iterator();
        while (importedWSDLIterator.hasNext()) {
            ImportedWSDL thisImportedWSDL = (ImportedWSDL) importedWSDLIterator
                    .next();
            if (this.wsdlProperty
                    .getPrefix(thisImportedWSDL.wsdlTargetNamespace) == null) {
                this.wsdlProperty.addNamespace(Project.getCandidateName(
                        this.wsdlProperty.getNamespaces(), "ns"),
                        thisImportedWSDL.wsdlTargetNamespace);
            }
        }
                for (Iterator iter = this.getPropertyAliases().iterator(); iter
                .hasNext();) {
            PropertyAlias propertyAlias = (PropertyAlias) iter.next();
            javax.wsdl.extensions.UnknownExtensibilityElement uee = new javax.wsdl.extensions.UnknownExtensibilityElement();
            org.w3c.dom.Element userElement = getElementByPropertyAliasImpl(propertyAlias);
            uee.setElement(userElement);
            wsdlProperty.addExtensibilityElement(uee);
        }
        WSDLWriter wsdlWriter = propertyWsdl.getWSDLFactory().newWSDLWriter();
        String fileName;
        if (this.getProcess() != null) {
            fileName = this.getProcess().getAtNameValue();
        } else {
            fileName = "work";
        }
        try {
            String path = GetActiveProjectDir.getactiveprodir()
                    + java.io.File.separator + "output"
                    + java.io.File.separator + "bpel" + java.io.File.separator
                    + fileName + "_property" + ".wsdl";
            Document doc = wsdlWriter.getDocument(wsdlProperty);
            try {
                writeXmlFile(path, doc);
            } catch (Exception e1) {
                                e1.printStackTrace();
            }
        } catch (WSDLException ex) {
        }
    }
    
    private Element getElementByPropertyImpl(Property property) {
        org.w3c.dom.Element eleResult = null;
        javax.xml.parsers.DocumentBuilderFactory dbf = javax.xml.parsers.DocumentBuilderFactory
                .newInstance();
        DocumentBuilder db = null;
        try {
            db = dbf.newDocumentBuilder();
            org.w3c.dom.Document doc = db.newDocument();
                        eleResult = doc.createElement("bpws:property");
            eleResult.setAttribute("name", property.getName());
            eleResult.setAttribute("type", property.getType());
        } catch (Exception e) {
        }
        return eleResult;
    }
    
    private Element getElementByPropertyAliasImpl(PropertyAlias propertyAlias) {
        org.w3c.dom.Element eleResult = null;
        javax.xml.parsers.DocumentBuilderFactory dbf = javax.xml.parsers.DocumentBuilderFactory
                .newInstance();
        DocumentBuilder db = null;
        try {
            db = dbf.newDocumentBuilder();
            org.w3c.dom.Document doc = db.newDocument();
                        eleResult = doc.createElement("bpws:propertyAlias");
            Message message = propertyAlias.getMessageType();
            String prefix = this.wsdlProperty.getPrefix(message.getQName()
                    .getNamespaceURI());             String mesName = prefix + ":" + message.getQName().getLocalPart();
            eleResult.setAttribute("propertyName", propertyAlias
                    .getPropertyName());
            eleResult.setAttribute("messageType", mesName);
            eleResult.setAttribute("part", propertyAlias.getPart());
        } catch (Exception e) {
        }
        return eleResult;
    }
    
    public List getProperties() {
        return this.properties;
    }
    
    public Property getPropertyByName(String s) {
        for (int i = 0; i < this.properties.size(); i++) {
            Property prot = (Property) this.properties.get(i);
            if (prot.getName().equals(s)) {
                return prot;
            }
        }
        return null;
    }
    
    public boolean addPropertyAlias(PropertyAlias propertyAlias) {
        if (this.getPropertyAliasByName(propertyAlias.getPropertyName()) == null
                && this.propertyAliases.add(propertyAlias)) {
            this.reWritePropertyWSDL();
            this.firePropertyAliasAdded(propertyAlias);
            return true;
        }
        return false;
    }
    
    public boolean addPropertyAlias(PropertyAlias propertyAlias,boolean isWriteToFile) {
        if (this.getPropertyAliasByName(propertyAlias.getPropertyName()) == null
                && this.propertyAliases.add(propertyAlias)) {
            this.firePropertyAliasAdded(propertyAlias);
            return true;
        }
        return false;
    }
    
    public void deletePropertyAlias(PropertyAlias propertyAlias) {
        if (this.propertyAliases.remove(propertyAlias)) {
            this.reWritePropertyWSDL();
            this.firePropertyAliasDeleted(propertyAlias);
        }
    }
    
    public List getPropertyAliases() {
        return this.propertyAliases;
    }
    
    public PropertyAlias getPropertyAliasByName(String s) {
        for (int i = 0; i < this.propertyAliases.size(); i++) {
            PropertyAlias proa = (PropertyAlias) this.propertyAliases.get(i);
            if (proa.getPropertyName().equals(s)) {
                return proa;
            }
        }
        return null;
    }
    
    public WSDLRegistry getWSDLRegistry() {
        return this.wsdlRegistry;
    }
    
    public BPELProcess getProcess() {
        return this.process;
    }
    
    public void setProcess(BPELProcess bp) {
        this.process = bp;
    }
    
    public void setElementWriter(ElementWriter eWriter) {
        this.eleWriter = eWriter;
    }
    
    public ElementWriter getElementWriter() {
        if (eleWriter == null) {
            this.eleWriter = new ElementWriter();
        }
        return this.eleWriter;
    }
    
    public void setElementReader(ElementReader elementReader) {
        this.elementReader = elementReader;
    }
    
    public ElementReader getElementReader() {
        if (elementReader == null) {
            File propWsdlDir = new File(GetActiveProjectDir.getactiveprodir()
                    + File.separator + "output" + File.separator + "bpel");
            if (WorkSpace.getInstance().getEle(propWsdlDir) != null) {
                this.elementReader = new ElementReader(WorkSpace.getInstance()
                        .getEle(propWsdlDir), this);
            }
        }
        return elementReader;
    }
    
    public Layer getActiveLayer() {
        return activeLayer;
    }
    
    public void setActiveLayer(Layer activeLayer) {
        this.activeLayer = activeLayer;
    }
}
