package org.act.wsc.bpel4wsmodeling.projectdata;
import javax.wsdl.Definition;
import java.io.File;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Property;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyAlias;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyWsdl;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import javax.wsdl.Message;

public class PropWsdlReader {
  Project project;
  Definition propWsdlDefinition;
  public PropWsdlReader(Project pro) {
    this.project = pro;
  }

  public void readPropWsdl(String propWsdlFile) {
    PropertyWsdl propWsdl = new PropertyWsdl();
    this.propWsdlDefinition = propWsdl.getPropertyWsdl();
    this.project.setPropertyWsdl(propWsdl);
    File fileProject = new java.io.File(propWsdlFile);
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = null;
    Document docPropWsdl = null;
    try {
            db = dbf.newDocumentBuilder();
            docPropWsdl = db.parse(fileProject);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    Element rootElement = rootElement = (Element) docPropWsdl.getFirstChild();         for (int i = 0; i < rootElement.getAttributes().getLength(); i++) {
      Node node = rootElement.getAttributes().item(i);
      if (node.getNodeName().startsWith("xmlns:")) {
        propWsdlDefinition.addNamespace(node.getNodeName().substring(node.
            getNodeName().indexOf(":") + 1, node.getNodeName().length()),
                                        node.getNodeValue());
      }
      else if (node.getNodeName().equals("targetNamespace")) {
        propWsdlDefinition.setTargetNamespace(node.getNodeValue());
      }
      else {
                }
    }
    NodeList propertyList = rootElement.getElementsByTagName("bpws:property");
    for (int i = 0; i < propertyList.getLength(); i++) {
      Element propertyEle = (Element) propertyList.item(i);
      Property property = new Property();
      property.setName(propertyEle.getAttribute("name"));
      property.setType(propertyEle.getAttribute("type"));
      this.project.addProperty(property,false);
      javax.wsdl.extensions.UnknownExtensibilityElement uee =
          new javax.wsdl.extensions.UnknownExtensibilityElement();
      org.w3c.dom.Element userElement = getElementByPropertyImpl(
          property);
      uee.setElement(userElement);
      propWsdlDefinition.addExtensibilityElement(uee);
    }
    NodeList propertyAliasList = rootElement.getElementsByTagName(
        "bpws:propertyAlias");
    for (int j = 0; j < propertyAliasList.getLength(); j++) {
      Element propertyAliasEle = (Element) propertyAliasList.item(j);
      PropertyAlias propertyAlias = new PropertyAlias();
      propertyAlias.setPropertyName(propertyAliasEle.getAttribute("propertyName"));
      String messageTypeValue = propertyAliasEle.getAttribute("messageType");
      String prefix = messageTypeValue.substring(0,
                                                 messageTypeValue.indexOf(":"));
      String messageTypeLocal = messageTypeValue.substring(messageTypeValue.
          indexOf(":") + 1, messageTypeValue.length());
            String messageTypeNs;
      if (prefix .equals("null")) {
           messageTypeNs = "";
      }
      else {
             messageTypeNs = propWsdlDefinition.getNamespace(prefix);
      }
      Message message = (Message)this.project.getWSDLRegistry().findMessage(
          messageTypeNs, messageTypeLocal).userObject;
      propertyAlias.setMessageType(message);
      propertyAlias.setPart(propertyAliasEle.getAttribute("part"));
      this.project.addPropertyAlias(propertyAlias,false);
      javax.wsdl.extensions.UnknownExtensibilityElement uee =
          new javax.wsdl.extensions.UnknownExtensibilityElement();
      org.w3c.dom.Element userElement = getElementByPropertyAliasImpl(
          propertyAlias);
      uee.setElement(userElement);
      propWsdlDefinition.addExtensibilityElement(uee);
    }
  }
  private Element getElementByPropertyImpl(Property property) {
    org.w3c.dom.Element eleResult = null;
    javax.xml.parsers.DocumentBuilderFactory dbf = javax.xml.parsers.
        DocumentBuilderFactory.newInstance();
    DocumentBuilder db = null;
    try {
      db = dbf.newDocumentBuilder();
      org.w3c.dom.Document doc = db.newDocument();
            eleResult = doc.createElement("bpws:property");
      eleResult.setAttribute("name", property.getName());
      eleResult.setAttribute("type", property.getType());
    }
    catch (Exception e) {
    }
    return eleResult;
  }
  private Element getElementByPropertyAliasImpl(PropertyAlias propertyAlias) {
    org.w3c.dom.Element eleResult = null;
    javax.xml.parsers.DocumentBuilderFactory dbf = javax.xml.parsers.
        DocumentBuilderFactory.newInstance();
    DocumentBuilder db = null;
    try {
      db = dbf.newDocumentBuilder();
      org.w3c.dom.Document doc = db.newDocument();
            eleResult = doc.createElement("bpws:propertyAlias");
      Message message = propertyAlias.getMessageType();
      String prefix = this.propWsdlDefinition.getPrefix(message.getQName().
          getNamespaceURI());       String mesName = prefix + ":" + message.getQName().getLocalPart();
      eleResult.setAttribute("propertyName", propertyAlias.getPropertyName());
      eleResult.setAttribute("messageType", mesName);
      eleResult.setAttribute("part", propertyAlias.getPart());
    }
    catch (Exception e) {
    }
    return eleResult;
  }
}
