
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import org.act.wsc.bpel4wsmodeling.def.process.Activity;
import org.act.wsc.bpel4wsmodeling.def.process.Case;
import org.act.wsc.bpel4wsmodeling.def.process.Flow;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.OtherWise;
import org.act.wsc.bpel4wsmodeling.def.process.Scope;
import org.act.wsc.bpel4wsmodeling.def.process.While;

public class NominalFigure extends Figure {
    
    public NominalFigure(boolean vacancy) {
        super();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
            }
    public NominalFigure() {
        super(Figure.LABLE_NOMINAL);
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
    }
    public void translate(int dx, int dy) {
        this.x += dx;
        this.y += dy;
        this.fireFigureLayoutUpated();
    }
    public int getStructHeight() {
        if (this.structHeight == 0) {
            this.structHeight = this.height;
        }
        return this.structHeight;
    }
    public int getStructWidth() {
        if (this.structWidth == 0) {
            this.structWidth = this.width;
        }
        return this.structWidth;
    }
    
    public void replaced(Figure newFigure) {
        StructFigure parent = this.getParent();
        parent.figures.set(parent.figures.indexOf(this), newFigure);
        parent.fireFigureRemoved(this);
        newFigure.setParent(parent);
        newFigure.setOwner(this.getOwner());
        this.addActivity(this.parent.getType(), newFigure);         this.parent.boundChanged();
        parent.fireFigureLayoutUpated();
        parent.fireFigureAdded(newFigure);
    }
    private void addActivity(int type, Figure figure) {
        switch (type) {
        case Figure.LABLE_CASE:
            Case c = (Case) this.parent.getServicesSet();
            c.addActivity((Activity) figure.getServicesSet());
            break;
        case Figure.LABLE_FLOW:
            Flow f = (Flow) this.parent.getServicesSet();
            f.addActivity((Activity) figure.getServicesSet());             break;
        case Figure.LABLE_ONALARM:
            OnAlarm a = (OnAlarm) this.parent.getServicesSet();
            a.addActivity((Activity) figure.getServicesSet());
            break;
        case Figure.LABLE_ONMESSAGE:
            OnMessage m = (OnMessage) this.parent.getServicesSet();
            m.addActivity((Activity) figure.getServicesSet());
            break;
        case Figure.LABLE_OTHERWISE:
            OtherWise o = (OtherWise) this.parent.getServicesSet();
            o.addActivity((Activity) figure.getServicesSet());
            break;
        case Figure.LABLE_SCOPE:
            Scope s = (Scope) this.parent.getServicesSet();
            s.addActivity((Activity) figure.getServicesSet());             break;
        case Figure.LABLE_WHILE:
            While w = (While) this.parent.getServicesSet();
            w.addActivity((Activity) figure.getServicesSet());
            break;
        default:
            break;
        }
        this.getOwner().getBPELProcess().write();
    }
}
