
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.awt.Rectangle;
import org.act.metaset.Metaset;
import java.util.List;
import java.util.Vector;

public class OnMessageFigure extends StructFigure {
    
    public OnMessageFigure(boolean vacancy) {
        super();
    }
    public OnMessageFigure() {
        super(Figure.LABLE_ONMESSAGE);
        NominalFigure nominalFigure = new NominalFigure();
        this.figures.add(nominalFigure);
        nominalFigure.setParent(this);
        nominalFigure.setOwner(this.getOwner());
        Line line1 = new Line();
        this.lines.add(line1);
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
    }
    public OnMessageFigure(Metaset ss, List figures) {
        super(ss);
        init(ss, figures);
    }
    private void init(Metaset ss, List figures) {
        if (figures.size() > 0) {
            Figure f = (Figure) figures.get(0);
            this.figures.add(f);
            f.setParent(this);
            f.setOwner(this.getOwner());
        } else {
            NominalFigure nominalFigure = new NominalFigure();
            this.figures.add(nominalFigure);
            nominalFigure.setParent(this);
            nominalFigure.setOwner(this.getOwner());
        }
        Line line1 = new Line();
        this.lines.add(line1);
        Line line2 = new Line();
        this.lines.add(line2);
    }
    public void removeFigure(Figure figure) {
        if (this.figures.size() == 1 && this.figures.get(0).equals(figure)) {
            this.figures.clear();
            this.fireFigureRemoved(figure);
            NominalFigure nominalFigure = new NominalFigure();
                        nominalFigure.setOwner(figure.getOwner());
            nominalFigure.setParent(figure.getParent());
            this.figures.add(nominalFigure);
            this.boundChanged();
            this.fireFigureLayoutUpated();
            this.fireFigureAdded(nominalFigure);
        }
    }
    public void translate(int dx, int dy) {
        this.x += dx;
        this.y += dy;
        if (!this.figures.isEmpty()) {
            ((Figure) this.figures.get(0)).translate(dx, dy);
            ((Line) this.lines.get(0)).translate(dx, dy);
        }
        this.fireFigureLayoutUpated();
    }
    
    protected Figure getSoleChildFigure() {
        if (this.figures != null && this.figures.size() == 1) {
            Figure figure = (Figure) this.figures.get(0);
            if (figure instanceof StructFigure) {
                return ((StructFigure) figure).getEnd();
            } else {
                return figure;
            }
        }
        return null;
    }
    protected Rectangle getStructBound() {
        return null;
    }
    public int getStructHeight() {
        if (this.structHeight == 0) {
            this.heightRecalculate();
        }
        return this.structHeight;
    }
    public int getStructWidth() {
        if (this.structWidth == 0) {
            this.widthRecalculate();
        }
        return this.structWidth;
    }
    
    public void setLayout() {
        if (!this.figures.isEmpty() && !this.lines.isEmpty()) {
            Figure figure = (Figure) this.figures.get(0);
            Line line = (Line) this.lines.get(0);
            line.reset();
            figure.setX(this.x);
            figure.setY(this.y + this.height + Line.LINE_HEIGHT);
            if (figure instanceof StructFigure) {
                ((StructFigure) figure).setLayout();
            }
            line.setSource(this);
            line.setTarget(figure);
        }
    }
    public void heightRecalculate() {
        this.structHeight = this.height;
        if (!this.figures.isEmpty() && !this.lines.isEmpty()) {
            this.structHeight += ((Figure) this.figures.get(0))
                    .getStructHeight()
                    + Line.LINE_HEIGHT;
        }
    }
    public void widthRecalculate() {
        this.structWidth = this.width;
        if (!this.figures.isEmpty()) {
            this.structWidth = Math.max(((Figure) this.figures.get(0))
                    .getStructWidth(), this.structWidth);
        }
    }
    public List getFirstChilds() {
        List figureList = new Vector();
        if (this.figures.size() == 1
                && !(this.figures instanceof NominalFigure)) {
            figureList.add(this.figures.get(0));
        }
        return figureList;
    }
    
    public void addFigure(Figure figure) {
        if (this.figures.isEmpty()) {
                        this.getOutput().setSource(figure);
            Line line = new Line();
            line.setSource(this);
            line.setTarget(figure);
            figure.setParent(this);
            figure.setOwner(this.getOwner());
            this.figures.add(figure);
            this.lines.add(line);
            this.fireFigureAdded(figure);
            this.fireLineAdded(line);
        }
    }
}
