
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.Pick;

public class PickFigure extends StructFigure {
    private List onAlarms = new Vector();
    private List onMessages = new Vector();
    protected PickFigure(boolean vacancy) {
        super();
    }
    public PickFigure() {
        super(Figure.LABLE_PICK);
        init();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
    }
    private void init() {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        OnMessageFigure onMessageFigure = new OnMessageFigure();
        OnAlarmFigure onAlarmFigure = new OnAlarmFigure();
        OnAlarm onAlarm = new OnAlarm();
        OnMessage onMessage = new OnMessage();
        onAlarmFigure.setServicesSet(onAlarm);
        onMessageFigure.setServicesSet(onMessage);
        Pick pick = (Pick) this.getServicesSet();
        pick.addOnMessage(onMessage);
        pick.addOnAlarm(onAlarm);
        this.figures.add(onMessageFigure);
        this.onMessages.add(onMessageFigure);
        onMessageFigure.setParent(this);
        onMessageFigure.setOwner(this.getOwner());
        this.figures.add(onAlarmFigure);
        this.onAlarms.add(onAlarmFigure);
        onAlarmFigure.setParent(this);
        onAlarmFigure.setOwner(this.getOwner());
        Line line11 = new Line();
        Line line12 = new Line();
        Line line21 = new Line();
        Line line22 = new Line();
        this.lines.add(line11);
        this.lines.add(line12);
        this.lines.add(line21);
        this.lines.add(line22);
    }
    public PickFigure(int x, int y) {
        super(x, y, Figure.LABLE_PICK);
        init();
                this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
        this.setLayout();
    }
    public PickFigure(Metaset ss, List figures, List onMessages, List onAlarms) {
        super(ss);
        init(ss, figures, onMessages, onAlarms);
    }
    private void init(Metaset ss, List figures, List onMessages, List onAlarms) {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        for (int i = 0; i < onMessages.size(); i++) {
            OnMessageFigure omf = (OnMessageFigure) onMessages.get(i);
            this.figures.add(omf);
            this.onMessages.add(omf);
            omf.setParent(this);
            omf.setOwner(this.getOwner());
            Line line1 = new Line();
            Line line2 = new Line();
            this.lines.add(line1);
            this.lines.add(line2);
        }
        for (int i = 0; i < onAlarms.size(); i++) {
            OnAlarmFigure oaf = (OnAlarmFigure) onAlarms.get(i);
            this.figures.add(oaf);
            this.onAlarms.add(oaf);
            oaf.setParent(this);
            oaf.setOwner(this.getOwner());
            Line line1 = new Line();
            Line line2 = new Line();
            this.lines.add(line1);
            this.lines.add(line2);
        }
    }
    public void addFigure(Figure figure) {
        if (figure instanceof OnAlarmFigure) {
            this.addOnAlarm((OnAlarmFigure) figure);
        } else if (figure instanceof OnMessageFigure) {
            this.addOnMessage((OnMessageFigure) figure);
        }
    }
    public void removeFigure(Figure figure) {
        if (figure instanceof OnAlarmFigure) {
            this.removeOnAlarm((OnAlarmFigure) figure);
        } else if (figure instanceof OnMessageFigure) {
            this.removeOnMessage((OnMessageFigure) figure);
        }
    }
    private void addOnAlarm(OnAlarmFigure onAlarmFigure) {
                this.figures.add(onAlarmFigure);
        this.onAlarms.add(onAlarmFigure);
        onAlarmFigure.setParent(this);
        onAlarmFigure.setOwner(this.getOwner());
        this.getServicesSet().add(onAlarmFigure.getServicesSet());
        onAlarmFigure.getServicesSet().setFather(this.getServicesSet());
        this.getOwner().getBPELProcess().write();
        Line line1 = new Line();
        Line line2 = new Line();
        this.lines.add(0, line1);
        this.lines.add(0, line2);
        this.boundChanged();
        this.fireFigureLayoutUpated();
        this.fireFigureAdded(onAlarmFigure);
        this.fireLineAdded(line1);
        this.fireLineAdded(line2);
    }
    private void removeOnAlarm(OnAlarmFigure onAlarmFigure) {
        this.figures.remove(onAlarmFigure);
        this.onAlarms.remove(onAlarmFigure);
        Line line1 = onAlarmFigure.getInput();
        Line line2 = onAlarmFigure.getSoleChildFigure().getOutput();
        this.lines.remove(line1);
        this.lines.remove(line2);
        this.boundChanged();
        this.fireFigureLayoutUpated();
        this.fireFigureRemoved(onAlarmFigure);
        this.fireLineRemoved(line1);
        this.fireLineRemoved(line2);
    }
    private void addOnMessage(OnMessageFigure onMessageFigure) {
                this.figures.add(0, onMessageFigure);
        this.onMessages.add(0, onMessageFigure);
        onMessageFigure.setParent(this);
        onMessageFigure.setOwner(this.getOwner());
        this.getServicesSet().insert(onMessageFigure.getServicesSet(), 0);
        onMessageFigure.getServicesSet().setFather(this.getServicesSet());
        this.getOwner().getBPELProcess().write();
        Line line1 = new Line();
        Line line2 = new Line();
        this.lines.add(line1);
        this.lines.add(line2);
        this.boundChanged();
        this.fireFigureLayoutUpated();
        this.fireFigureAdded(onMessageFigure);
        this.fireLineAdded(line1);
        this.fireLineAdded(line2);
    }
    private void removeOnMessage(OnMessageFigure onMessageFigure) {
        if (this.onMessages.size() == 1) {
            return;
        }
        this.figures.remove(onMessageFigure);         this.onMessages.remove(onMessageFigure);
        Line line1 = onMessageFigure.getInput();
        Line line2 = onMessageFigure.getSoleChildFigure().getOutput();
        this.lines.remove(line1);
        this.lines.remove(line2);
        this.boundChanged();
        this.fireFigureLayoutUpated();
        this.fireFigureRemoved(onMessageFigure);
        this.fireLineRemoved(line1);
        this.fireLineRemoved(line2);
    }
    public int getOnMessageCount() {
        return this.onMessages.size();
    }
    public void translate(int dx, int dy) {
        this.x += dx;
        this.y += dy;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure element = (Figure) iter.next();
            element.translate(dx, dy);
        }
        for (Iterator iter = this.lines.iterator(); iter.hasNext();) {
            Line element = (Line) iter.next();
            element.translate(dx, dy);
        }
        if (this.end != null) {
            this.end.translate(dx, dy);
        }
        this.fireFigureLayoutUpated();
    }
    protected Rectangle getStructBound() {
                return null;
    }
    public int getStructHeight() {
        if (this.structHeight == 0) {
            this.heightRecalculate();
        }
        return structHeight;
    }
    public int getStructWidth() {
        if (this.structWidth == 0) {
            this.widthRecalculate();
        }
        return structWidth;
    }
    public void setLayout() {
        this.end.setX(this.x);
        this.end.setY(this.y + this.getStructHeight() - this.end.height);
        int childFigureX = this.x - this.getStructWidth() / 2
                + StructFigure.BORDER_WIDTH;
        int childFigureY = this.y + this.getHeight() + Line.LINE_HEIGHT * 2;
        for (int i = 0; i < this.figures.size(); i++) {
                        Figure figure = (Figure) this.figures.get(i);
            figure.setX(childFigureX + figure.getStructWidth() / 2);
            figure.setY(childFigureY);
            if (figure instanceof StructFigure) {
                ((StructFigure) figure).setLayout();
            }
            childFigureX += figure.getStructWidth()
                    + StructFigure.HORIZONTAL_INTERVAL;
                        Line line1 = (Line) this.lines.get(i * 2);
            line1.reset();
            line1.setSource(this);
            line1.setTarget(figure);
            Point sPoint1 = (Point) line1.getPoints().get(0);
            Point tPoint1 = (Point) line1.getPoints().get(
                    line1.getPoints().size() - 1);
            line1.getPoints().add(1,
                    new Point(sPoint1.x, sPoint1.y + Line.LINE_HEIGHT));
            line1.getPoints().add(2,
                    new Point(tPoint1.x, tPoint1.y - Line.LINE_HEIGHT));
            Line line2 = (Line) this.lines.get(i * 2 + 1);
            line2.reset();
            if (figure instanceof OnAlarmFigure) {
                line2.setSource(((OnAlarmFigure) figure).getSoleChildFigure());
            } else if (figure instanceof OnMessageFigure) {
                line2
                        .setSource(((OnMessageFigure) figure)
                                .getSoleChildFigure());
            }
            line2.setTarget(this.end);
            Point sPoint2 = (Point) line2.getPoints().get(0);
            Point tPoint2 = (Point) line2.getPoints().get(
                    line2.getPoints().size() - 1);
            line2.getPoints().add(1,
                    new Point(sPoint2.x, tPoint2.y - Line.LINE_HEIGHT));
            line2.getPoints().add(2,
                    new Point(tPoint2.x, tPoint2.y - Line.LINE_HEIGHT));
        }
    }
    public void heightRecalculate() {
        this.structHeight = 0;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure figure = (Figure) iter.next();
            if (this.structHeight < figure.getStructHeight()) {
                this.structHeight = figure.getStructHeight();
            }
        }
        this.structHeight += this.height + this.end.getHeight()
                + Line.LINE_HEIGHT * 4;
    }
    public void widthRecalculate() {
        this.structWidth = (this.figures.size() - 1)
                * StructFigure.HORIZONTAL_INTERVAL;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure figure = (Figure) iter.next();
            this.structWidth += figure.getStructWidth();
        }
        this.structWidth = Math.max(this.structWidth, this.width);
        this.structWidth += StructFigure.BORDER_WIDTH * 2;
    }
    
    public List getFirstChilds() {
        List figureList = new Vector();
        for (Iterator iter = this.onAlarms.iterator(); iter.hasNext();) {
            OnAlarmFigure alarmFigure = (OnAlarmFigure) iter.next();
            figureList.addAll(alarmFigure.getFirstChilds());
        }
        for (Iterator iter = this.onMessages.iterator(); iter.hasNext();) {
            OnMessageFigure messageFigure = (OnMessageFigure) iter.next();
            figureList.addAll(messageFigure.getFirstChilds());
        }
        return figureList;
    }
}
