
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.awt.Rectangle;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.IFigureLifeCircleListener;

public abstract class StructFigure extends Figure {
    public static int BORDER_WIDTH = 5;    public static int HORIZONTAL_INTERVAL = 10;
    protected List figures = new Vector();
    protected List lines = new Vector();
    protected JoinendFigure end = null;
    protected List figureLifeCircleListeners = new Vector();
    
    protected StructFigure() {
        super();
            }
    protected StructFigure(int type) {
        super(type);
    }
    public StructFigure(int x, int y, int type) {
        super(x, y, type);
    }
    public StructFigure(Metaset ss) {
        super(ss);
    }
    
    public abstract void addFigure(Figure figure);
    
    abstract public void removeFigure(Figure figure);
    
    public void addListener(IFigureLifeCircleListener l) {
        if (!this.figureLifeCircleListeners.contains(l)) {
            this.figureLifeCircleListeners.add(l);
        }
    }
    
    public void removeListener(IFigureLifeCircleListener l) {
        if (this.figureLifeCircleListeners.contains(l)) {
            this.figureLifeCircleListeners.remove(l);
        }
    }
    protected void fireFigureAdded(Figure figure) {
        for (Iterator iter = this.figureLifeCircleListeners.iterator(); iter
                .hasNext();) {
            ((IFigureLifeCircleListener) iter.next()).figureAdded(figure);
        }
    }
    protected void fireFigureRemoved(Figure figure) {
        for (Iterator iter = this.figureLifeCircleListeners.iterator(); iter
                .hasNext();) {
            ((IFigureLifeCircleListener) iter.next()).figureRemoved(figure);
        }
    }
    
    protected void fireLineAdded(Line line) {
                for (Iterator iter = this.figureLifeCircleListeners.iterator(); iter
                .hasNext();) {
            ((IFigureLifeCircleListener) iter.next()).lineAdded(line);
        }
    }
    
    protected void fireLineRemoved(Line line) {
        for (Iterator iter = this.figureLifeCircleListeners.iterator(); iter
                .hasNext();) {
            ((IFigureLifeCircleListener) iter.next()).lineRemoved(line);
        }
    }
    
    public JoinendFigure getEnd() {
        return end;
    }
    protected abstract Rectangle getStructBound();
    
    
    public List getFigures() {
        return figures;
    }
    
    public List getLines() {
        return lines;
    }
    
    public abstract List getFirstChilds();
    
    public abstract void setLayout();
    public boolean boundChanged() {
                int oldWidth = this.structWidth;
        int oldHeight = this.structHeight;
        this.widthRecalculate();
        this.heightRecalculate();
        if (this.structHeight == oldHeight && this.structWidth == oldWidth) {
            return false;
        } else {
            if (this.parent == null) {
                this.setLayout();
                                this.getOwner().setLayout();
            } else if (this.parent.boundChanged() == false) {
                this.parent.setLayout();
            }
            return true;
        }
    }
    
    public abstract void heightRecalculate();
    
    public abstract void widthRecalculate();
}
