
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.def.process.Case;
import org.act.wsc.bpel4wsmodeling.def.process.OtherWise;
import org.act.wsc.bpel4wsmodeling.def.process.Switch;

public class SwitchFigure extends StructFigure {
    private List cases = new Vector();
    private OtherwiseFigure otherwise;
    
    protected SwitchFigure(boolean vacancy) {
        super();
    }
    public SwitchFigure(int x, int y) {
        super(x, y, Figure.LABLE_SWITCH);
        init();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
        this.setLayout();
    }
    
    public SwitchFigure() {
        super(Figure.LABLE_SWITCH);
        init();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
    }
    
    private void init() {
        CaseFigure caseFigure1 = new CaseFigure();
        this.otherwise = new OtherwiseFigure();
        Case caseClause1 = new Case();
        OtherWise otherWise = new OtherWise();
        caseFigure1.setServicesSet(caseClause1);
        this.otherwise.setServicesSet(otherWise);
        Switch sw = (Switch) this.getServicesSet();
        sw.addCase(caseClause1);
        sw.addOtherWise(otherWise);
        this.figures.add(caseFigure1);
        this.cases.add(caseFigure1);
        caseFigure1.setParent(this);
        caseFigure1.setOwner(this.getOwner());
        this.figures.add(this.otherwise);
        this.otherwise.setParent(this);
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        Line line11 = new Line();
        Line line12 = new Line();
        Line line21 = new Line();
        Line line22 = new Line();
        this.lines.add(line11);
        this.lines.add(line12);
        this.lines.add(line21);
        this.lines.add(line22);
    }
    public SwitchFigure(Metaset ss, List figures, List cases, List otherwises) {
        super(ss);
        init(ss, figures, cases, otherwises);
    }
    private void init(Metaset ss, List figures, List cases, List otherwises) {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        for (int i = 0; i < cases.size(); i++) {
            CaseFigure caseFigure = (CaseFigure) cases.get(i);
            caseFigure.setParent(this);
            caseFigure.setOwner(this.getOwner());
            this.figures.add(caseFigure);
            this.cases.add(caseFigure);
            Line line11 = new Line();
            Line line12 = new Line();
            this.lines.add(line11);
            this.lines.add(line12);
        }
        if (otherwises.size() > 0) {
            this.otherwise = (OtherwiseFigure) otherwises.get(0);
            this.figures.add(this.otherwise);
            this.otherwise.setParent(this);
            this.otherwise.setOwner(this.getOwner());
            Line line21 = new Line();
            Line line22 = new Line();
            this.lines.add(line21);
            this.lines.add(line22);
        }
    }
    public int getCaseCount() {
        return this.cases.size();
    }
    public int getOtherwiseCount() {
        return this.otherwise == null ? 0 : 1;
    }
    public void addFigure(Figure figure) {
        if (figure instanceof CaseFigure) {
            this.addCaseFigure((CaseFigure) figure);
        } else if (figure instanceof OtherwiseFigure) {
            this.addOtherwiseFigure((OtherwiseFigure) figure);
        }
    }
    
    public void addCaseFigure(CaseFigure caseFigure) {
                this.figures.add(0, caseFigure);
        this.cases.add(0, caseFigure);
        caseFigure.setParent(this);
        caseFigure.setOwner(this.getOwner());
        this.getServicesSet().insert(caseFigure.getServicesSet(), 0);
        caseFigure.getServicesSet().setFather(this.getServicesSet());
        this.getOwner().getBPELProcess().write();
        Line line1 = new Line();
        Line line2 = new Line();
        this.lines.add(0, line1);
        this.lines.add(1, line2);
        this.boundChanged();
        this.fireFigureAdded(caseFigure);
        this.fireLineAdded(line1);
        this.fireLineAdded(line2);
        this.fireFigureLayoutUpated();
    }
    
    private void removeCaseFigure(CaseFigure caseFigure) {
        if (this.cases != null) {
            this.figures.remove(caseFigure);             this.cases.remove(caseFigure);
            Line line1 = caseFigure.getInput();
            Line line2 = caseFigure.getSoleChildFigure().getOutput();
            this.lines.remove(line1);
            this.lines.remove(line2);
            this.boundChanged();
            this.fireFigureLayoutUpated();
            this.fireFigureRemoved(caseFigure);
            this.fireLineRemoved(line1);
            this.fireLineRemoved(line2);
            caseFigure = null;
            line1 = null;
            line2 = null;
        }
    }
    
    public void addOtherwiseFigure(OtherwiseFigure otherwiseFigure) {
        if (this.otherwise == null) {
                                    this.setStructWidth(this.structWidth
                    + otherwiseFigure.getStructWidth()
                    + StructFigure.HORIZONTAL_INTERVAL);
            this.otherwise = otherwiseFigure;
            this.figures.add(this.otherwise);
            this.otherwise.setParent(this);
            this.otherwise.setOwner(this.getOwner());
                        this.getServicesSet().add(this.otherwise.getServicesSet());
            this.otherwise.getServicesSet().setFather(this.getServicesSet());
            this.getOwner().getBPELProcess().write();
            Line line1 = new Line();
            Line line2 = new Line();
            this.lines.add(line1);
            this.lines.add(line2);
            this.fireFigureAdded(otherwiseFigure);
            this.fireLineAdded(line1);
            this.fireLineAdded(line2);
            this.fireFigureLayoutUpated();
        }
    }
    
    private void removeOtherwiseFigure(OtherwiseFigure otherwiseFigure) {
        if (otherwise != null && this.otherwise.equals(otherwiseFigure)) {
            this.lines.remove(this.otherwise.getInput());
            this.lines.remove(this.otherwise.getOutput());
            this.figures.remove(this.otherwise);
            this.otherwise = null;
                        Line line1 = otherwiseFigure.getInput();
            Line line2 = otherwiseFigure.getSoleChildFigure().getOutput();
            this.lines.remove(line1);
            this.lines.remove(line2);
            this.boundChanged();
            this.fireFigureLayoutUpated();
            this.fireFigureRemoved(otherwiseFigure);
            this.fireLineRemoved(line1);
            this.fireLineRemoved(line2);
            line1 = null;
            line2 = null;
        }
    }
    public void removeFigure(Figure figure) {
        if (figure instanceof CaseFigure) {
            this.removeCaseFigure((CaseFigure) figure);
        } else if (figure instanceof OtherwiseFigure) {
            this.removeOtherwiseFigure((OtherwiseFigure) figure);
        }
    }
    public void translate(int dx, int dy) {
        this.x += dx;
        this.y += dy;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure element = (Figure) iter.next();
            element.translate(dx, dy);
        }
        for (Iterator iter = this.lines.iterator(); iter.hasNext();) {
            Line element = (Line) iter.next();
            element.translate(dx, dy);
        }
        if (this.end != null) {
            this.end.translate(dx, dy);
        }
        this.fireFigureLayoutUpated();
    }
    protected Rectangle getStructBound() {
        return null;
    }
    public int getStructHeight() {
        if (this.structHeight == 0) {
            this.heightRecalculate();
        }
        return structHeight;
    }
    public int getStructWidth() {
        if (this.structWidth == 0) {
            this.widthRecalculate();
        }
        return structWidth;
    }
    public void setLayout() {
        this.end.setX(this.x);
        this.end.setY(this.y + this.getStructHeight() - this.end.height);
        int childFigureX = this.x - this.getStructWidth() / 2
                + StructFigure.BORDER_WIDTH;
        int childFigureY = this.y + this.getHeight() + Line.LINE_HEIGHT * 2;
        for (int i = 0; i < this.figures.size(); i++) {
                        Figure figure = (Figure) this.figures.get(i);
            figure.setX(childFigureX + figure.getStructWidth() / 2);
            figure.setY(childFigureY);
            if (figure instanceof StructFigure) {
                ((StructFigure) figure).setLayout();
            }
            childFigureX += figure.getStructWidth()
                    + StructFigure.HORIZONTAL_INTERVAL;
                        Line line1 = (Line) this.lines.get(i * 2);
            line1.reset();
            line1.setSource(this);
            line1.setTarget(figure);
            Point sPoint1 = (Point) line1.getPoints().get(0);
            Point tPoint1 = (Point) line1.getPoints().get(
                    line1.getPoints().size() - 1);
            line1.getPoints().add(1,
                    new Point(sPoint1.x, sPoint1.y + Line.LINE_HEIGHT));
            line1.getPoints().add(2,
                    new Point(tPoint1.x, tPoint1.y - Line.LINE_HEIGHT));
            Line line2 = (Line) this.lines.get(i * 2 + 1);
            line2.reset();
            if (figure instanceof CaseFigure) {
                line2.setSource(((CaseFigure) figure).getSoleChildFigure());
            } else if (figure instanceof OtherwiseFigure) {
                line2
                        .setSource(((OtherwiseFigure) figure)
                                .getSoleChildFigure());
            }
            line2.setTarget(this.end);
            Point sPoint2 = (Point) line2.getPoints().get(0);
            Point tPoint2 = (Point) line2.getPoints().get(
                    line2.getPoints().size() - 1);
            line2.getPoints().add(1,
                    new Point(sPoint2.x, tPoint2.y - Line.LINE_HEIGHT));
            line2.getPoints().add(2,
                    new Point(tPoint2.x, tPoint2.y - Line.LINE_HEIGHT));
        }
    }
    public void heightRecalculate() {
        this.structHeight = 0;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure figure = (Figure) iter.next();
            if (this.structHeight < figure.getStructHeight()) {
                this.structHeight = figure.getStructHeight();
            }
        }
        this.structHeight += this.height + this.end.getHeight()
                + Line.LINE_HEIGHT * 4;
    }
    public void widthRecalculate() {
        this.structWidth = (this.figures.size() - 1)
                * StructFigure.HORIZONTAL_INTERVAL;
        for (Iterator iter = this.figures.iterator(); iter.hasNext();) {
            Figure figure = (Figure) iter.next();
            this.structWidth += figure.getStructWidth();
        }
        this.structWidth = Math.max(this.structWidth, this.width);
        this.structWidth += StructFigure.BORDER_WIDTH * 2;
    }
    
    public List getFirstChilds() {
        List figureList = new Vector();
        for (Iterator iter = this.cases.iterator(); iter.hasNext();) {
            CaseFigure caseFigure = (CaseFigure) iter.next();
            figureList.addAll(caseFigure.getFirstChilds());
        }
        if (this.otherwise != null) {
            if (otherwise.getFigures().size() == 1) {
                figureList.addAll(otherwise.getFirstChilds());
            }
        }
        return figureList;
    }
}
