
package org.act.wsc.bpel4wsmodeling.projectdata.process;
import java.awt.Rectangle;
import org.act.metaset.Metaset;
import java.util.List;
import java.util.Vector;

public class WhileFigure extends StructFigure {
    public WhileFigure(boolean vacancy) {
        super();
    }
    public WhileFigure() {
        super(Figure.LABLE_WHILE);
        init();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
    }
    public WhileFigure(int x, int y) {
        super(x, y, Figure.LABLE_WHILE);
        init();
        this.structWidth = this.getStructWidth();
        this.structHeight = this.getStructHeight();
        this.setLayout();
    }
    private void init() {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        NominalFigure nominalFigure = new NominalFigure();
        this.figures.add(nominalFigure);
        nominalFigure.setParent(this);
        nominalFigure.setOwner(this.getOwner());
        Line line1 = new Line();
        Line line2 = new Line();
        this.lines.add(line1);
        this.lines.add(line2);
    }
    public WhileFigure(Metaset ss, List figures) {
        super(ss);
        init(ss, figures);
    }
    private void init(Metaset ss, List figures) {
        this.end = new JoinendFigure();
        this.end.setParent(this);
        this.end.setOwner(this.getOwner());
        if (figures.size() > 0) {
            Figure f = (Figure) figures.get(0);
            this.figures.add(f);
            f.setParent(this);
            f.setOwner(this.getOwner());
        } else {
            NominalFigure nominalFigure = new NominalFigure();
            this.figures.add(nominalFigure);
            nominalFigure.setParent(this);
            nominalFigure.setOwner(this.getOwner());
        }
        Line line1 = new Line();
        this.lines.add(line1);
        Line line2 = new Line();
        this.lines.add(line2);
    }
    public void removeFigure(Figure figure) {
        if (this.figures.size() == 1 && this.figures.get(0).equals(figure)) {
            this.figures.clear();
            this.fireFigureRemoved(figure);
            NominalFigure nominalFigure = new NominalFigure();
                        nominalFigure.setOwner(figure.getOwner());
            nominalFigure.setParent(figure.getParent());
            this.figures.add(nominalFigure);
            this.boundChanged();
            this.fireFigureAdded(nominalFigure);
            this.fireFigureLayoutUpated();
        }
    }
    public void translate(int dx, int dy) {
        this.x += dx;
        this.y += dy;
        if (!this.figures.isEmpty()) {
            ((Figure) this.figures.get(0)).translate(dx, dy);
            ((Line) this.lines.get(0)).translate(dx, dy);
            ((Line) this.lines.get(1)).translate(dx, dy);
        }
        if (this.end != null) {
            this.end.translate(dx, dy);
        }
        this.fireFigureLayoutUpated();
    }
    protected Rectangle getStructBound() {
        return null;
    }
    public int getStructHeight() {
        if (this.structHeight == 0) {
            this.heightRecalculate();
        }
        return this.structHeight;
    }
    public int getStructWidth() {
        if (this.structWidth == 0) {
            this.widthRecalculate();
        }
        return this.structWidth;
    }
    public void setLayout() {
        this.end.setX(this.x);
        this.end.setY(this.y + this.getStructHeight() - this.end.getHeight());
        if (!this.figures.isEmpty() && !this.lines.isEmpty()) {
            Figure figure = (Figure) this.figures.get(0);
            Line line1 = (Line) this.lines.get(0);
            Line line2 = (Line) this.lines.get(1);
            line1.reset();
            line2.reset();
            figure.setX(this.x);
            figure.setY(this.y + this.height + Line.LINE_HEIGHT);
            if (figure instanceof StructFigure) {
                ((StructFigure) figure).setLayout();
            }
            line1.setSource(this);
            line1.setTarget(figure);
            if (figure instanceof StructFigure
                    && ((StructFigure) figure).getEnd() != null) {
                line2.setSource(((StructFigure) figure).getEnd());
            } else {
                line2.setSource(figure);
            }
            line2.setTarget(this.end);
        }
        this.fireFigureLayoutUpated();
    }
    public void heightRecalculate() {
        this.structHeight = this.height;
        if (!this.figures.isEmpty() && !this.lines.isEmpty()) {
            this.structHeight += ((Figure) this.figures.get(0))
                    .getStructHeight()
                    + Line.LINE_HEIGHT * 2;
        }
        this.structHeight += this.end.getHeight();
    }
    public void widthRecalculate() {
        this.structWidth = this.width;
        if (!this.figures.isEmpty()) {
            this.structWidth = Math.max(((Figure) this.figures.get(0))
                    .getStructWidth(), this.structWidth);
        }
        this.structWidth += StructFigure.BORDER_WIDTH * 2;
    }
    public List getFirstChilds() {
        List figureList = new Vector();
        if (this.figures.size() == 1
                && !(this.figures instanceof NominalFigure)) {
            figureList.add(this.figures.get(0));
        }
        return figureList;
    }
    public void addFigure(Figure figure) {
    }
}
