
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.wsdl.BindingFault;
import javax.wsdl.BindingInput;
import javax.wsdl.BindingOperation;
import javax.wsdl.BindingOutput;
import javax.wsdl.Operation;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.xml.namespace.QName;
import org.w3c.dom.Element;

public class BindingOperationEx extends WSDLLabel implements IDerivedLabel,
        BindingOperation {
    public static int timer=0;
    
    String name = null;
    OperationEx operationEx = null;
    Map bindingFaults = new HashMap();
    BindingInputEx bindingInputEx = null;
    BindingOutputEx bindingOutputEx = null;
    List extensibilityElements = new Vector();
    public static final String ATT_NAME = "name";
    
    public BindingOperationEx() {
        super();
    }
    
    
    public boolean addChild(WSDLLabel childLabel) {
        return false;
    }
    
    public boolean removeChild(WSDLLabel childLabel) {
        if (childLabel instanceof BindingFaultEx) {
            this.removeBindingFault((BindingFault) childLabel);
            return true;
        }
        if (childLabel instanceof BindingInputEx) {
            this.removeBindingInput((BindingInputEx) childLabel);
            return true;
        }
        if (childLabel instanceof BindingOutputEx) {
            this.removeBindingOutput((BindingOutputEx) childLabel);
            return true;
        }
        if (childLabel instanceof ExtensibilityElementEx) {
            this.removeExtensibilityElement((ExtensibilityElement) childLabel);
            return true;
        }
        return false;
    }
    
    
    
    public void addBindingFault(BindingFault bindingFault) {
        
        if (bindingFault instanceof BindingFaultEx) {
            BindingFaultEx new_name = (BindingFaultEx) bindingFault;
            this.bindingFaults.put(new_name.getName(), bindingFault);
            new_name.setBindingOperationEx(this);
            this.fireChildAdded(new_name);
        }
    }
    
    public void removeBindingFault(BindingFault bindingFault) {
        this.bindingFaults.remove(bindingFault.getName());
        if (bindingFault instanceof BindingFaultEx) {
            BindingFaultEx new_name = (BindingFaultEx) bindingFault;
            this.fireChildRemoved(new_name);
        }
    }
    
    public void addExtensibilityElement(
            ExtensibilityElement extensibilityElement) {
        this.extensibilityElements.add(extensibilityElement);
        if (extensibilityElement instanceof ExtensibilityElementEx) {
            ExtensibilityElementEx new_name = (ExtensibilityElementEx) extensibilityElement;
            this.fireChildAdded(new_name);
        }
    }
    
    public void removeExtensibilityElement(
            ExtensibilityElement extensibilityElement) {
        this.extensibilityElements.remove(extensibilityElement);
        if (extensibilityElement instanceof ExtensibilityElementEx) {
            ExtensibilityElementEx new_name = (ExtensibilityElementEx) extensibilityElement;
            this.fireChildRemoved(new_name);
        }
    }
    
    public BindingFault getBindingFault(String faultName) {
        return (BindingFault) this.bindingFaults.get(faultName);
    }
    
    public Map getBindingFaults() {
        return this.bindingFaults;
    }
    
    public BindingInput getBindingInput() {
        return this.bindingInputEx;
    }
    
    public BindingOutput getBindingOutput() {
        return this.bindingOutputEx;
    }
    
    public Element getDocumentationElement() {
                return null;
    }
    
    public List getExtensibilityElements() {
        
        return this.extensibilityElements;
    }
    
    public Operation getOperation() {
        return this.operationEx;
    }
    
    public void setBindingInput(BindingInput bindingInput) {
            this.bindingInputEx = (BindingInputEx) bindingInput;
    }
    
    public void addBindingInput(BindingInputEx bindingInputEx) {
        if (this.bindingInputEx == null) {
            this.setBindingInput(bindingInputEx);
                       this.fireChildAdded(bindingInputEx);
        }
    }
    
    public void removeBindingInput(BindingInputEx bindingInputEx) {
        if (this.bindingInputEx != null
                && this.bindingInputEx.equals(bindingInputEx)) {
            this.setBindingInput(null);
            this.fireChildRemoved(bindingInputEx);
        }
    }
    
    public void setBindingOutput(BindingOutput bindingOutput) {
        
            this.bindingOutputEx = (BindingOutputEx) bindingOutput;
    }
    public void addBindingOutput(BindingOutputEx bindingOutputEx) {
        if (this.bindingOutputEx == null) {
            this.setBindingOutput(bindingOutputEx);
            this.fireChildAdded(bindingOutputEx);
        }
    }
    public void removeBindingOutput(BindingOutputEx bindingOutputEx) {
        if (this.bindingOutputEx != null
                && this.bindingOutputEx.equals(bindingOutputEx)) {
            this.setBindingOutput(null);
            this.fireChildRemoved(bindingOutputEx);
        }
    }
    
    public void setDocumentationElement(Element arg0) {
            }
    
    public void setOperation(Operation operation) {
        if (operation instanceof OperationEx||operation==null) {
            this.operationEx = (OperationEx) operation;
        }
    }
    
    public String getName() {
        if (this.name == null) {
            this.name = this.getLabelName();
        }
        return this.name;
    }
    
    public void setName(String name) {
        this.name = name;
        this.firePropertyChanged(this);
    }
    public void reName(String newName) {
        if(newName==null){
            return;
        }
        String oldName = this.getName();
        
        if (!newName.equals(oldName)) {
            this.setName(newName);
            this.fireChildRenamed(this);
        }
    }
    
    public Object getExtensionAttribute(QName arg0) {
                return null;
    }
    
    public Map getExtensionAttributes() {
                return null;
    }
    
    public List getNativeAttributeNames() {
                return null;
    }
    
    public void setExtensionAttribute(QName arg0, Object arg1) {
                
    }
}
