
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util;
import java.io.File;
import java.io.IOException;
import javax.wsdl.Fault;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.Combiner;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ExtensibilityElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.FaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlEncoded;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlReplacement;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ImportEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.InputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEMultipartRelated;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEPart;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEXml;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MessageEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PartEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBody;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPFault;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPHeader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ServiceEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.TypesEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

public class WSDLReader {
    DefinitionEx definitionEx = null;
    Document docWSDL = null;
        
    public WSDLReader(File file) {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        try {
            db = dbf.newDocumentBuilder();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            docWSDL = db.parse(file);
        } catch (SAXException e1) {
                        e1.printStackTrace();
        } catch (IOException e1) {
                        e1.printStackTrace();
        }
        if (docWSDL.getElementsByTagName(WSDLLabel.DEFINITION).getLength() == 1) {
            this.definitionEx = new DefinitionEx();
        }
    }
    public DefinitionEx readWSDL() {
        createDefinition();
        return definitionEx;
    }
    private void createDefinition() {
        if (this.definitionEx != null) {
                        Element definitionNode = (Element) docWSDL.getElementsByTagName(
                    WSDLLabel.DEFINITION).item(0);
                        for (int i = 0; i < definitionNode.getAttributes().getLength(); i++) {
                Node attNode = definitionNode.getAttributes().item(i);
                if (attNode.getNodeName().equals(DefinitionEx.ATT_NAME)) {
                    definitionEx.setQName(new QName(attNode.getNodeValue()));
                } else if (attNode.getNodeName().equals(
                        DefinitionEx.ATT_TARGET_NS)) {
                    definitionEx.setTargetNamespace(attNode.getNodeValue());
                } else {
                    definitionEx.addNamespace(NSprefixRegular(attNode.getNodeName()),
                            attNode.getNodeValue());
                }
            }
            this.createImport();
            this.createTypes();
            this.createMessage();
            this.createPortType();
            this.createBinding();
            this.createService();
        }
    }
    
    private void createImport() {
        for (int i = 0; i < docWSDL.getElementsByTagName(WSDLLabel.IMPORT)
                .getLength(); i++) {
            Element element = (Element) docWSDL.getElementsByTagName(
                    WSDLLabel.IMPORT).item(i);
            ImportEx importEx = (ImportEx) definitionEx.createImport();
                        for (int j = 0; j < element.getAttributes().getLength(); j++) {
                Node attNode = element.getAttributes().item(j);
                if (attNode.getNodeName().equals(ImportEx.ATT_NS)) {
                    importEx.setNamespaceURI(attNode.getNodeValue());
                } else if (attNode.getNodeName().equals(ImportEx.ATT_LOC_URL)) {
                    importEx.setLocationURI(attNode.getNodeValue());
                }
            }
            definitionEx.addImport(importEx);
        }
    }
    
    private void createTypes() {
        if (docWSDL.getElementsByTagName(WSDLLabel.TYPES).getLength() == 1) {
            Element element = (Element) docWSDL.getElementsByTagName(
                    WSDLLabel.TYPES).item(0);
            TypesEx typesEx = (TypesEx) definitionEx.createTypes();
            definitionEx.addTypes(typesEx);
            this.createSchema(typesEx);
        }
    }
    
    private void createSchema(TypesEx typesEx) {
        for (int i = 0; i < docWSDL.getElementsByTagName(WSDLLabel.SCHEMA)
                .getLength(); i++) {
            Element element = (Element) docWSDL.getElementsByTagName(
                    WSDLLabel.SCHEMA).item(i);
            SchemaEx schemaEx = (SchemaEx) definitionEx.createSchema();
            for (int j = 0; j < element.getAttributes().getLength(); j++) {
                Node node = element.getAttributes().item(j);
                if (node.getNodeName().equals(SchemaEx.ATT_TNS)) {
                    schemaEx.setTargetNamespace(node.getNodeValue());
                } else {
                    schemaEx.addNamespace(NSprefixRegular(node.getNodeName()), node
                            .getNodeValue());
                }
            }
            typesEx.addExtensibilityElement(schemaEx);
            for (int j = 0; j < element.getChildNodes().getLength(); j++) {
                Node node = element.getChildNodes().item(j);
                if (node.getNodeName().equals(WSDLLabel.SIMPLE_TYPE)) {
                    schemaEx.addSimpleType(this
                            .createSimpleType(schemaEx, node));
                } else if (node.getNodeName().equals(WSDLLabel.COMPLEX_TYPE)) {
                    schemaEx.addComplexType(this.createComplexType(schemaEx,
                            node));
                } else if (node.getNodeName().equals(WSDLLabel.ELEMENT)) {
                    schemaEx.addElement(this.createElement(schemaEx, node));
                }
            }
        }
    }
    
    private SimpleTypeEx createSimpleType(WSDLLabel label, Node node) {
        SimpleTypeEx simpleTypeEx = label.getDefinitionEx().createSimpleType();
                for (int j = 0; j < node.getAttributes().getLength(); j++) {
            Node attNode = node.getAttributes().item(j);
            if (attNode.getNodeName().equals(SimpleTypeEx.ATT_NAME)) {
                simpleTypeEx.setName(attNode.getNodeValue());
            }
        }
                for (int j = 0; j < node.getChildNodes().getLength(); j++) {
            Element cnode = (Element) node.getChildNodes().item(j);
            if (cnode.getNodeName().equals(SimpleTypeEx.CHILD_RETR)) {
                simpleTypeEx.setKind(SimpleTypeEx.KIND_ATOMIC);
                simpleTypeEx.setBaseType(cnode
                        .getAttribute(SimpleTypeEx.ATT_BASE));
            } else if (cnode.getNodeName().equals(SimpleTypeEx.KIND_LIST)) {
                simpleTypeEx.setKind(SimpleTypeEx.KIND_LIST);
                simpleTypeEx.setItemType(cnode
                        .getAttribute(SimpleTypeEx.ATT_ITEM));
            } else if (cnode.getNodeName().equals(SimpleTypeEx.KIND_UNION)) {
                simpleTypeEx.setKind(SimpleTypeEx.KIND_UNION);
                simpleTypeEx.setMemberTypes(cnode
                        .getAttribute(SimpleTypeEx.ATT_MEMBER));
            }
        }
        return simpleTypeEx;
    }
    
    private ComplexTypeEx createComplexType(WSDLLabel label, Node node) {
        ComplexTypeEx complexTypeEx = label.getDefinitionEx()
                .createComplexType();
                for (int j = 0; j < node.getAttributes().getLength(); j++) {
            Node attNode = node.getAttributes().item(j);
            if (attNode.getNodeName().equals(SimpleTypeEx.ATT_NAME)) {
                complexTypeEx.setName(attNode.getNodeValue());
            }
        }
                this.createCombiner(complexTypeEx, node);
        return complexTypeEx;
    }
    
    private void createCombiner(ComplexTypeEx complexTypeEx, Node node) {
        for (int i = 0; i < node.getChildNodes().getLength(); i++) {
            Node cnode = node.getChildNodes().item(i);
            if (cnode.getNodeName().equals(WSDLLabel.COMB_ALL)
                    || cnode.getNodeName().equals(WSDLLabel.COMB_CHOICE)
                    || cnode.getNodeName().equals(WSDLLabel.COMB_SEQ)) {
                                                complexTypeEx.addCombiner(cnode.getNodeName());
                Combiner combiner = complexTypeEx.getCombiner();
                                for (int j = 0; j < cnode.getChildNodes().getLength(); j++) {
                    Node ccnode = cnode.getChildNodes().item(j);
                    if (ccnode.getNodeName().equals(WSDLLabel.ELEMENT)) {
                        combiner.addElement(this
                                .createElement(combiner, ccnode));
                    }
                }
            }
        }
    }
    
    private ElementEx createElement(WSDLLabel label, Node node) {
        ElementEx elementEx = label.getDefinitionEx().createElement();
                for (int j = 0; j < node.getAttributes().getLength(); j++) {
            Node attNode = node.getAttributes().item(j);
            if (attNode.getNodeName().equals(ElementEx.ATT_NAME)) {
                elementEx.setName(attNode.getNodeValue());
            } else if (attNode.getNodeName().equals(ElementEx.ATT_TYPE)) {
                elementEx.setTypeEx(attNode.getNodeValue());
            }
        }
                for (int j = 0; j < node.getChildNodes().getLength(); j++) {
            Node cnode = node.getChildNodes().item(j);
            if (cnode.getNodeName().equals(WSDLLabel.SIMPLE_TYPE)) {
                elementEx.addTypeEx(this.createSimpleType(elementEx, cnode));
            } else if (cnode.getNodeName().equals(WSDLLabel.COMPLEX_TYPE)) {
                elementEx.addTypeEx(this.createComplexType(elementEx, cnode));
            }
        }
        return elementEx;
    }
    
    private void createMessage() {
        for (int i = 0; i < docWSDL.getElementsByTagName(WSDLLabel.MESSAGE)
                .getLength(); i++) {
            Element element = (Element) docWSDL.getElementsByTagName(
                    WSDLLabel.MESSAGE).item(i);
            MessageEx messageEx = (MessageEx) definitionEx.createMessage();
                        for (int j = 0; j < element.getAttributes().getLength(); j++) {
                Node attNode = element.getAttributes().item(j);
                if (attNode.getNodeName().equals(MessageEx.ATT_NAME)) {
                    messageEx.setQName(definitionEx.StringToQName(attNode
                            .getNodeValue()));
                }
            }
            definitionEx.addMessage(messageEx);
            this.createPart(messageEx, element);
        }
    }
    
    private void createPart(MessageEx messageEx, Element element) {
        for (int i = 0; i < element.getChildNodes().getLength(); i++) {
            Node node = element.getChildNodes().item(i);
            if (node.getNodeName().equals(WSDLLabel.PART)) {
                PartEx partEx = (PartEx) messageEx.getDefinitionEx()
                        .createPart();
                                for (int j = 0; j < node.getAttributes().getLength(); j++) {
                    Node attNode = node.getAttributes().item(j);
                    if (attNode.getNodeName().equals(PartEx.ATT_NAME)) {
                        partEx.setName(attNode.getNodeValue());
                    } else if (attNode.getNodeName().equals(PartEx.ATT_ELEMENT)) {
                        partEx.setElementName(definitionEx
                                .StringToQName(attNode.getNodeValue()));
                    } else if (attNode.getNodeName().equals(PartEx.ATT_TYPE)) {
                        partEx.setTypeName(definitionEx.StringToQName(attNode
                                .getNodeValue()));
                    }
                }
                messageEx.addPart(partEx);
            }
        }
    }
    
    private void createPortType() {
        for (int i = 0; i < docWSDL.getElementsByTagName(WSDLLabel.PORTTYPE)
                .getLength(); i++) {
            Element element = (Element) docWSDL.getElementsByTagName(
                    WSDLLabel.PORTTYPE).item(i);
            PortTypeEx portTypeEx = (PortTypeEx) definitionEx.createPortType();
                        for (int j = 0; j < element.getAttributes().getLength(); j++) {
                Node attNode = element.getAttributes().item(j);
                if (attNode.getNodeName().equals(PortTypeEx.ATT_NAME)) {
                    portTypeEx.setQName(definitionEx.StringToQName(attNode
                            .getNodeValue()));
                }
            }
            definitionEx.addPortType(portTypeEx);
            this.createOperation(portTypeEx, element);
        }
    }
    
    private void createOperation(PortTypeEx portTypeEx, Element element) {
        for (int i = 0; i < element.getChildNodes().getLength(); i++) {
            Node node = element.getChildNodes().item(i);
            if (node.getNodeName().equals(WSDLLabel.OPERATION)) {
                OperationEx operationEx = (OperationEx) portTypeEx
                        .getDefinitionEx().createOperation();
                                for (int j = 0; j < node.getAttributes().getLength(); j++) {
                    Node attNode = node.getAttributes().item(j);
                    if (attNode.getNodeName().equals(OperationEx.ATT_NAME)) {
                        operationEx.setName(attNode.getNodeValue());
                    }
                }
                portTypeEx.addOperation(operationEx);
                for (int k = 0; k < node.getChildNodes().getLength(); k++) {
                    Node cnode = node.getChildNodes().item(k);
                    if (cnode.getNodeName().equals(WSDLLabel.INPUT)) {
                        operationEx.addInput(this.createInput(operationEx,
                                cnode));
                    } else if (cnode.getNodeName().equals(WSDLLabel.OUTPUT)) {
                        operationEx.addOutput(this.createOutput(operationEx,
                                cnode));
                    } else if (cnode.getNodeName().equals(WSDLLabel.FAULT)) {
                        operationEx.addFault(this.createFault(operationEx,
                                cnode));
                    }
                }
            }
        }
    }
    
    private InputEx createInput(OperationEx operationEx, Node cnode) {
        InputEx inputEx = (InputEx) operationEx.getDefinitionEx().createInput();
                for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
            Node attNode = cnode.getAttributes().item(j);
            if (attNode.getNodeName().equals(InputEx.ATT_NAME)) {
                inputEx.setName(attNode.getNodeValue());
            } else if (attNode.getNodeName().equals(InputEx.ATT_MESSAGE)) {
                inputEx.setMessage(inputEx.getDefinitionEx().getMessage(
                        definitionEx.StringToQName(attNode.getNodeValue())));
            }
        }
        return inputEx;
    }
    
    private OutputEx createOutput(OperationEx operationEx, Node node) {
        OutputEx outputEx = (OutputEx) operationEx.getDefinitionEx()
                .createOutput();
                for (int j = 0; j < node.getAttributes().getLength(); j++) {
            Node attNode = node.getAttributes().item(j);
            if (attNode.getNodeName().equals(OutputEx.ATT_NAME)) {
                outputEx.setName(attNode.getNodeValue());
            }
            if (attNode.getNodeName().equals(OutputEx.ATT_MESSAGE)) {
                outputEx.setMessage(outputEx.getDefinitionEx().getMessage(
                        definitionEx.StringToQName(attNode.getNodeValue())));
            }
        }
        return outputEx;
    }
    
    private Fault createFault(OperationEx operationEx, Node node) {
        FaultEx faultEx = (FaultEx) operationEx.getDefinitionEx().createFault();
                for (int j = 0; j < node.getAttributes().getLength(); j++) {
            Node attNode = node.getAttributes().item(j);
            if (attNode.getNodeName().equals(FaultEx.ATT_NAME)) {
                faultEx.setName(attNode.getNodeValue());
            } else if (attNode.getNodeName().equals(FaultEx.ATT_MESSAGE)) {
                faultEx.setMessage(faultEx.getDefinitionEx().getMessage(
                        definitionEx.StringToQName(attNode.getNodeValue())));
            }
        }
        return faultEx;
    }
    
    private void createBinding() {
        for (int i = 0; i < docWSDL.getElementsByTagName(WSDLLabel.BINDING)
                .getLength(); i++) {
            Element element = (Element) docWSDL.getElementsByTagName(
                    WSDLLabel.BINDING).item(i);
            BindingEx bindingEx = (BindingEx) definitionEx.createBinding();
                        for (int j = 0; j < element.getAttributes().getLength(); j++) {
                Node attNode = element.getAttributes().item(j);
                if (attNode.getNodeName().equals(BindingEx.ATT_NAME)) {
                    bindingEx.setQName(definitionEx.StringToQName(attNode
                            .getNodeValue()));
                } else if (attNode.getNodeName().equals(BindingEx.ATT_TYPE)) {
                    bindingEx.setPortType(bindingEx.getDefinitionEx()
                            .getPortType(
                                    definitionEx.StringToQName(attNode
                                            .getNodeValue())));
                }
            }
            definitionEx.addBinding(bindingEx);
            this.createBindingOperation(bindingEx, element);
            this.createExtensibilityElement(bindingEx, element);
        }
    }
    
    private void createBindingOperation(BindingEx bindingEx, Element element) {
        for (int i = 0; i < element.getChildNodes().getLength(); i++) {
            Node node = element.getChildNodes().item(i);
            if (node.getNodeName().equals(WSDLLabel.OPERATION)) {
                BindingOperationEx operationEx = (BindingOperationEx) bindingEx
                        .getDefinitionEx().createBindingOperation();
                                for (int j = 0; j < node.getAttributes().getLength(); j++) {
                    Node attNode = node.getAttributes().item(j);
                    if (attNode.getNodeName().equals(
                            BindingOperationEx.ATT_NAME)) {
                        operationEx.setName(attNode.getNodeValue());
                        if (bindingEx.getPortType() != null) {
                            operationEx.setOperation(((PortTypeEx) bindingEx
                                    .getPortType()).getOperation(operationEx
                                    .getName(), null, null));
                        }
                    }
                }
                bindingEx.addBindingOperation(operationEx);
                this.createExtensibilityElement(operationEx, node);
                for (int k = 0; k < node.getChildNodes().getLength(); k++) {
                    Node cnode = node.getChildNodes().item(k);
                    if (cnode.getNodeName().equals(WSDLLabel.BINDING_INPUT)) {
                        this.createBindingInput(operationEx, cnode);
                    } else if (cnode.getNodeName().equals(
                            WSDLLabel.BINDING_OUTPUT)) {
                        this.createBindingOutput(operationEx, cnode);
                    } else if (cnode.getNodeName().equals(
                            WSDLLabel.BINDING_FAULT)) {
                        this.createBindingFault(operationEx, cnode);
                    }
                }
            }
        }
    }
    
    private void createBindingInput(BindingOperationEx operationEx, Node cnode) {
        BindingInputEx inputEx = (BindingInputEx) operationEx.getDefinitionEx()
                .createBindingInput();
                for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
            Node attNode = cnode.getAttributes().item(j);
            if (attNode.getNodeName().equals(BindingInputEx.ATT_NAME)) {
                inputEx.setName(attNode.getNodeValue());
            }
        }
        operationEx.addBindingInput(inputEx);
        this.createExtensibilityElement(inputEx, cnode);
    }
    
    private void createBindingOutput(BindingOperationEx operationEx, Node cnode) {
        BindingOutputEx outputEx = (BindingOutputEx) operationEx
                .getDefinitionEx().createBindingOutput();
                for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
            Node attNode = cnode.getAttributes().item(j);
            if (attNode.getNodeName().equals(BindingOutputEx.ATT_NAME)) {
                outputEx.setName(attNode.getNodeValue());
            }
        }
        operationEx.addBindingOutput(outputEx);
        this.createExtensibilityElement(outputEx, cnode);
    }
    
    private void createBindingFault(BindingOperationEx operationEx, Node cnode) {
        BindingFaultEx faultEx = (BindingFaultEx) operationEx.getDefinitionEx()
                .createBindingFault();
                for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
            Node attNode = cnode.getAttributes().item(j);
            if (attNode.getNodeName().equals(FaultEx.ATT_NAME)) {
                faultEx.setName(attNode.getNodeValue());
            }
        }
        operationEx.addBindingFault(faultEx);
        this.createExtensibilityElement(faultEx, cnode);
    }
    
    private void createExtensibilityElement(WSDLLabel label, Node node) {
        if (label instanceof BindingEx) {
            for (int i = 0; i < node.getChildNodes().getLength(); i++) {
                Node cnode = node.getChildNodes().item(i);
                if (cnode.getNodeName().equals(WSDLLabel.SOAP_BINDING)) {
                    label.getDefinitionEx().setBindingType(
                            DefinitionEx.BINDING_TYPE_SOAP);
                    SOAPBinding binding = label.getDefinitionEx()
                            .createSOAPBinding();
                                        for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                        Node attNode = cnode.getAttributes().item(j);
                        if (attNode.getNodeName().equals(SOAPBinding.ATT_STYLE)) {
                            binding.setStyle(attNode.getNodeValue());
                        } else if (attNode.getNodeName().equals(
                                SOAPBinding.ATT_TRAN)) {
                            binding.setTransport(attNode.getNodeValue());
                        }
                    }
                    ((BindingEx) label).addExtensibilityElement(binding);
                } else if (cnode.getNodeName().equals(WSDLLabel.HTTP_BINDING)) {
                    label.getDefinitionEx().setBindingType(
                            DefinitionEx.BINDING_TYPE_HTTP);
                    HTTPBinding binding = label.getDefinitionEx()
                            .createHTTPBinding();
                                        for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                        Node attNode = cnode.getAttributes().item(j);
                        if (attNode.getNodeName().equals(HTTPBinding.ATT_VERB)) {
                            binding.setVerb(attNode.getNodeValue());
                        }
                    }
                    ((BindingEx) label).addExtensibilityElement(binding);
                }
            }
        }
        if (label instanceof BindingOperationEx) {
            for (int i = 0; i < node.getChildNodes().getLength(); i++) {
                Node cnode = node.getChildNodes().item(i);
                if (cnode.getNodeName().equals(WSDLLabel.SOAP_OPER)) {
                    SOAPOperation operation = label.getDefinitionEx()
                            .createSOAPOperation();
                                        for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                        Node attNode = node.getAttributes().item(j);
                        if (attNode.getNodeName().equals(
                                SOAPOperation.ATT_ACTION)) {
                            operation.setSoapAction(attNode.getNodeValue());
                        } else if (attNode.getNodeName().equals(
                                SOAPOperation.ATT_STYLE)) {
                            operation.setStyle(attNode.getNodeValue());
                        }
                    }
                    ((BindingOperationEx) label)
                            .addExtensibilityElement(operation);
                } else if (cnode.getNodeName().equals(WSDLLabel.HTTP_OPER)) {
                    HTTPOperation operation = label.getDefinitionEx()
                            .createHTTPOperation();
                                        for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                        Node attNode = node.getAttributes().item(j);
                        if (attNode.getNodeName().equals(HTTPOperation.ATT_LOC)) {
                            operation.setLocation(attNode.getNodeValue());
                        }
                    }
                    ((BindingOperationEx) label)
                            .addExtensibilityElement(operation);
                }
            }
        }
        if (label instanceof BindingInputEx || label instanceof BindingOutputEx) {
            ExtensibilityElementEx elementEx = this
                    .createExtensibilityForInOut(label, node);
            if (elementEx != null) {
                if (label instanceof BindingInputEx) {
                    ((BindingInputEx) label).addExtensibilityElement(elementEx);
                } else if (label instanceof BindingOutputEx) {
                    ((BindingOutputEx) label)
                            .addExtensibilityElement(elementEx);
                }
            }
        }
        if (label instanceof BindingFaultEx) {
            for (int i = 0; i < node.getChildNodes().getLength(); i++) {
                Node cnode = node.getChildNodes().item(i);
                if (cnode.getNodeName().equals(WSDLLabel.SOAP_FAULT)) {
                    SOAPFault fault = label.getDefinitionEx().createSOAPFault();
                                        for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                        Node attNode = cnode.getAttributes().item(j);
                        if (attNode.getNodeName().equals(SOAPFault.ATT_NAME)) {
                            fault.setName(attNode.getNodeValue());
                        } else if (attNode.getNodeName().equals(
                                SOAPFault.ATT_USE)) {
                            fault.setUse(attNode.getNodeValue());
                        } else if (attNode.getNodeName().equals(
                                SOAPFault.ATT_ENC_STYLE)) {
                            fault.setEncodingStyle(attNode.getNodeValue());
                        } else if (attNode.getNodeName().equals(
                                SOAPFault.ATT_NS)) {
                            fault.setNamespace(attNode.getNodeValue());
                        }
                    }
                    ((BindingFaultEx) label).addExtensibilityElement(fault);
                }
            }
        }
        if (label instanceof PortEx) {
            for (int i = 0; i < node.getChildNodes().getLength(); i++) {
                Node cnode = node.getChildNodes().item(i);
                if (cnode.getNodeName().equals(WSDLLabel.SOAP_ADDR)) {
                    SOAPAddress address = label.getDefinitionEx()
                            .createSOAPAddress();
                                        for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                        Node attNode = node.getAttributes().item(j);
                        if (attNode.getNodeName().equals(SOAPAddress.ATT_LOC)) {
                            address.setLocation(attNode.getNodeValue());
                        }
                    }
                    ((PortEx) label).addExtensibilityElement(address);
                } else if (cnode.getNodeName().equals(WSDLLabel.HTTP_ADDR)) {
                    HTTPAddress address = label.getDefinitionEx()
                            .createHTTPAddress();
                                        for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                        Node attNode = node.getAttributes().item(j);
                        if (attNode.getNodeName().equals(HTTPAddress.ATT_LOC)) {
                            address.setLocation(attNode.getNodeValue());
                        }
                    }
                    ((PortEx) label).addExtensibilityElement(address);
                }
            }
        }
    }
    
    private ExtensibilityElementEx createExtensibilityForInOut(WSDLLabel label,
            Node node) {
        ExtensibilityElementEx elementEx = null;
        for (int i = 0; i < node.getChildNodes().getLength(); i++) {
            Node cnode = node.getChildNodes().item(i);
            if (cnode.getNodeName().equals(WSDLLabel.SOAP_BODY)) {
                SOAPBody body = label.getDefinitionEx().createSOAPBody();
                elementEx = body;
                                for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                    Node attNode = cnode.getAttributes().item(j);
                    if (attNode.getNodeName().equals(SOAPBody.ATT_PARTS)) {
                        body.setParts(attNode.getNodeValue());
                    } else if (attNode.getNodeName().equals(SOAPBody.ATT_USE)) {
                        body.setUse(attNode.getNodeValue());
                    } else if (attNode.getNodeName().equals(
                            SOAPBody.ATT_ENC_STYLE)) {
                        body.setEncodingStyle(attNode.getNodeValue());
                    } else if (attNode.getNodeName().equals(SOAPBody.ATT_NS)) {
                        body.setNamespace(attNode.getNodeValue());
                    }
                }
            } else if (cnode.getNodeName().equals(WSDLLabel.SOAP_HEAD)) {
                SOAPHeader header = label.getDefinitionEx().createSOAPHeader();
                elementEx = header;
                                for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                    Node attNode = cnode.getAttributes().item(j);
                    if (attNode.getNodeName().equals(SOAPHeader.ATT_ELE)) {
                        header.setElement(attNode.getNodeValue());
                    } else if (attNode.getNodeName().equals(
                            SOAPHeader.ATT_FAULT)) {
                        header.setFault(attNode.getNodeValue());
                    }
                }
            } else if (cnode.getNodeName().equals(WSDLLabel.HTTP_URLENC)) {
                HTTPUrlEncoded encoded = label.getDefinitionEx()
                        .createHTTPUrlEncoded();
                elementEx = encoded;
            } else if (cnode.getNodeName().equals(WSDLLabel.HTTP_URLREP)) {
                HTTPUrlReplacement replacement = label.getDefinitionEx()
                        .createHTTPUrlReplacement();
                elementEx = replacement;
            } else if (cnode.getNodeName().equals(WSDLLabel.MIME_CONTENT)) {
                MIMEContent content = label.getDefinitionEx()
                        .createMIMEContent();
                elementEx = content;
                                for (int j = 0; j < cnode.getAttributes().getLength(); j++) {
                    Node attNode = cnode.getAttributes().item(j);
                    if (attNode.getNodeName().equals(MIMEContent.ATT_TYPE)) {
                        content.setType(attNode.getNodeValue());
                    } else if (attNode.getNodeName().equals(
                            MIMEContent.ATT_PART)) {
                        content.setPart(attNode.getNodeValue());
                    }
                }
            } else if (cnode.getNodeName().equals(WSDLLabel.MIME_MUL)) {
                MIMEMultipartRelated multipartRelated = this.createMultipart(
                        label, cnode);
                elementEx = multipartRelated;
            } else if (cnode.getNodeName().equals(WSDLLabel.MIME_XML)) {
                MIMEXml xml = label.getDefinitionEx().createMIMEXml();
                for (int k = 0; k < cnode.getAttributes().getLength(); k++) {
                    Node attNode = cnode.getAttributes().item(k);
                    if (attNode.getNodeName().equals(MIMEXml.ATT_PART)) {
                        xml.setPart(attNode.getNodeValue());
                    }
                }
                elementEx = xml;
            }
        }
        return elementEx;
    }
    private MIMEMultipartRelated createMultipart(WSDLLabel label, Node cnode) {
        MIMEMultipartRelated multipartRelated = label.getDefinitionEx()
                .createMIMEMultipartRelated();
                for (int i = 0; i < cnode.getChildNodes().getLength(); i++) {
            Node pnode = cnode.getChildNodes().item(i);
            if (pnode.getNodeName().equals(WSDLLabel.MIME_PART)) {
                MIMEPart part = multipartRelated.getDefinitionEx()
                        .createMIMEPart();
                for (int j = 0; j < pnode.getChildNodes().getLength(); j++) {
                    Node ccnode = pnode.getChildNodes().item(j);
                    if (ccnode.getNodeName().equals(WSDLLabel.MIME_CONTENT)) {
                        MIMEContent content = part.getDefinitionEx()
                                .createMIMEContent();
                                                for (int k = 0; k < cnode.getAttributes().getLength(); k++) {
                            Node attNode = cnode.getAttributes().item(k);
                            if (attNode.getNodeName().equals(
                                    MIMEContent.ATT_TYPE)) {
                                content.setType(attNode.getNodeValue());
                            } else if (attNode.getNodeName().equals(
                                    MIMEContent.ATT_PART)) {
                                content.setPart(attNode.getNodeValue());
                            }
                        }
                        part.addExtensibilityElementEx(content);
                    } else if (ccnode.getNodeName().equals(WSDLLabel.MIME_MUL)) {
                        part.addExtensibilityElementEx(this.createMultipart(
                                part, pnode));
                    } else if (ccnode.getNodeName().equals(WSDLLabel.MIME_XML)) {
                        MIMEXml xml = part.getDefinitionEx().createMIMEXml();
                        for (int k = 0; k < ccnode.getAttributes().getLength(); k++) {
                            Node attNode = ccnode.getAttributes().item(k);
                            if (attNode.getNodeName().equals(MIMEXml.ATT_PART)) {
                                xml.setPart(attNode.getNodeValue());
                            }
                        }
                        part.addExtensibilityElementEx(xml);
                    }
                }
            }
        }
        return multipartRelated;
    }
    
    private void createService() {
        for (int i = 0; i < docWSDL.getElementsByTagName(WSDLLabel.SERVICE)
                .getLength(); i++) {
            Element element = (Element) docWSDL.getElementsByTagName(
                    WSDLLabel.SERVICE).item(i);
            ServiceEx serviceEx = (ServiceEx) definitionEx.createService();
                        for (int j = 0; j < element.getAttributes().getLength(); j++) {
                Node attNode = element.getAttributes().item(j);
                if (attNode.getNodeName().equals(BindingEx.ATT_NAME)) {
                    serviceEx.setQName(definitionEx.StringToQName(attNode
                            .getNodeValue()));
                }
            }
            definitionEx.addService(serviceEx);
            this.createPort(serviceEx, element);
            this.createExtensibilityElement(serviceEx, element);
        }
    }
    
    private void createPort(ServiceEx serviceEx, Element element) {
        for (int i = 0; i < element.getChildNodes().getLength(); i++) {
            Node node = element.getChildNodes().item(i);
            if (node.getNodeName().equals(WSDLLabel.PORT)) {
                PortEx portEx = (PortEx) serviceEx.getDefinitionEx()
                        .createPort();
                                for (int j = 0; j < node.getAttributes().getLength(); j++) {
                    Node attNode = node.getAttributes().item(j);
                    if (attNode.getNodeName().equals(PortEx.ATT_NAME)) {
                        portEx.setName(attNode.getNodeValue());
                    } else if (attNode.getNodeName().equals(PortEx.ATT_BINDING)) {
                        portEx.setBinding(portEx.getDefinitionEx().getBinding(
                                definitionEx.StringToQName(attNode
                                        .getNodeValue())));
                    }
                }
                serviceEx.addPort(portEx);
                this.createExtensibilityElement(portEx, node);
            }
        }
    }
    private String NSprefixRegular(String NSprefix) {
        if (NSprefix.indexOf(':') != -1) {
            return NSprefix.substring(NSprefix.indexOf(':') + 1);
        } else {
            return NSprefix;
        }
    }
    
    public DefinitionEx getDefinitionEx() {
        return definitionEx;
    }
    public static Element getComplexTypeElement(String wsdlSource,
            ComplexTypeEx complexTypeEx) {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        Document docWSDL;
        try {
            db = dbf.newDocumentBuilder();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            docWSDL = db.parse(new File(wsdlSource));
            for (int i = 0; i < docWSDL.getElementsByTagName("complexType")
                    .getLength(); i++) {
                Element element = (Element) docWSDL.getElementsByTagName(
                        "complexType").item(i);
                if (element.getAttribute("name")
                        .equals(complexTypeEx.getName())) {
                    return element;
                }
            }
        } catch (SAXException e1) {
                        e1.printStackTrace();
        } catch (IOException e1) {
                        e1.printStackTrace();
        }
        return null;
    }
    
    public static Element getElement(String wsdlFileAbPath, WSDLLabel label) {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        Document docWSDL;
        try {
            db = dbf.newDocumentBuilder();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            docWSDL = db.parse(new File(wsdlFileAbPath));
            for (int i = 0; i < docWSDL.getElementsByTagName(
                    label.getLabelName()).getLength(); i++) {
                Element element = (Element) docWSDL.getElementsByTagName(
                        label.getLabelName()).item(i);
                if (element.getAttribute("name") == "") {
                    return element;
                } else if (element.getAttribute("name").equals(label.getName())) {
                    return element;
                }
            }
        } catch (SAXException e1) {
                        e1.printStackTrace();
        } catch (IOException e1) {
                        e1.printStackTrace();
        }
        return null;
    }
}
