
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.Combiner;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ExtensibilityElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.FaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlEncoded;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlReplacement;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ImportEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.InputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEMultipartRelated;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEPart;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEXml;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MessageEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PartEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBody;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPFault;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPHeader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ServiceEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.TypesEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.listeners.IDeriveLabelListener;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.listeners.IPropertyListener;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class WSDLWriter implements IPropertyListener, IDeriveLabelListener {
    DefinitionEx definitionEx;
    Document docWSDL;
    Element definitionElement;
    File file;
    
    public WSDLWriter(DefinitionEx definitionEx, File file) {
        this.definitionEx = definitionEx;
        this.definitionEx.addIPropertyListener(this);
        this.definitionEx.addIDeriveLabelListeners(this);
        
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        try {
            db = dbf.newDocumentBuilder();
        } catch (Exception e) {
            e.printStackTrace();
        }
                docWSDL = db.newDocument();
        definitionElement = docWSDL.createElement(definitionEx.getLabelName());
       
        this.file=file;
    }
    public void overWriteWSDL(){
        this.clear();
        this.saveWSDL();
    }
    private void writeWSDL() {
        this.initDefinitionElement();
        
                if (isExisted(definitionEx.getImports())) {
            for (Iterator iter = definitionEx.getImports().values().iterator(); iter
                    .hasNext();) {
                ImportEx importEx = (ImportEx) iter.next();
                definitionElement.appendChild(this
                        .createImportElement(importEx));
            }
        }
                if (definitionEx.getTypes() != null
                && definitionEx.getTypes() instanceof TypesEx) {
            TypesEx typesEx = (TypesEx) definitionEx.getTypes();
            definitionElement.appendChild(this.createTypesElement(typesEx));
        }
                if (isExisted(definitionEx.getMessages())) {
            for (Iterator iter = definitionEx.getMessages().values().iterator(); iter
                    .hasNext();) {
                Object object=iter.next();
                if (object instanceof MessageEx) {
                    MessageEx messageEx = (MessageEx) object;
                    definitionElement.appendChild(this
                            .createMessageElement(messageEx));
                }
                
            }
        }
                if (isExisted(definitionEx.getPortTypes())) {
            for (Iterator iter = definitionEx.getPortTypes().values()
                    .iterator(); iter.hasNext();) {
                PortTypeEx portType = (PortTypeEx) iter.next();
                definitionElement.appendChild(this
                        .createPortTypeElement(portType));
            }
        }
                if (isExisted(definitionEx.getBindings())) {
            for (Iterator iter = definitionEx.getBindings().values().iterator(); iter
                    .hasNext();) {
                BindingEx binding = (BindingEx) iter.next();
                definitionElement.appendChild(this
                        .createBindingElement(binding));
            }
        }
                if (isExisted(definitionEx.getServices())) {
            for (Iterator iter = definitionEx.getServices().values().iterator(); iter
                    .hasNext();) {
                ServiceEx serviceEx = (ServiceEx) iter.next();
                definitionElement.appendChild(this
                        .createServiceElement(serviceEx));
            }
        }
    }

    public void outWSDL() {
        this.writeWSDL();
        Source source = new DOMSource(this.definitionElement);
        Result result = new StreamResult(System.out);
        try {
            Transformer transformer = TransformerFactory.newInstance()
                    .newTransformer();
            transformer.setOutputProperty(OutputKeys.METHOD, "xml");
            transformer
                    .setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "no");
            try {
                transformer.transform(source, result);
            } catch (TransformerException e1) {
                                e1.printStackTrace();
            }
        } catch (TransformerConfigurationException e) {
                        e.printStackTrace();
        } catch (TransformerFactoryConfigurationError e) {
                        e.printStackTrace();
        }
    }
    public void saveWSDL() {
        this.writeWSDL();
        Source source = new DOMSource(this.definitionElement);
        Result result = new StreamResult(file);
        try {
            Transformer transformer = TransformerFactory.newInstance()
                    .newTransformer();
            transformer.setOutputProperty(OutputKeys.METHOD, "xml");
            transformer
                    .setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "no");
            try {
                transformer.transform(source, result);
            } catch (TransformerException e1) {
                                e1.printStackTrace();
            }
        } catch (TransformerConfigurationException e) {
                        e.printStackTrace();
        } catch (TransformerFactoryConfigurationError e) {
                        e.printStackTrace();
        }
    }
    public void initDefinitionElement() {
        
        if (isExisted(definitionEx.getQName())) {
            definitionElement.setAttribute("name", definitionEx.QNameToString(definitionEx
                    .getQName()));
        }
        if (isExisted(definitionEx.getTargetNamespace())) {
            definitionElement.setAttribute("targetNamespace", definitionEx
                    .getTargetNamespace());
        }
        if (isExisted(definitionEx.getNamespaces())) {
            for (Iterator iter = definitionEx.getNamespaces().keySet()
                    .iterator(); iter.hasNext();) {
                String prefix = (String) iter.next();
                definitionElement.setAttribute(NSprefixRegular(prefix), definitionEx
                        .getNamespace(prefix));
            }
        }
    }
    
    private Element createServiceElement(ServiceEx serviceEx) {
        Element serviceElement = docWSDL
                .createElement(serviceEx.getLabelName());
        if(serviceEx.getQName()!=null){
            serviceElement.setAttribute(ServiceEx.ATT_NAME, serviceEx.getQName().getLocalPart());
        }
       
        for (Iterator iterator = serviceEx.getPorts().values().iterator(); iterator
                .hasNext();) {
            PortEx portEx = (PortEx) iterator.next();
            serviceElement.appendChild(this.createPortElement(portEx));
        }
        return serviceElement;
    }
    private Element createPortElement(PortEx portEx) {
        Element portElement = docWSDL.createElement(portEx.getLabelName());
        portElement.setAttribute("name", portEx.getName());
        if(portEx.getBinding()!=null){
            portElement.setAttribute("binding", definitionEx.QNameToString(portEx
                    .getBinding().getQName()));
        }
        
        for (Iterator iter = portEx.getExtensibilityElements().iterator(); iter
                .hasNext();) {
            ExtensibilityElementEx elementEx = (ExtensibilityElementEx) iter
                    .next();
            portElement.appendChild(this
                    .createBindingExtensibilityElement(elementEx));
        }
        return portElement;
    }
    
    private Element createBindingElement(BindingEx binding) {
        Element bindingElement = docWSDL.createElement(binding.getLabelName());
        bindingElement.setAttribute(BindingEx.ATT_NAME, binding
                .getQName().getLocalPart());
        if(binding.getPortType()!=null){
            bindingElement.setAttribute(BindingEx.ATT_TYPE, definitionEx.QNameToString(binding
                    .getPortType().getQName()));
        }
        
                        for (Iterator iterator = binding.getExtensibilityElements().iterator(); iterator
                .hasNext();) {
            ExtensibilityElementEx extensibilityElement = (ExtensibilityElementEx) iterator
                    .next();
            bindingElement.appendChild(this
                    .createBindingExtensibilityElement(extensibilityElement));
        }
                                for (Iterator iterator = binding.getBindingOperations().iterator(); iterator
                .hasNext();) {
            BindingOperationEx bindingOperationEx = (BindingOperationEx) iterator
                    .next();
                        bindingElement.appendChild(this
                    .createBindingOperation(bindingOperationEx));
        }
        return bindingElement;
    }
    
    private Element createBindingOperation(BindingOperationEx bindingOperationEx) {
        Element bindingOperationElement = docWSDL
                .createElement(bindingOperationEx.getLabelName());
        bindingOperationElement.setAttribute(BindingOperationEx.ATT_NAME,
                bindingOperationEx.getName());
                        for (Iterator iterator = bindingOperationEx.getExtensibilityElements()
                .iterator(); iterator.hasNext();) {
            ExtensibilityElementEx element = (ExtensibilityElementEx) iterator
                    .next();
            bindingOperationElement.appendChild(this
                    .createBindingExtensibilityElement(element));
        }
                        BindingInputEx bindingInputEx = (BindingInputEx) bindingOperationEx
                .getBindingInput();
        if (isExisted(bindingInputEx)) {
            bindingOperationElement.appendChild(this
                    .createBindingInput(bindingInputEx));
        }
                BindingOutputEx bindingOutputEx = (BindingOutputEx) bindingOperationEx
                .getBindingOutput();
        if (isExisted(bindingOutputEx)) {
            bindingOperationElement.appendChild(this
                    .createBindingOutput(bindingOutputEx));
        }
                Map bindingFaultExs = bindingOperationEx.getBindingFaults();
        for (Iterator iter = bindingFaultExs.values().iterator(); iter
                .hasNext();) {
            BindingFaultEx bindingFaultEx = (BindingFaultEx) iter.next();
            bindingOperationElement.appendChild(this
                    .createBindingFault(bindingFaultEx));
        }
        return bindingOperationElement;
    }
    
    private Element createBindingFault(BindingFaultEx bindingFaultEx) {
        Element faultElement = docWSDL.createElement(bindingFaultEx
                .getLabelName());
        faultElement.setAttribute("name", bindingFaultEx.getName());
        for (Iterator iterator = bindingFaultEx.getExtensibilityElements()
                .iterator(); iterator.hasNext();) {
            ExtensibilityElementEx elementEx = (ExtensibilityElementEx) iterator
                    .next();
            faultElement.appendChild(this
                    .createBindingExtensibilityElement(elementEx));
        }
        return faultElement;
    }
    
    private Element createBindingOutput(BindingOutputEx bindingOutputEx) {
        Element outputElement = docWSDL.createElement(bindingOutputEx
                .getLabelName());
        if (isExisted(bindingOutputEx.getName())) {
            outputElement.setAttribute("name", bindingOutputEx.getName());
        }
        for (Iterator iter = bindingOutputEx.getExtensibilityElements()
                .iterator(); iter.hasNext();) {
            ExtensibilityElementEx elementEx = (ExtensibilityElementEx) iter
                    .next();
            outputElement.appendChild(this
                    .createBindingExtensibilityElement(elementEx));
        }
        return outputElement;
    }
    
    private Node createBindingInput(BindingInputEx bindingInputEx) {
        Element inputElement = docWSDL.createElement(bindingInputEx
                .getLabelName());
        if (isExisted(bindingInputEx.getName())) {
            inputElement.setAttribute("name", bindingInputEx.getName());
        }
        for (Iterator iter = bindingInputEx.getExtensibilityElements()
                .iterator(); iter.hasNext();) {
            ExtensibilityElementEx elementEx = (ExtensibilityElementEx) iter
                    .next();
            inputElement.appendChild(this
                    .createBindingExtensibilityElement(elementEx));
        }
        return inputElement;
    }
    private Element createBindingExtensibilityElement(
            ExtensibilityElementEx elementEx) {
        if (elementEx instanceof SOAPAddress) {
            SOAPAddress soap = (SOAPAddress) elementEx;
            Element soapElement = docWSDL.createElement(soap.getLabelName());
            if(soap.getLocation()!=null){
                soapElement.setAttribute("location", soap.getLocation());
            }
            return soapElement;
        }
        if (elementEx instanceof SOAPBinding) {
            SOAPBinding soap = (SOAPBinding) elementEx;
            Element soapElement = docWSDL.createElement(soap.getLabelName());
            if (isExisted(soap.getTransport())) {
                soapElement.setAttribute("transport", soap.getTransport());
            }
            if (isExisted(soap.getStyle())) {
                soapElement.setAttribute("style", soap.getStyle());
            }
            return soapElement;
        }
        if (elementEx instanceof SOAPOperation) {
            SOAPOperation soap = (SOAPOperation) elementEx;
            Element soapElement = docWSDL.createElement(soap.getLabelName());
            if (isExisted(soap.getSoapAction())) {
                soapElement.setAttribute("soapAction", soap.getSoapAction());
            }
            if (isExisted(soap.getStyle())) {
                soapElement.setAttribute("style", soap.getStyle());
            }
            return soapElement;
        }
        if (elementEx instanceof SOAPBody) {
            SOAPBody soap = (SOAPBody) elementEx;
            Element soapElement = docWSDL.createElement(soap.getLabelName());
            if (isExisted(soap.getParts())) {
                soapElement.setAttribute("parts", soap.getParts());
            }
            if (isExisted(soap.getUse())) {
                soapElement.setAttribute("use", soap.getUse());
            }
            if (isExisted(soap.getEncodingStyle())) {
                soapElement.setAttribute("encodingStyle", soap
                        .getEncodingStyle());
            }
            if (isExisted(soap.getNamespace())) {
                soapElement.setAttribute("namespace", soap.getNamespace());
            }
            return soapElement;
        }
        if (elementEx instanceof SOAPHeader) {
            SOAPHeader soap = (SOAPHeader) elementEx;
            Element soapElement = docWSDL.createElement(soap.getLabelName());
            soapElement.setAttribute("element", soap.getElement());
            if (isExisted(soap.getFault())) {
                soapElement.setAttribute("fault", soap.getFault());
            }
            return soapElement;
        }
        if (elementEx instanceof SOAPFault) {
            SOAPFault soap = (SOAPFault) elementEx;
            Element soapElement = docWSDL.createElement(soap.getLabelName());
            soapElement.setAttribute("name", soap.getName());
            soapElement.setAttribute("use", soap.getUse());
            if (isExisted(soap.getEncodingStyle())) {
                soapElement.setAttribute("encodingStyle", soap
                        .getEncodingStyle());
            }
            if (isExisted(soap.getNamespace())) {
                soapElement.setAttribute("namespace", soap.getNamespace());
            }
            return soapElement;
        }
        if (elementEx instanceof HTTPAddress) {
            HTTPAddress http = (HTTPAddress) elementEx;
            Element httpElement = docWSDL.createElement(http.getLabelName());
            httpElement.setAttribute("location", http.getLocation());
            return httpElement;
        }
        if (elementEx instanceof HTTPBinding) {
            HTTPBinding http = (HTTPBinding) elementEx;
            Element httpElement = docWSDL.createElement(http.getLabelName());
            httpElement.setAttribute("verb", http.getVerb());
            return httpElement;
        }
        if (elementEx instanceof HTTPOperation) {
            HTTPOperation http = (HTTPOperation) elementEx;
            Element httpElement = docWSDL.createElement(http.getLabelName());
            httpElement.setAttribute("location", http.getLocation());
            return httpElement;
        }
        if (elementEx instanceof HTTPUrlEncoded) {
            HTTPUrlEncoded http = (HTTPUrlEncoded) elementEx;
            Element httpElement = docWSDL.createElement(http.getLabelName());
            return httpElement;
        }
        if (elementEx instanceof HTTPUrlReplacement) {
            HTTPUrlReplacement http = (HTTPUrlReplacement) elementEx;
            Element httpElement = docWSDL.createElement(http.getLabelName());
            return httpElement;
        }
        if (elementEx instanceof MIMEContent) {
            MIMEContent mime = (MIMEContent) elementEx;
            Element mimeElement = docWSDL.createElement(mime.getLabelName());
            if (isExisted(mime.getType())) {
                mimeElement.setAttribute("type", mime.getType());
            }
            if (isExisted(mime.getPart())) {
                mimeElement.setAttribute("part", mime.getPart());
            }
            return mimeElement;
        }
        if (elementEx instanceof MIMEMultipartRelated) {
            MIMEMultipartRelated mime = (MIMEMultipartRelated) elementEx;
            Element mimeElement = docWSDL.createElement(mime.getLabelName());
            for (Iterator iter = mime.getMimeParts().iterator(); iter.hasNext();) {
                MIMEPart part = (MIMEPart) iter.next();
                mimeElement.appendChild(this
                        .createBindingExtensibilityElement(part));
            }
            return mimeElement;
        }
        if (elementEx instanceof MIMEPart) {
            MIMEPart mime = (MIMEPart) elementEx;
            Element mimeElement = docWSDL.createElement(mime.getLabelName());
            mimeElement.setAttribute("name", mime.getName());
            for (Iterator iterator = mime.getExtensibilityElements().iterator(); iterator
                    .hasNext();) {
                ExtensibilityElementEx extensibilityElementEx = (ExtensibilityElementEx) iterator
                        .next();
                mimeElement
                        .appendChild(this
                                .createBindingExtensibilityElement(extensibilityElementEx));
            }
            return mimeElement;
        }
        if (elementEx instanceof MIMEXml) {
            MIMEXml mime = (MIMEXml) elementEx;
            Element mimeElement = docWSDL.createElement(mime.getLabelName());
            if (isExisted(mime.getPart())) {
                mimeElement.setAttribute("part", mime.getPart());
            }
            return mimeElement;
        }
        return null;
    }
    
    private Element createPortTypeElement(PortTypeEx portType) {
        Element portTypeElement = docWSDL
                .createElement(portType.getLabelName());
        portTypeElement.setAttribute(PortTypeEx.ATT_NAME,
                portType.getQName().getLocalPart());
                if (isExisted(portType.getOperations())) {
            for (Iterator iterator = portType.getOperations().iterator(); iterator
                    .hasNext();) {
                OperationEx operation = (OperationEx) iterator.next();
                portTypeElement.appendChild(this.createOperation(operation));
            }
        }
        return portTypeElement;
    }
    
    private Element createOperation(OperationEx operation) {
        Element operationElement = docWSDL.createElement(operation
                .getLabelName());
        operationElement
                .setAttribute(OperationEx.ATT_NAME, operation.getName());
                if (operation.getInput() != null) {
            InputEx inputEx = (InputEx) operation.getInput();
            operationElement.appendChild(this.createInput(inputEx));
        }
                if (operation.getOutput() != null) {
            OutputEx outputEx = (OutputEx) operation.getOutput();
            operationElement.appendChild(this.createOutput(outputEx));
        }
                if (isExisted(operation.getFaults())) {
            for (Iterator iterator2 = operation.getFaults().values().iterator(); iterator2
                    .hasNext();) {
                FaultEx fault = (FaultEx) iterator2.next();
                operationElement.appendChild(this.createFault(fault));
            }
        }
        return operationElement;
    }
    
    private Element createFault(FaultEx fault) {
        Element faultElement = docWSDL.createElement(fault.getLabelName());
        
        faultElement.setAttribute(FaultEx.ATT_NAME, fault.getName());
        if(fault.getMessage()!=null){
            faultElement.setAttribute(FaultEx.ATT_MESSAGE, definitionEx.QNameToString(fault
                    .getMessage().getQName()));
        }
        
        return faultElement;
    }
    
    private Node createOutput(OutputEx outputEx) {
        Element outputElement = docWSDL.createElement(outputEx.getLabelName());
        if (isExisted(outputEx.getName())) {
            outputElement.setAttribute(OutputEx.ATT_NAME, outputEx.getName());
        }
        if(outputEx.getMessage()!=null){
            outputElement.setAttribute(OutputEx.ATT_MESSAGE, definitionEx.QNameToString(outputEx
                    .getMessage().getQName()));
        }
        return outputElement;
    }
    
    private Node createInput(InputEx inputEx) {
        Element inputElement = docWSDL.createElement(inputEx.getLabelName());
        if (isExisted(inputEx.getName())) {
            inputElement.setAttribute(InputEx.ATT_NAME, inputEx.getName());
        }
        if(inputEx.getMessage()!=null){
            inputElement.setAttribute(InputEx.ATT_MESSAGE, definitionEx.QNameToString(inputEx
                    .getMessage().getQName()));
        }
        return inputElement;
    }
    
    private Element createMessageElement(MessageEx messageEx) {
        Element messageElement = docWSDL
                .createElement(messageEx.getLabelName());
        messageElement.setAttribute(MessageEx.ATT_NAME, messageEx
                .getQName().getLocalPart());
        if (isExisted(messageEx.getPartList())) {
            for (Iterator iterator = messageEx.getPartList().iterator(); iterator
                    .hasNext();) {
                PartEx partEx = (PartEx) iterator.next();
                messageElement.appendChild(this.createPart(partEx));
            }
        }
        return messageElement;
    }
    private Element createPart(PartEx partEx) {
        Element partElement = docWSDL.createElement(partEx.getLabelName());
        partElement.setAttribute(PartEx.ATT_NAME, partEx.getName());
        if (isExisted(partEx.getElementName())) {
            partElement.setAttribute(PartEx.ATT_ELEMENT, definitionEx.QNameToString(partEx
                    .getElementName()));
        }
        if (isExisted(partEx.getTypeName())) {
            partElement.setAttribute(PartEx.ATT_TYPE, definitionEx.QNameToString(partEx
                    .getTypeName()));
        }
        return partElement;
    }
    
    private Element createTypesElement(TypesEx typesEx) {
        Element typesElement = docWSDL.createElement(typesEx.getLabelName());
                if (isExisted(typesEx.getExtensibilityElements())) {
            for (Iterator iter = typesEx.getExtensibilityElements().iterator(); iter
                    .hasNext();) {
                ExtensibilityElementEx elementEx = (ExtensibilityElementEx) iter
                        .next();
                if (elementEx instanceof SchemaEx) {
                    SchemaEx schemaEx = (SchemaEx) elementEx;
                    typesElement
                            .appendChild(this.createSchemaElement(schemaEx));
                }
            }
        }
        return typesElement;
    }
    private Element createSchemaElement(SchemaEx schemaEx) {
        Element schemaElement = docWSDL.createElement(schemaEx.getLabelName());
        schemaElement.setAttribute(SchemaEx.ATT_TNS,schemaEx.getTargetNamespace());
        for (Iterator iter = schemaEx.getNamespaces().keySet().iterator(); iter.hasNext();) {
            String prefix = (String) iter.next();
            String ns=schemaEx.getNamespaces(prefix);
            schemaElement.setAttribute(prefix,ns);
        }
        
        if (isExisted(schemaEx.getComplexTypes())) {
            for (Iterator iterator = schemaEx.getComplexTypes().iterator(); iterator
                    .hasNext();) {
                ComplexTypeEx complexTypeEx = (ComplexTypeEx) iterator.next();
                                schemaElement.appendChild(this
                        .createComplexTypeElement(complexTypeEx));
            }
        }
        if (isExisted(schemaEx.getSimpleTypes())) {
            for (Iterator iterator = schemaEx.getSimpleTypes().iterator(); iterator
                    .hasNext();) {
                SimpleTypeEx simpleTypeEx = (SimpleTypeEx) iterator.next();
                                schemaElement.appendChild(this
                        .createSimpleTypeElement(simpleTypeEx));
            }
        }
        if (isExisted(schemaEx.getElememts())) {
            for (Iterator iterator = schemaEx.getElememts().iterator(); iterator
                    .hasNext();) {
                ElementEx elementEx = (ElementEx) iterator.next();
                                schemaElement.appendChild(this.createElementElement(elementEx));
            }
        }
        return schemaElement;
    }
    private Element createSimpleTypeElement(SimpleTypeEx simpleTypeEx) {
        Element simpleTypeElement = docWSDL.createElement(simpleTypeEx
                .getLabelName());
        if (isExisted(simpleTypeEx.getName())) {
            simpleTypeElement.setAttribute("name", simpleTypeEx.getName());
        }
        if (simpleTypeEx.getKind().equals(SimpleTypeEx.KIND_ATOMIC)) {
            Element restrictionElement = docWSDL.createElement("restriction");
            restrictionElement.setAttribute("base", simpleTypeEx.getBaseType());
            simpleTypeElement.appendChild(restrictionElement);
                    } else if (simpleTypeEx.getKind().equals(SimpleTypeEx.KIND_LIST)) {
            Element listElement = docWSDL.createElement(SimpleTypeEx.KIND_LIST);
            listElement.setAttribute("itemType", simpleTypeEx.getItemType());
        } else if (simpleTypeEx.getKind().equals(SimpleTypeEx.KIND_UNION)) {
            Element unionElement = docWSDL
                    .createElement(SimpleTypeEx.KIND_UNION);
            unionElement
                    .setAttribute("itemType", simpleTypeEx.getMemberTypes());
        }
        return simpleTypeElement;
    }
    private Element createComplexTypeElement(ComplexTypeEx complexTypeEx) {
        Element complexTypeElement = docWSDL.createElement(complexTypeEx
                .getLabelName());
        complexTypeElement.setAttribute("name", complexTypeEx.getName());
        Combiner combiner = complexTypeEx.getCombiner();
        if (combiner != null) {
            Element combinerElement = docWSDL.createElement(combiner.getKind());
            if (isExisted(combiner.getElements())) {
                for (Iterator iterator = combiner.getElements().iterator(); iterator
                        .hasNext();) {
                    ElementEx elementEx = (ElementEx) iterator.next();
                                        combinerElement.appendChild(this
                            .createElementElement(elementEx));
                }
            }
        }
        return complexTypeElement;
    }
    private Element createElementElement(ElementEx elementEx) {
        Element element = docWSDL.createElement(elementEx.getLabelName());
        if (isExisted(elementEx.getName())) {
            element.setAttribute("name", elementEx.getName());
        }
        if (isExisted(elementEx.getRef())) {
            element.setAttribute("ref", elementEx.getRef());
        }
        if (isExisted(elementEx.getTypeEx())) {
            element.setAttribute("type", elementEx.getTypeEx());
        }
        if (elementEx.getTypeExInner() != null) {
            if (elementEx.getTypeExInner() instanceof ComplexTypeEx) {
                ComplexTypeEx complexTypeEx = (ComplexTypeEx) elementEx
                        .getTypeExInner();
                element.appendChild(this
                        .createComplexTypeElement(complexTypeEx));
            }
            if (elementEx.getTypeExInner() instanceof SimpleTypeEx) {
                SimpleTypeEx simpleTypeEx = (SimpleTypeEx) elementEx
                        .getTypeExInner();
                element.appendChild(this.createSimpleTypeElement(simpleTypeEx));
            }
        }
        return element;
    }
    
    private Element createImportElement(ImportEx importEx) {
        Element importElement = docWSDL.createElement(importEx.getLabelName());
        importElement.setAttribute(ImportEx.ATT_NS, importEx.getNamespaceURI());
        if(importEx.getLocationURI()!=null){
            importElement.setAttribute(ImportEx.ATT_LOC_URL, importEx
                    .getLocationURI());
        }
        return importElement;
    }
   private String NSprefixRegular(String NSprefix){
       if(NSprefix.equals(DefinitionEx.XMLNS)){
           return NSprefix;
       }
       else{
           return DefinitionEx.XMLNS+":"+NSprefix;
       }
   }
    
    
    private boolean isExisted(QName att) {
        if (att != null && att.toString() != "") {
            return true;
        }
        return false;
    }
    private boolean isExisted(String att) {
        if (att != null && att != "") {
            return true;
        }
        return false;
    }
    private boolean isExisted(Map map) {
        if (map != null && !map.isEmpty()) {
            return true;
        }
        return false;
    }
    private boolean isExisted(List list) {
        if (list != null && !list.isEmpty()) {
            return true;
        }
        return false;
    }
    private boolean isExisted(WSDLLabel label) {
        if (label != null) {
            return true;
        }
        return false;
    }
    
    public void propertyChanged(WSDLLabel label) {
        if (regCheck(label)) {
            this.clear();
            this.saveWSDL();
            MainFrame.getmainFrame().getProject().getWSDLRegistry().updateUserDefinedWSDL(this.definitionEx);
        }
        else{
            this.clear();
            this.saveWSDL();
        }
    }
    
    public void childAdded(WSDLLabel childlabel) {
                                                if (regCheck(childlabel)) {
            this.clear();
            this.saveWSDL();
            MainFrame.getmainFrame().getProject().getWSDLRegistry().updateUserDefinedWSDL(this.definitionEx);
        }
        else{
            this.clear();
            this.saveWSDL();
        }
        
    }
    
    private boolean regCheck(WSDLLabel childlabel) {
        if (childlabel instanceof SchemaEx
                || childlabel instanceof ComplexTypeEx
                || childlabel instanceof SimpleTypeEx
                || childlabel instanceof MessageEx
                || childlabel instanceof PortTypeEx
                || childlabel instanceof BindingEx
                || childlabel instanceof ServiceEx) {
            return true;
        }
        return false;
    }
    
    private void clear() {
        while(definitionElement.getAttributes().getLength()>0){
            definitionElement.removeAttributeNode((Attr) definitionElement.getAttributes().item(0));
        }
        while(definitionElement.getChildNodes().getLength()>0){
            definitionElement.removeChild(definitionElement.getChildNodes().item(0));
        }
        
    }
    
    public void childRemoved(WSDLLabel childLabel) {
        if (regCheck(childLabel)) {
            this.clear();
            this.saveWSDL();
            MainFrame.getmainFrame().getProject().getWSDLRegistry().updateUserDefinedWSDL(this.definitionEx);
        }
        else{
            this.clear();
            this.saveWSDL();
        }
    }
    
    public void lableRenamed(WSDLLabel lable) {
    }
}
