package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ImportEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MessageEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ServiceEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.TypesEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.listeners.IDeriveLabelListener;
public class MyTreeNode extends DefaultMutableTreeNode implements IDeriveLabelListener {
	WSDLLabel wsdlLabel=null;
	int level=-1;
	WSDLTreePane treePane;
	
	
    
    public MyTreeNode(String name,int level,WSDLTreePane treePane) {
        super(name);
        this.level = level;
        this.treePane=treePane;
    }
	
	public MyTreeNode(WSDLLabel wsdlLabel, int level,WSDLTreePane treePane) {
		super(wsdlLabel.getName());
		this.wsdlLabel = wsdlLabel;
		this.level = level;
		this.treePane=treePane;
		this.wsdlLabel.addIDeriveLabelListeners(this);
	}
	
    
	public int getLevel() {
		return level;
	}
	
	public void setLevel(int level) {
		this.level = level;
	}
	
	public WSDLLabel getWsdlLabel() {
		return wsdlLabel;
	}
	
	public void setWsdlLabel(WSDLLabel wsdlLabel) {
		this.wsdlLabel = wsdlLabel;
	}
    
    public void childAdded(WSDLLabel childlabel) {
        if(this.wsdlLabel instanceof DefinitionEx){
            int index=-1;
            if(childlabel instanceof ImportEx){
                index=0;
            }else if(childlabel instanceof TypesEx){
                index=1;
            }else if(childlabel instanceof MessageEx){
                index=2;
            }else if(childlabel instanceof PortTypeEx){
                index=3;
            }else if(childlabel instanceof BindingEx){
                index=4;
            }else if(childlabel instanceof ServiceEx){
                index=5;
            }
            if(index==1){
                ((MyTreeNode)this.getChildAt(index)).setWsdlLabel(childlabel);
                childlabel.addIDeriveLabelListeners(((MyTreeNode)this.getChildAt(index)));
                this.treePane.getLabelToNode().put(childlabel,((MyTreeNode)this.getChildAt(index)));
            }
            else{
                MyTreeNode node=new MyTreeNode(childlabel,this.level+1,this.treePane);
                this.treePane.getLabelToNode().put(childlabel,node);
                ((MyTreeNode)this.getChildAt(index)).add(node);
                this.treePane.getWSDLTree().expandPath(new TreePath(((MyTreeNode)this.getChildAt(index)).getPath())); 
            }
        }else{
            MyTreeNode node=new MyTreeNode(childlabel,this.level+1,this.treePane);
            this.treePane.getLabelToNode().put(childlabel,node);
            this.add(node); 
            this.treePane.getWSDLTree().expandPath(new TreePath(this.getPath()));
        }
        this.treePane.getWSDLTree().updateUI();
    }
    
    public void childRemoved(WSDLLabel childLabel) {
        if(childLabel instanceof TypesEx){
            ((MyTreeNode)this.treePane.getLabelToNode().get(childLabel)).setWsdlLabel(null);
            childLabel.removeIDeriveLabelListeners(((MyTreeNode)this.treePane.getLabelToNode().get(childLabel)));
        }
        else{
            ((MyTreeNode)this.treePane.getLabelToNode().get(childLabel)).removeFromParent();
        }
       this.treePane.getLabelToNode().remove(childLabel);
       this.treePane.getWSDLTree().updateUI();
    }
    
    public void lableRenamed(WSDLLabel label) {
        this.setUserObject(label.getName());       
    }
 
    
    public WSDLTreePane getTreePane() {
        return treePane;
    }
    
    public void setTreePane(WSDLTreePane treePane) {
        this.treePane = treePane;
    }
}
