
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view;
import java.io.File;
import javax.swing.JScrollPane;
import javax.xml.namespace.QName;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.FaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ImportEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.InputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MessageEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PartEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBody;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPFault;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPHeader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ServiceEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLReader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLWriter;

public class Test {
    
    public Test() {
        super();
        
    }
    public static void main(String[] args){
        Test.test();
    }
    public static void test() {
        DefinitionEx definitionEx =new DefinitionEx();
        ImportEx importEx=(ImportEx) definitionEx.createImport();
        importEx.setNamespaceURI("http://test.com/test");
        importEx.setLocationURI("http://test.com/test.xsd");
        definitionEx.addImport(importEx);
        
        MessageEx messageEx1= (MessageEx) definitionEx.createMessage();
        PartEx partEx=(PartEx) definitionEx.createPart();
        partEx.setTypeName(new QName("tns","type1"));
        messageEx1.addPart(partEx);
        definitionEx.addMessage(messageEx1);
        
        MessageEx messageEx2= (MessageEx) definitionEx.createMessage();
        messageEx2.setQName(new QName("message2"));
        PartEx partEx2=(PartEx) definitionEx.createPart();
        partEx2.setTypeName(new QName("tns","type2"));
        messageEx2.addPart(partEx2);
        definitionEx.addMessage(messageEx2);
        
        InputEx inputEx=(InputEx) definitionEx.createInput();
        inputEx.setMessage(messageEx1);
        OutputEx outputEx=(OutputEx) definitionEx.createOutput();
        outputEx.setMessage(messageEx2);
        FaultEx faultEx1=(FaultEx)definitionEx.createFault();
        FaultEx faultEx2=(FaultEx)definitionEx.createFault();
        faultEx2.setName("fault2");
        faultEx1.setMessage(messageEx1);
        faultEx2.setMessage(messageEx2);
        OperationEx operationEx=(OperationEx) definitionEx.createOperation();
        operationEx.addInput(inputEx);
        operationEx.addOutput(outputEx);
        operationEx.addFault(faultEx1);
        operationEx.addFault(faultEx2);
        
        PortTypeEx portTypeEx=(PortTypeEx) definitionEx.createPortType();
        portTypeEx.setQName(new QName("testPortType"));
        portTypeEx.addOperation(operationEx);
        definitionEx.addPortType(portTypeEx);
        
        BindingEx bindingEx=(BindingEx) definitionEx.createBinding();
        definitionEx.addBinding(bindingEx);
        bindingEx.setPortType(portTypeEx);
        SOAPBinding binding=definitionEx.createSOAPBinding();
        binding.setStyle("rpc");
        bindingEx.addExtensibilityElement(binding);
        
        BindingOperationEx bindingOperationEx=(BindingOperationEx) definitionEx.createBindingOperation();
        bindingEx.addBindingOperation(bindingOperationEx);
        
        SOAPOperation operation=definitionEx.createSOAPOperation();
        operation.setSoapAction("http://test.com/testPortType");
        bindingOperationEx.addExtensibilityElement(operation);
        
        BindingInputEx bindingInputEx=(BindingInputEx) definitionEx.createBindingInput();
        bindingOperationEx.addBindingInput(bindingInputEx);
        SOAPBody body=definitionEx.createSOAPBody();
        body.setUse("literal");
        body.setEncodingStyle("http://schema.xmlsoap.org/soap/binding");
        bindingInputEx.addExtensibilityElement(body);
        
        BindingOutputEx bindingOutputEx=(BindingOutputEx) definitionEx.createBindingOutput();
        bindingOperationEx.addBindingOutput(bindingOutputEx);
        SOAPHeader header=definitionEx.createSOAPHeader();
        header.setElement("newHeaderElement");
        header.setFault(faultEx1.getName());
        bindingOutputEx.addExtensibilityElement(header);
        
        BindingFaultEx bindingFaultEx=(BindingFaultEx) definitionEx.createBindingFault();
        bindingOperationEx.addBindingFault(bindingFaultEx);
        bindingFaultEx.setName(faultEx2.getName());
        SOAPFault fault=definitionEx.createSOAPFault();
        fault.setName(faultEx2.getName());
        fault.setUse("literal");
        fault.setNamespace("htt://faultnamespace.com");
        bindingFaultEx.addExtensibilityElement(fault);   
        
        ServiceEx serviceEx=(ServiceEx) definitionEx.createService();
        definitionEx.addService(serviceEx);
        
        PortEx portEx=(PortEx) definitionEx.createPort();
        serviceEx.addPort(portEx);
        portEx.setBinding(bindingEx);
        
        SOAPAddress address=definitionEx.createSOAPAddress();
        address.setLocation("http://test.com/test");
        portEx.addExtensibilityElement(address);
        
        definitionEx.setQName(new QName("definitionName"));
                definitionEx.addNamespace("xmlns:tns","http://test.com/tns");
        definitionEx.addNamespace("xmlns:soap","http://test.com/soap");
        
        File file = new File("d:" + File.separator + "test.wsdl");
        WSDLWriter writer = new WSDLWriter(definitionEx,file);
                writer.saveWSDL();
        WSDLReader reader=new WSDLReader(file);
        if(reader.getDefinitionEx()!=null){
            TestDialog testDialog=new TestDialog();
            WSDLTreePane treePane=new WSDLTreePane(new WSDLLayer(reader.getDefinitionEx()));
            PaneHolder.getInstance().addTab(treePane.getName(),new JScrollPane(treePane));
            reader.readWSDL();
            testDialog.setSize(900,700);
            testDialog.show();
        }
        
    }
    private static String QNameToString(QName name){
        String string="";
        if(name.getNamespaceURI()!=null&&name.getNamespaceURI()!=""){
            string=name.getNamespaceURI()+":";
        }
        return string+name.getLocalPart();
    }
}
