
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.InputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class BindingHTTPOperationRightMenu extends AbstractTreeRightMenu {
	  private ResourceBundle res = ResChoose.getLanguage();
	  
    
    JMenuItem setName=new JMenuItem(res.getString("BHTTPOPRM_ChooseOper")); 
	JMenuItem addOutput=new JMenuItem(res.getString("BHTTPOPRM_AOutput"));
    JMenuItem addInput=new JMenuItem(res.getString("BHTTPOPRM_AInput"));
    JMenuItem addFault=new JMenuItem(res.getString("BHTTPOPRM_AFault"));
    JMenu addExtensibilityElement=new JMenu(res.getString("BHTTPOPRM_AExtensibilityElement"));
    JMenuItem addHTTPOperation = new JMenuItem(res.getString("BHTTPOPRM_AHttpOperation"));
   
    
    private void jbInit() throws Exception  {
    	addExtensibilityElement.add(addHTTPOperation);
     }
    
    
    public BindingHTTPOperationRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof BindingEx) {
            final BindingOperationEx bindingOperationEx = (BindingOperationEx) myTreeNode
                    .getWsdlLabel();
            final BindingEx bindingEx=(BindingEx)((MyTreeNode)myTreeNode.getParent()).getWsdlLabel();
            this.setName.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=bindingOperationEx.getName();
                    List options=new Vector();
                    for (Iterator iter = bindingEx.getPortType().getOperations().iterator(); iter.hasNext();) {
                        OperationEx operationEx = (OperationEx) iter.next();
                        String item=operationEx.getName()+"(";
                        if(operationEx.getInput()!=null&&operationEx.getInput().getMessage()!=null){
                            item+=operationEx.getDefinitionEx().QNameToString(operationEx.getInput().getMessage().getQName());
                        }
                        item+=",";
                        if(operationEx.getOutput()!=null&&operationEx.getOutput().getMessage()!=null){
                            item+=operationEx.getDefinitionEx().QNameToString(operationEx.getOutput().getMessage().getQName());
                        }
                        item+=")";
                        options.add(item);
                    }
                    String result=PropertyEditorFactory.showEditor(BindingOperationEx.ATT_NAME+": ",""+BindingOperationEx.ATT_NAME,initialV,options);
                    String name=result.substring(0,result.indexOf('('));
                    String input=null;
                    if(result.indexOf('(')+1!=result.indexOf(',')){
                        input=result.substring(result.indexOf('(')+1,result.indexOf(','));
                    }
                    String output=null;
                    if(result.indexOf(',')+1!=result.indexOf(')')){
                        output=result.substring(result.indexOf(',')+1,result.indexOf(')'));
                    }
                    bindingOperationEx.setOperation(((PortTypeEx)bindingEx.getPortType()).getOperation(name, input, output));
                    bindingOperationEx.reName(name);
                }});
            
            this.add(this.addExtensibilityElement);
                         this.addHTTPOperation.addActionListener(new ActionListener(){
                 public void actionPerformed(ActionEvent e) {
                     WSDLLabel label=BindingHTTPOperationRightMenu.this.myTreeNode.getWsdlLabel();
                     if (label instanceof BindingOperationEx) {
                        BindingOperationEx bindingOperationEx = (BindingOperationEx) label;
                        HTTPOperation httpOperation=(HTTPOperation)bindingOperationEx.getDefinitionEx().createHTTPOperation();
                         bindingOperationEx.addExtensibilityElement(httpOperation);
                     }
                 }});
             
             this.addOutput.addActionListener(new ActionListener() {
                 public void actionPerformed(ActionEvent e) {
                    
                         BindingOutputEx bindingoutputEx = (BindingOutputEx) bindingOperationEx
                                 .getDefinitionEx().createBindingOutput();
                         if(bindingOperationEx.getOperation()!=null&&((OperationEx)bindingOperationEx.getOperation()).getOutput()!=null){
                             bindingoutputEx.setOutputEx((OutputEx) ((OperationEx)bindingOperationEx.getOperation()).getOutput());
                             bindingOperationEx.addBindingOutput(bindingoutputEx);
                         }
                 }
             });
             this.addInput.addActionListener(new ActionListener() {
                 public void actionPerformed(ActionEvent e) {
                     
                         BindingInputEx bindingInputEx = (BindingInputEx) bindingOperationEx
                                 .getDefinitionEx().createBindingInput();
                         if(bindingOperationEx.getOperation()!=null&&((OperationEx)bindingOperationEx.getOperation()).getInput()!=null){
                             bindingInputEx.setInputEx((InputEx) ((OperationEx)bindingOperationEx.getOperation()).getInput());
                             bindingOperationEx.addBindingInput(bindingInputEx);
                         }
                 }
             });
              this.addFault.addActionListener(new ActionListener(){
                 public void actionPerformed(ActionEvent e) {
                     WSDLLabel label=BindingHTTPOperationRightMenu.this.myTreeNode.getWsdlLabel();
                     if (label instanceof BindingOperationEx) {
                     	BindingOperationEx bindingOperationEx = (BindingOperationEx) label;
                         BindingFaultEx bindingFaultEx=(BindingFaultEx)bindingOperationEx.getDefinitionEx().createBindingFault();
                         bindingOperationEx.addBindingFault(bindingFaultEx);
                     }
                 }});
              
             this.add(addInput);
             this.add(addOutput);
             this.add(addFault);
        }
        this.add(this.removeItem);
        try {
			jbInit() ;
		} catch (Exception e1) {
						e1.printStackTrace();
		}
    }
}
