
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlEncoded;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPUrlReplacement;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEMultipartRelated;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEXml;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class BindingHTTPOutputRightMenu extends AbstractTreeRightMenu {
    
	  private ResourceBundle res = ResChoose.getLanguage();
	
    JMenu addExtensibilityElement=new JMenu(res.getString("BHTTPOUTRM_AddElement"));
    JMenuItem addHTTPUrlEncoded = new JMenuItem(res.getString("BHTTPOUTRM_AURLEncoded"));
    JMenuItem addHTTPUrlReplacement = new JMenuItem(res.getString("BHTTPOUTRM_AURLReplacement"));
    JMenuItem addMIMEContent = new JMenuItem(res.getString("BHTTPOUTRM_AMIMEcontent"));
    JMenuItem addMIMEMultipartRelated = new JMenuItem(res.getString("BHTTPOUTRM_AMIMEmultipartRelated"));
    JMenuItem addMIMEXml = new JMenuItem(res.getString("BHTTPOUTRM_AMIMEMIMEXml"));
    JMenuItem setName = new JMenuItem(res.getString("BHTTPOUTRM_SetName"));
    
    private void jbInit() throws Exception  {
    	addExtensibilityElement.add(addHTTPUrlEncoded);
    	addExtensibilityElement.add(addHTTPUrlReplacement);
    	addExtensibilityElement.add(addMIMEContent);
    	addExtensibilityElement.add(addMIMEMultipartRelated);
    	addExtensibilityElement.add(addMIMEXml);
     }
    
    
    public BindingHTTPOutputRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof BindingOutputEx) {
            final BindingOutputEx bindingInputEx = (BindingOutputEx) myTreeNode
                    .getWsdlLabel();
            this.setName.addActionListener(new ActionListener() {
                String initialV = bindingInputEx.getName();
                public void actionPerformed(ActionEvent e) {
                    String result = PropertyEditorFactory.showEditor(
                            BindingOutputEx.ATT_NAME + ": ", ""
                                    + BindingOutputEx.ATT_NAME, initialV);
                    if(result!=null){
                        bindingInputEx.setName(result);
                    }
                    
                }
            });
            this.add(setName);
            this.add(this.addExtensibilityElement);
            
               this.addHTTPUrlReplacement.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          HTTPUrlReplacement httpUrlReplacement=(HTTPUrlReplacement)bindingInputEx.getDefinitionEx().createHTTPUrlReplacement();
                           bindingInputEx.addExtensibilityElement(httpUrlReplacement);
                   }});
               
               this.addHTTPUrlEncoded.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          HTTPUrlEncoded httpUrlEncoded=(HTTPUrlEncoded)bindingInputEx.getDefinitionEx().createHTTPUrlEncoded();
                           bindingInputEx.addExtensibilityElement(httpUrlEncoded);
                   }});
               
               this.addMIMEContent.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEContent mimeContent=(MIMEContent)bindingInputEx.getDefinitionEx().createMIMEContent();
                           bindingInputEx.addExtensibilityElement(mimeContent);
                   }});
               
               this.addMIMEMultipartRelated.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEMultipartRelated mimeMultipartRelated=(MIMEMultipartRelated)bindingInputEx.getDefinitionEx().createMIMEMultipartRelated();
                           bindingInputEx.addExtensibilityElement(mimeMultipartRelated);
                   }});
               
               this.addMIMEXml.addActionListener(new ActionListener(){
                   public void actionPerformed(ActionEvent e) {
                          MIMEXml mimeXml=(MIMEXml)bindingInputEx.getDefinitionEx().createMIMEXml();
                           bindingInputEx.addExtensibilityElement(mimeXml);
                   }});
        }
        this.add(this.removeItem);
        try {
			jbInit() ;
		} catch (Exception e1) {
						e1.printStackTrace();
		}
    }
}
