
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBody;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPHeader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class BindingSOAPInputRightMenu extends AbstractTreeRightMenu {
	
	  private ResourceBundle res = ResChoose.getLanguage();
    JMenu addExtensibilityElement = new JMenu(res.getString("BSOAPIRM_AExtensibilityElement"));
    JMenuItem addSOAPBody = new JMenuItem(res.getString("BSOAPIRM_ABody"));
    JMenuItem addSOAPHeader = new JMenuItem(res.getString("BSOAPIRM_AHeader"));
    JMenuItem setName = new JMenuItem(res.getString("BSOAPIRM_SetName"));
    private void jbInit() throws Exception {
        addExtensibilityElement.add(addSOAPBody);
        addExtensibilityElement.add(addSOAPHeader);
    }
    
    public BindingSOAPInputRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof BindingInputEx) {
            final BindingInputEx bindingInputEx = (BindingInputEx) myTreeNode
                    .getWsdlLabel();
            this.setName.addActionListener(new ActionListener() {
                String initialV = bindingInputEx.getName();
                public void actionPerformed(ActionEvent e) {
                    String result = PropertyEditorFactory.showEditor(
                            BindingInputEx.ATT_NAME + ": ", ""
                                    + BindingInputEx.ATT_NAME, initialV);
                    if(result!=null){
                        bindingInputEx.setName(result);
                    }
                }
            });
            this.add(setName);
            this.add(this.addExtensibilityElement);
            this.addSOAPBody.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    SOAPBody soapBody = (SOAPBody) bindingInputEx
                            .getDefinitionEx().createSOAPBody();
                    bindingInputEx.addExtensibilityElement(soapBody);
                }
            });
            this.addSOAPHeader.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    SOAPHeader soapHeader = (SOAPHeader) bindingInputEx
                            .getDefinitionEx().createSOAPHeader();
                    bindingInputEx.addExtensibilityElement(soapHeader);
                }
            });
        }
        this.add(this.removeItem);
        try {
            jbInit();
        } catch (Exception e1) {
                        e1.printStackTrace();
        }
    }
}
