
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import javax.xml.namespace.QName;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class DefinitionRightMenu extends AbstractTreeRightMenu {
	  private ResourceBundle res = ResChoose.getLanguage();
    JMenuItem setName=new JMenuItem(res.getString("DERM_SetName"));
    JMenuItem setTargetNamespace=new JMenuItem(res.getString("DERM_SetTargetNamespace"));
    JMenuItem setNamespaces=new JMenuItem(res.getString("DERM_AODNameSpace"));
    
    public DefinitionRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof DefinitionEx) {
            final DefinitionEx definitionEx = (DefinitionEx) myTreeNode.getWsdlLabel();
            setName.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=definitionEx.getQName().getLocalPart();
                    String result=PropertyEditorFactory.showEditor(DefinitionEx.ATT_NAME+": ",res.getString("DERM_Set")+DefinitionEx.ATT_NAME,initialV);
                    if(result!=null){
                        definitionEx.setQName(new QName(result));
                    }
                }});
            this.add(setName);
            setTargetNamespace.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=definitionEx.getTargetNamespace();
                    String result=PropertyEditorFactory.showEditor(DefinitionEx.ATT_TARGET_NS+": ",res.getString("DERM_Set")+DefinitionEx.ATT_TARGET_NS,initialV);
                    if(result!=null){
                        definitionEx.setTargetNamespace(result);    
                    }
                    
                }});
            this.add(setTargetNamespace);
            setNamespaces.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    Map initialV=definitionEx.getNamespaces();
                    Map namespaces=PropertyEditorFactory.showNamespacesEditor(initialV);
                    if(namespaces!=null){
                        definitionEx.setNamespaces(namespaces);
                    }
                }});
            this.add(setNamespaces);
        }
        
    }
}
