
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ImportEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PartEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MessageEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.OutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.InputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.FaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ServiceEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.DefinitionEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SimpleTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.Combiner;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOperationEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingFaultEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBody;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPHeader;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPFault;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPBinding;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.HTTPOperation;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEContent;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEMultipartRelated;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEXml;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.MIMEPart;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;

public class MenuFactory {
    public static AbstractTreeRightMenu createMenuByNode(MyTreeNode myTreeNode){
        WSDLLabel label=null;
        if(myTreeNode.getLevel()==1&&myTreeNode.getWsdlLabel()==null){
            String nodeName=(String) myTreeNode.getUserObject();
            if(nodeName.equals("imports")){
                return new ImportsRightMenu(myTreeNode);
            }
            if(nodeName.equals("types")){
                return new TypesRightMenu(myTreeNode);
            }
            if(nodeName.equals("messages")){
                return new MessagesRightMenu(myTreeNode);
            }
            if(nodeName.equals("portTypes")){
                return new PortTypesRightMenu(myTreeNode);
            }
            if(nodeName.equals("bindings")){
                return new BindingsRightMenu(myTreeNode);
            }
            if(nodeName.equals("services")){
                return new ServicesRightMenu(myTreeNode);
            }
        }
        else if((label=myTreeNode.getWsdlLabel())!=null){
            if(label instanceof DefinitionEx){
                return new DefinitionRightMenu(myTreeNode);
            }
            if(label instanceof ImportEx){
                return new ImportRightMenu(myTreeNode);
            }
            if(label instanceof MessageEx){
                return new MessageRightMenu(myTreeNode);    
            }
            if(label instanceof PartEx){
                return new PartRightMenu(myTreeNode);
            }
            
            if(label instanceof PortTypeEx){
               return new PortTypeRightMenu(myTreeNode);
            }
            if(label instanceof OperationEx){
                return new OperationRightMenu(myTreeNode);
             }
            if(label instanceof OutputEx){
                return new OutputRightMenu(myTreeNode);
             }
            if(label instanceof InputEx){
                return new InputRightMenu(myTreeNode);
             }
            if(label instanceof FaultEx){
                return new FaultRightMenu(myTreeNode);
             }
            if(label instanceof ServiceEx){
                return new ServiceRightMenu(myTreeNode);
             }
            if(label instanceof PortEx){
            	DefinitionEx definition = label.getDefinitionEx();
            	if (definition.getBindingType() == "soap"){
                return new PortRightMenu1(myTreeNode);
            	}
            	else {
            		return new PortRightMenu2(myTreeNode);
            	}
            	
             }
            if(label instanceof SOAPAddress){
                return new SOAPAddressRightMenu(myTreeNode);
             }
            if(label instanceof HTTPAddress){
                return new HTTPAddressRightMenu(myTreeNode);
             }
            if(label instanceof SchemaEx){
                return new SchemaRightMenu(myTreeNode);
             }
            if(label instanceof ElementEx){
                return new ElementRightMenu(myTreeNode);
             }
            if(label instanceof ComplexTypeEx){
                return new ComplexTypeRightMenu(myTreeNode);
             }
            if(label instanceof SimpleTypeEx){
                return new SimpleTypeRightMenu(myTreeNode);
             }
            if(label instanceof Combiner){
                return new CombinerRightMenu(myTreeNode);
             }
            
            if(label instanceof BindingEx){
            	DefinitionEx definition =label.getDefinitionEx();
            	if (definition.getBindingType() == "soap"){
                return new BindingSOAPRightMenu(myTreeNode);
            	   }
            	else if(definition.getBindingType() == "http"){
            		return new BindingHTTPRightMenu(myTreeNode);
            	}
            	else{
            		            	}
             }
            if(label instanceof SOAPBinding){
                return new SOAPBindingRightMenu(myTreeNode);
             }
            if(label instanceof HTTPBinding){
                return new HTTPBindingRightMenu(myTreeNode);
             }
            
            
            if(label instanceof SOAPOperation){
                return new SOAPOperationRightMenu(myTreeNode);
             }
            
            if(label instanceof HTTPOperation){
                return new HTTPOperationRightMenu(myTreeNode);
             }
            
            if(label instanceof SOAPBody){
                return new SOAPBodyRightMenu(myTreeNode);
             }
            if(label instanceof SOAPHeader){
                return new SOAPHeaderRightMenu(myTreeNode);
             }
            if(label instanceof SOAPFault){
                return new SOAPFaultRightMenu(myTreeNode);
             }
            
            if(label instanceof MIMEContent){
                return new MIMEContentRightMenu(myTreeNode);
             }
            if(label instanceof MIMEMultipartRelated){
                return new MIMEMultipartRelatedRightMenu(myTreeNode);
             }
            if(label instanceof MIMEXml){
                return new MIMEXmlRightMenu(myTreeNode);
             }
            if(label instanceof MIMEPart){
                return new MIMEPartRightMenu(myTreeNode);
             }
            if(label instanceof BindingOperationEx){
            	DefinitionEx definition = label.getDefinitionEx();
            	if (definition.getBindingType() == "soap"){
                return new BindingSOAPOperationRightMenu(myTreeNode);
            	   }
            	else if(definition.getBindingType() == "http"){
            		return new BindingHTTPOperationRightMenu(myTreeNode);
            	}
            	else{
            		            	}
              }
            if(label instanceof BindingInputEx){
            	DefinitionEx definition = label.getDefinitionEx();
            	if (definition.getBindingType() == "soap"){
                return new BindingSOAPInputRightMenu(myTreeNode);
            	   }
            	else if(definition.getBindingType() == "http"){
            		return new BindingHTTPInputRightMenu(myTreeNode);
            	}
            	else{
            		            	}
              }
            
            if(label instanceof BindingFaultEx){
            	DefinitionEx definition = label.getDefinitionEx();
            	if (definition.getBindingType() == "soap"){
                return new BindingSOAPFaultRightMenu(myTreeNode);
            	   }
            	else if(definition.getBindingType() == "http"){
            		return new BindingHTTPFaultRightMenu(myTreeNode);
            	}
            	else{
            		            	}
              }
           
            if(label instanceof BindingOutputEx){
            	DefinitionEx definition = label.getDefinitionEx();
            	if (definition.getBindingType() == "soap"){
                return new BindingSOAPOutputRightMenu(myTreeNode);
            	   }
            	else if(definition.getBindingType() == "http"){
            		return new BindingHTTPOutputRightMenu(myTreeNode);
            	}
            	else{
            		            	}
              }
            if(label instanceof BindingFaultEx){
            	DefinitionEx definition =label.getDefinitionEx();
            	if (definition.getBindingType() == "soap"){
                return new BindingSOAPFaultRightMenu(myTreeNode);
            	   }
            	else if(definition.getBindingType() == "http"){
            		return new BindingHTTPFaultRightMenu(myTreeNode);
            	}
            	else{
            		            	}
              }
        }
        return null;
    }
}
