
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PortEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPAddress;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLabel;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class PortRightMenu1 extends AbstractTreeRightMenu {
	
	private ResourceBundle res = ResChoose.getLanguage();
    
	JMenuItem setBinding=new JMenuItem(res.getString("PRM1_SetBinding"));
    JMenu addExtensibilityElement=new JMenu(res.getString("PRM1_AExtensibilityElement"));
    JMenuItem addSOAPAddress = new JMenuItem(res.getString("PRM1_ASOAPAddress"));
   
    
    private void jbInit() throws Exception  {
    	addExtensibilityElement.add(addSOAPAddress);
     }
    
    
    public PortRightMenu1(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof PortEx) {
            final PortEx portEx = (PortEx) myTreeNode.getWsdlLabel();
           
            this.add(this.addExtensibilityElement);
            this.addExtensibilityElement.add(addSOAPAddress);
            this.addSOAPAddress.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    WSDLLabel label=PortRightMenu1.this.myTreeNode.getWsdlLabel();
                    if (label instanceof PortEx) {
                       PortEx portEx = (PortEx) label;
                       SOAPAddress soapAdress=(SOAPAddress)portEx.getDefinitionEx().createSOAPAddress();
                        portEx.addExtensibilityElement(soapAdress);
                    }
                }});
            
            this.setBinding.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String initialV=null;
                    try {
                        initialV=portEx.getDefinitionEx().QNameToString(portEx.getBinding().getQName());
                    } catch (NullPointerException ex) {
                    }
                    
                    List options=new Vector();
                    for (Iterator iter = portEx.getDefinitionEx().getBindings().values().iterator(); iter.hasNext();) {
                        BindingEx bindingEx = (BindingEx) iter.next();
                        options.add(portEx.getDefinitionEx().QNameToString(bindingEx.getQName()));
                    }
                    String result=PropertyEditorFactory.showEditor(PortEx.ATT_BINDING+": ",res.getString("PRM1_Set")+PortEx.ATT_BINDING,initialV,options);
                    if (result!=null) {
                        portEx.setBinding(portEx.getDefinitionEx().getBinding(portEx.getDefinitionEx().StringToQName(result)));
                    }
                }});
            this.add(setBinding);
            
            this.renameItem.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    String newName=JOptionPane.showInputDialog(MainFrame.getmainFrame(),res.getString("PRM1_NewName"),res.getString("PRM1_Rename"),JOptionPane.QUESTION_MESSAGE);
                    
                        portEx.reName(newName);
                }});
           
            this.add(this.renameItem);
        }
        
        this.add(this.removeItem);
        try {
			jbInit() ;
		} catch (Exception e1) {
						e1.printStackTrace();
		}
    }
}
