
package org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.popmenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JMenuItem;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingInputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.BindingOutputEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.PartEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SOAPBody;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.MyTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.view.propertyeditor.PropertyEditorFactory;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class SOAPBodyRightMenu extends AbstractTreeRightMenu {
	private ResourceBundle res = ResChoose.getLanguage();
   JMenuItem setParts=new JMenuItem(res.getString("SOAPBRM_SetParts"));
   JMenuItem setUse=new JMenuItem(res.getString("SOAPBRM_SetUse"));
   JMenuItem setEncodingStyle=new JMenuItem(res.getString("SOAPBRM_SetEncodingStyle"));
   JMenuItem setNamespace=new JMenuItem(res.getString("SOAPBRM_SetNameSpace"));
   
    public SOAPBodyRightMenu(MyTreeNode myTreeNode) {
        super(myTreeNode);
        if (myTreeNode.getWsdlLabel() instanceof SOAPBody) {
            final SOAPBody body = (SOAPBody) myTreeNode.getWsdlLabel();
            
            this.setParts.addActionListener(new ActionListener(){
                
                public void actionPerformed(ActionEvent e) {
                    String initialV=body.getParts();
                    List options=new Vector();
                    if(((MyTreeNode)SOAPBodyRightMenu.this.myTreeNode.getParent()).getWsdlLabel() instanceof BindingInputEx){
                        BindingInputEx bindingInputEx=(BindingInputEx)((MyTreeNode)SOAPBodyRightMenu.this.myTreeNode.getParent()).getWsdlLabel();
                        for (Iterator iter = bindingInputEx.getInputEx().getMessage().getParts().values().iterator(); iter.hasNext();) {
                            PartEx element = (PartEx) iter.next();
                            options.add(element.getName());
                        }
                    }
                    else if(((MyTreeNode)SOAPBodyRightMenu.this.myTreeNode.getParent()).getWsdlLabel() instanceof BindingOutputEx){
                        BindingOutputEx bindingOutputEx=(BindingOutputEx)((MyTreeNode)SOAPBodyRightMenu.this.myTreeNode.getParent()).getWsdlLabel();
                        for (Iterator iter = bindingOutputEx.getOutputEx().getMessage().getParts().values().iterator(); iter.hasNext();) {
                            PartEx element = (PartEx) iter.next();
                            options.add(element.getName());
                        }
                    }
                    String parts=PropertyEditorFactory.showEditor(SOAPBody.ATT_PARTS+": ",res.getString("SOAPBRM_Set")+SOAPBody.ATT_PARTS,initialV,options,true);
                    if(parts!=null){
                        body.setParts(parts);
                    }
                }});
            this.add(setParts);
            
            this.setUse.addActionListener(new ActionListener(){
                
                public void actionPerformed(ActionEvent e) {
                    String initialV=body.getUse();
                    List options=new Vector();
                    options.add("literal");
                    options.add("encoded");
                    String use=PropertyEditorFactory.showEditor(SOAPBody.ATT_USE+": ",res.getString("SOAPBRM_Set")+SOAPBody.ATT_USE,initialV,options);
                    if(use!=null){
                        body.setUse(use);
                    }
                }});
            this.add(setUse);
            
            this.setEncodingStyle.addActionListener(new ActionListener(){
                
                public void actionPerformed(ActionEvent e) {
                    String initialV=body.getEncodingStyle();
                    String result=PropertyEditorFactory.showEditor(SOAPBody.ATT_ENC_STYLE+": ",res.getString("SOAPBRM_Set")+SOAPBody.ATT_ENC_STYLE,initialV);
                    if(result!=null){
                        body.setEncodingStyle(result);
                    }
                }});
            this.add(setEncodingStyle);
            
            this.setNamespace.addActionListener(new ActionListener(){
                
                public void actionPerformed(ActionEvent e) {
                    String initialV=body.getNamespace();
                    String result=PropertyEditorFactory.showEditor(SOAPBody.ATT_NS+": ",res.getString("SOAPBRM_Set")+SOAPBody.ATT_NS,initialV);
                    if(result!=null){
                        body.setNamespace(result);
                    }
                }});
            this.add(setNamespace);
        }
               this.add(this.removeItem);
    }
}
