package org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Vector;
import javax.wsdl.Binding;
import javax.wsdl.Definition;
import javax.wsdl.Message;
import javax.wsdl.PortType;
import javax.wsdl.Service;
import javax.wsdl.Types;
import javax.wsdl.WSDLException;
import javax.wsdl.extensions.UnknownExtensibilityElement;
import javax.wsdl.factory.WSDLFactory;
import javax.wsdl.xml.WSDLWriter;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.def.process.Case;
import org.act.wsc.bpel4wsmodeling.def.process.Flow;
import org.act.wsc.bpel4wsmodeling.def.process.Invoke;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.OtherWise;
import org.act.wsc.bpel4wsmodeling.def.process.Pick;
import org.act.wsc.bpel4wsmodeling.def.process.Receive;
import org.act.wsc.bpel4wsmodeling.def.process.Reply;
import org.act.wsc.bpel4wsmodeling.def.process.Scope;
import org.act.wsc.bpel4wsmodeling.def.process.Sequence;
import org.act.wsc.bpel4wsmodeling.def.process.Switch;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;
import org.act.wsc.bpel4wsmodeling.def.process.Variables;
import org.act.wsc.bpel4wsmodeling.def.process.While;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.ExtWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyAlias;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Role;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ComplexTypeEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.ExtensibilityElementEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.SchemaEx;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.TypesEx;
import org.act.wsc.bpel4wsmodeling.utils.XMLUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
//<p></p><p></p><p></p><p></p>
public class WSDLRegistry {
  private Project project = null;
  private Vector database = new Vector();   private Vector typeIndex = new Vector();   private Vector portTypeIndex = new Vector();   private Vector messageIndex = new Vector();     private Map nslist = new HashMap();
  private Document docment = null;   public WSDLRegistry(Project prj) {
    this.project = prj;
              }
  
  public void registeWSDL(String localWSDLFile, Definition def) {
                    analyseWSDLDefinition(localWSDLFile, def);
  }
  
  private void addEntry(WSDLRegistryEntry wre) {
    database.add(wre);
        if (wre.type.equals("type")) {
      typeIndex.add(wre);
    }
    if (wre.type.equals(WSDLRegistryEntry.TYPE_PT)) {
      portTypeIndex.add(wre);
    }
    if (wre.type.equals("message")) {
      messageIndex.add(wre);
    }
  }
  
  private void removeEntry(WSDLRegistryEntry wre) {
    database.add(wre);
        if (wre.type.equals("type")) {
      typeIndex.remove(wre);
    }
    if (wre.type.equals(WSDLRegistryEntry.TYPE_PT)) {
      portTypeIndex.remove(wre);
    }
    if (wre.type.equals("message")) {
      messageIndex.remove(wre);
    }
  }
  
    private String replaceFilePath(String original) {
    if (original.indexOf('\\') != -1) {
      return original.replace('\\', '/');
    }
    else {
      return original;
    }
  }
  
  private void analyseWSDLDefinition(String wsdlSource, Definition def) {
        Iterator nsit = def.getNamespaces().values().iterator();
    while (nsit.hasNext()) {
      String curNs = (String) nsit.next();
      nslist.put(curNs, curNs);
    }
                analyseWSDLDefinitionTypes(wsdlSource, def.getTypes());
    analyseWSDLDefinitionMessages(wsdlSource, def.getMessages());
    analyseWSDLDefinitionPortType(wsdlSource, def.getPortTypes());
    analyseWSDLDefinitionBindings(wsdlSource, def.getBindings());
    analyseWSDLDefinitionServices(wsdlSource, def.getServices());
  }
 private void analyseWSDLDefinitionTypes(String wsdlSource, Types types) {
    if (types == null) {
      return;
    }
    if(types instanceof TypesEx){
        TypesEx typesEx=(TypesEx)types;
        for (Iterator iter = typesEx.getExtensibilityElements().iterator(); iter.hasNext();) {
            ExtensibilityElementEx elementEx = (ExtensibilityElementEx) iter.next();
            if (elementEx instanceof SchemaEx) {
                SchemaEx schemaEx = (SchemaEx) elementEx;
                for (Iterator iterator = schemaEx.getNamespaces().values().iterator(); iterator
                        .hasNext();) {
                    String namespace = (String) iterator.next();
                    nslist.put(namespace,namespace);
                }
              String wsdlFileAbPath=wsdlSource;
                if (wsdlFileAbPath.indexOf(GetActiveProjectDir.getactiveprodir()) == -1) {
                    wsdlFileAbPath = GetActiveProjectDir.getactiveprodir() + wsdlFileAbPath;
                }
                Element schemaElement = org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.util.WSDLReader
                            .getElement(wsdlFileAbPath, schemaEx);
     
                analyseWSDLDefinitionTypesBySchema(wsdlSource, schemaElement);
            }
        }
    }else{
        java.util.List typeElementList = types.getExtensibilityElements();
        Iterator it = typeElementList.iterator();
        while (it.hasNext()) {
          UnknownExtensibilityElement ue = (UnknownExtensibilityElement) it.next();
          if (ue.getElementType().getLocalPart().equals("schema")) {
                        Element typeElement = ue.getElement();             nslist.put(ue.getElement().getNamespaceURI(),
                       ue.getElement().getNamespaceURI());
                        analyseWSDLDefinitionTypesBySchema(wsdlSource, typeElement);
          }
          else {
                      }
        }
    }
    
  }
  
  private void analyseWSDLDefinitionTypesBySchema(String wsdlSource,
                                                  SchemaEx schemaEx) {
    String targetNamespaceUri = schemaEx.getTargetNamespace();
    for (Iterator iter = schemaEx.getComplexTypes().iterator(); iter.hasNext(); ) {
      ComplexTypeEx complexTypeEx = (ComplexTypeEx) iter.next();
      WSDLRegistryEntry wre = new WSDLRegistryEntry();
      wre.sourceWSDL = (ImportedWSDL)this.project.imports.get(wsdlSource);
      wre.localName = complexTypeEx.getName();
      wre.type = "type";
      wre.userObject = org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.
          util.WSDLReader.getComplexTypeElement(wsdlSource, complexTypeEx);
    }
  }
  
  private void analyseWSDLDefinitionTypesBySchema(String wsdlSource,
                                                  Element schemaElement) {
    String targetNamespaceUri = schemaElement.getAttribute("targetNamespace");
    NodeList nl = schemaElement.getElementsByTagName("complexType");
    for (int i = 0; i < nl.getLength(); i++) {
      Element ct = (Element) nl.item(i);
      WSDLRegistryEntry wre = new WSDLRegistryEntry();
      wre.sourceWSDL = (ImportedWSDL)this.project.imports.get(wsdlSource);
      wre.namespace = targetNamespaceUri;
      wre.localName = ct.getAttribute("name");
      wre.type = "type";
      wre.userObject = ct;       this.addEntry(wre);
    }
  }
  
  private void analyseWSDLDefinitionMessages(String wsdlSrouce, Map messages) {
    if (messages == null) {
      return;
    }
    Iterator it = messages.values().iterator();
    while (it.hasNext()) {
        Object object=it.next();
        if(!(object instanceof Message)){
            continue;
        }
      Message msg = (Message) object;
      boolean f = false;
      for (int i = 0; i < this.messageIndex.size(); i++) {
        WSDLRegistryEntry we = (WSDLRegistryEntry)this.messageIndex.get(i);
        Message message = (Message) we.userObject;
        if (message.equals(msg)) {
          f = true;
          break;
        }
        else if (message.getQName().getLocalPart().equals(
            msg.getQName().getLocalPart()) &&
                 (message.getQName().getNamespaceURI() == null ||
                  message.getQName().getNamespaceURI() == "")) {
          f = true;
                    WSDLRegistryEntry wre = (WSDLRegistryEntry) messageIndex.get(i);
          wre.sourceWSDL = (ImportedWSDL)this.project.imports.get(wsdlSrouce);
          wre.localName = msg.getQName().getLocalPart();
          wre.namespace = msg.getQName().getNamespaceURI();
          wre.userObject = msg;
                    if (this.project.getProcess() != null) {
            if (this.project.getProcess().getVariables() != null) {
              Variables vs = (Variables)this.project.getProcess().getVariables().
                  getChilds().get(0);
              if (vs.getVariables() != null) {
                for (int j = 0; j < vs.getVariables().getChilds().size(); j++) {
                  Variable v = (Variable) vs.getVariables().getChilds().get(j);
                  if (v.getAtMessageTypeValue().indexOf(":") == -1) {
                    if (v.getAtMessageTypeValue().equals(wre.localName)) {
                      ExtWsdl extWsdl = this.project.getExtWsdl();
                      Definition definition = extWsdl.getExtWsdl();
                      String prefix = definition.getPrefix(msg.getQName().
                          getNamespaceURI());
                      v.setAtMessageTypeValue(prefix + ":" +
                                              msg.getQName().getLocalPart());
                      this.project.getProcess().write();
                    }
                  }
                  else {
                  }
                }
              }
            }
          }
                    for (int t = 0; t < this.project.getPropertyAliases().size(); t++) {
            PropertyAlias proAlias = (PropertyAlias)this.project.
                getPropertyAliases().get(t);
            if (proAlias.getMessageType().getQName().getLocalPart().equals(wre.
                localName)) {
              proAlias.setMessageType(msg);
              if (this.project.getPropertyWsdl() != null) {
                PropertyWsdl propWsdl = this.project.getPropertyWsdl();
                Definition propDef = propWsdl.getPropertyWsdl();
                                List elePltList = propDef.getExtensibilityElements();
                for (int n = 0; n < elePltList.size(); n++) {
                  javax.wsdl.extensions.UnknownExtensibilityElement unEle = (
                      UnknownExtensibilityElement) elePltList.get(i);
                  Element eleProp = unEle.getElement();
                  if (eleProp.getNodeName().equals("bpws:propertyAlias")) {
                    String prefix = propDef.getPrefix(msg.getQName().
                        getNamespaceURI());
                    eleProp.setAttribute("messageType",
                                         prefix + ":" +
                                         msg.getQName().getLocalPart());
                  }
                  unEle.setElement(eleProp);
                }
                WSDLWriter wsdlWriter = propWsdl.getWSDLFactory().newWSDLWriter();
        		String fileName;
                if(this.project.getProcess()!=null){
                    fileName=this.project.getProcess().getAtNameValue();
                }
                else{
                    fileName="work";
                }
                try {
                                    String path = GetActiveProjectDir
                      .getactiveprodir()
                      + java.io.File.separator
                      + "output"
                      + java.io.File.separator
                      + "bpel"
                      + java.io.File.separator
                      + fileName + "_property.wsdl";
                  Document doc = wsdlWriter.getDocument(propDef);
                  try {
                    writeXmlFile(path, doc);
                  }
                  catch (Exception e1) {
                    e1.printStackTrace();
                  }
                }
                catch (WSDLException ex) {
                }
              }
            }
          }
          break;
        }
        else {
          f = f || false;
        }
      }
      if (f == false) {
        WSDLRegistryEntry wre = new WSDLRegistryEntry();
        wre.sourceWSDL = (ImportedWSDL)this.project.imports.get(wsdlSrouce);
        wre.namespace = msg.getQName().getNamespaceURI();
        wre.localName = msg.getQName().getLocalPart();
        wre.type = "message";
        wre.userObject = msg;
                this.addEntry(wre);
      }
    }
  }
  
  private void analyseWSDLDefinitionPortType(String wsdlSource, Map portTypes) {
    if (portTypes == null) {
      return;
    }
    Iterator it = portTypes.values().iterator();
    while (it.hasNext()) {
      PortType pt = (PortType) it.next();
      boolean f = false;
      for (int i = 0; i < this.portTypeIndex.size(); i++) {
        WSDLRegistryEntry we = (WSDLRegistryEntry)this.portTypeIndex.get(i);
        PortType porttype = (PortType) we.userObject;
        if (porttype.equals(pt)) {
          f = true;
          break;
        }
                else if (porttype.getQName().getLocalPart().equals(
            pt.getQName().getLocalPart()) &&
                 (porttype.getQName().getNamespaceURI() == null ||
                  porttype.getQName().getNamespaceURI() == "")) {
          f = true;
                              we.sourceWSDL = (ImportedWSDL)this.project.imports.get(wsdlSource);
          we.localName = pt.getQName().getLocalPart();
          we.namespace = pt.getQName().getNamespaceURI();
          we.userObject = pt;
                    if (this.project.getProcess() != null) {
            BPELProcess process = this.project.getProcess();
            this.judgeActivity(process.getActivity(), pt);           }
                    for (int j = 0; j < this.project.getRoles().size(); j++) {
            Role r = (Role)this.project.getRoles().get(j);
            if (r.getPortType().getQName().getLocalPart().equals(we.localName)) {
              r.setPortType(pt);
              if (this.project.getExtWsdl() != null) {
                ExtWsdl extWsdl = this.project.getExtWsdl();
                Definition definition = extWsdl.getExtWsdl();
                                List elePltList = definition.getExtensibilityElements();
                for (int n = 0; n < elePltList.size(); n++) {
                  javax.wsdl.extensions.UnknownExtensibilityElement unEle = (
                      UnknownExtensibilityElement) elePltList.get(i);
                  Element elePlt = unEle.getElement();
                  NodeList eleRoleList = elePlt.getElementsByTagName(
                      "plnk:role");
                  for (int a = 0; a < eleRoleList.getLength(); a++) {
                    Element eleRole = (Element) eleRoleList.item(a);
                    if (eleRole.getAttribute("name").equals(r.getName())) {                       Element elePt = (Element) eleRole.getElementsByTagName(
                          "plnk:portType").item(0);
                      String strPrefix1 = definition.getPrefix(pt.getQName().
                          getNamespaceURI());
                      elePt.setAttribute("name",
                                         strPrefix1 +
                                         elePt.getAttribute("name").substring(elePt.getAttribute( "name").indexOf( ":"),
                          elePt.getAttribute("name").length()));
                    }
                  }
                  unEle.setElement(elePlt);
                }
                WSDLWriter wsdlWriter = extWsdl.getWSDLFactory().newWSDLWriter();
        		String fileName;
                if(this.project.getProcess()!=null){
                    fileName=this.project.getProcess().getAtNameValue();
                }
                else{
                    fileName="work";
                }
                try {
                  String path = GetActiveProjectDir
                      .getactiveprodir()
                      + java.io.File.separator
                      + "output"
                      + java.io.File.separator
                      + "bpel"
                      + java.io.File.separator
                      + fileName+ "_ext.wsdl";
                  Document doc = wsdlWriter.getDocument(definition);
                  try {
                    writeXmlFile(path, doc);
                                      }
                  catch (Exception e1) {
                                        e1.printStackTrace();
                  }
                }
                catch (WSDLException ex) {
                }
              }
            }
          }
          break;
        }
        else {
          f = f || false;
        }
      }
      if (f == false) {
        WSDLRegistryEntry wre = new WSDLRegistryEntry();
        wre.sourceWSDL = (ImportedWSDL)this.project.imports.get(wsdlSource);
        wre.namespace = pt.getQName().getNamespaceURI();
        wre.localName = pt.getQName().getLocalPart();
        wre.type = WSDLRegistryEntry.TYPE_PT;
        wre.userObject = pt;
        this.addEntry(wre);
      }
    }
  }
  private long writeXmlFile(String name, Document document) throws Exception {
    DOMSource doms = new DOMSource(document);
    File file = new File(name);
    StreamResult result = new StreamResult(file);
    TransformerFactory tf = TransformerFactory.newInstance();
    Transformer transformer = tf.newTransformer();
    Properties properties = transformer.getOutputProperties();
    properties.setProperty(OutputKeys.ENCODING, "GB2312");
    properties.setProperty(OutputKeys.METHOD, "xml");
    properties.setProperty(OutputKeys.INDENT, "yes");
    transformer.setOutputProperties(properties);
    transformer.transform(doms, result);
    return 0;
  }
  
  private void analyseWSDLDefinitionBindings(String wsdlSource, Map bindings) {
    if (bindings == null) {
      return;
    }
    Iterator it = bindings.values().iterator();
    while (it.hasNext()) {
      Binding b = (Binding) it.next();
      WSDLRegistryEntry wre = new WSDLRegistryEntry();
      wre.sourceWSDL = (ImportedWSDL)this.project.imports.get(wsdlSource);
      wre.namespace = b.getQName().getNamespaceURI();
      wre.localName = b.getQName().getLocalPart();
      wre.type = "binding";
      wre.userObject = b;
      this.addEntry(wre);
    }
  }
  
  private void analyseWSDLDefinitionServices(String wsdlSource, Map services) {
    if (services == null) {
      return;
    }
    Iterator it = services.values().iterator();
    while (it.hasNext()) {
      Service s = (Service) it.next();
      WSDLRegistryEntry wre = new WSDLRegistryEntry();
      wre.sourceWSDL = (ImportedWSDL)this.project.imports.get(wsdlSource);
      wre.namespace = s.getQName().getNamespaceURI();
      wre.localName = s.getQName().getLocalPart();
      wre.type = "service";
      wre.userObject = s;
      this.addEntry(wre);
    }
  }
  
  private Vector findItemInDatabase(ImportedWSDL wsdlSource, String entryType) {
    Vector result = new Vector();
    Iterator it = database.iterator();
    while (it.hasNext()) {
      WSDLRegistryEntry wre = (WSDLRegistryEntry) it.next();
      boolean bChoosed = true;
      if (wsdlSource != null) {
        if (wre.sourceWSDL.toString().equals(wsdlSource.toString())) {
          bChoosed = true;
        }
        else {
          bChoosed = false;
        }
      }
      if (entryType != null && !entryType.equals("")) {
        if (wre.type.equals(entryType)) {
          bChoosed = bChoosed && true;
        }
        else {
          bChoosed = false;
        }
      }
      if (bChoosed) {
        result.add(wre);
      }
    }
    return result;
  }
  private Vector findItem(ImportedWSDL wsdlSource, Vector target) {
    Vector result = new Vector();
    String key = wsdlSource.toString();
    Iterator it = target.iterator();
    while (it.hasNext()) {
      WSDLRegistryEntry wre = (WSDLRegistryEntry) it.next();
      if (wre.sourceWSDL.toString().equals(key)) {
        result.add(wre);
      }
    }
    return result;
  }
  
  public Vector findTypes() {
    return this.typeIndex;
  }
  public Vector findTypes(ImportedWSDL wsdlSource) {
    if (wsdlSource == null) {
      return this.typeIndex;
    }
    return findItem(wsdlSource, this.typeIndex);
  }
  public Vector findMessages() {
    return this.messageIndex;
  }
  public Vector findMessages(ImportedWSDL wsdlSource) {
    if (wsdlSource == null) {
      return this.messageIndex;
    }
    return findItem(wsdlSource, this.messageIndex);
  }
  
  public Vector findPortTypes() {
    return this.portTypeIndex;
  }
  
  public Vector findPortTypes(ImportedWSDL wsdlSource) {
    if (wsdlSource == null) {
      return this.portTypeIndex;
    }
    return findItem(wsdlSource, this.portTypeIndex);
  }
  public Vector findServices() {
    return this.findItemInDatabase(null, "service");
  }
  public Vector findServices(ImportedWSDL wsdl) {
    return this.findItemInDatabase(wsdl, "service");
  }
  
  public Vector findAllNamespace() {
    Vector result = new Vector();
    Map buffer = null;
    buffer = (Map) ( (HashMap) nslist).clone();
    Iterator it = database.iterator();
    while (it.hasNext()) {
      WSDLRegistryEntry wre = (WSDLRegistryEntry) it.next();
      buffer.put(wre.namespace, wre.namespace);
    }
        it = buffer.values().iterator();
    while (it.hasNext()) {
      result.add( (String) it.next());
    }
    return result;
  }
  
  private ImportedWSDL getUserDefinedImportedWSDL() {
    ImportedWSDL result = null;
    Iterator it = this.project.imports.values().iterator();
    while (it.hasNext()) {
      ImportedWSDL thisWsdl = (ImportedWSDL) it.next();
      if (thisWsdl.wsdlRetrieveMode.equals("UserDefined")) {
        result = thisWsdl;
        break;
      }
    }
    return result;
  }
  
  private void saveWSDLDefinition(Definition def, String replicaUrl) {
        com.ibm.wsdl.xml.WSDLWriterImpl ww = new com.ibm.wsdl.xml.WSDLWriterImpl();
    Document doc = null;
    try {
      System.out.println("def:" + def);
      doc = ww.getDocument(def);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    Element docElement = doc.getDocumentElement();
    
        System.out.println("WSDLRegistry replicaUrl:" + replicaUrl);
    File wsdlFile = new File(replicaUrl);
    Source source = new DOMSource(docElement);
    Result result = new StreamResult(wsdlFile);
    TransformerFactory tf = TransformerFactory.newInstance();
    javax.xml.transform.Transformer tran = null;
    try {
      tran = tf.newTransformer();
      tran.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "no");
      tran.transform(source, result);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  public void updateUserDefinedWSDL(Definition def) {
    ImportedWSDL wsdl = null;
    String replicaUrl = "";
        wsdl = this.getUserDefinedImportedWSDL();     replicaUrl = wsdl.wsdlReplicaUrl;
                        cleanAll();
    reloadAllWSDLs(def);
  }
  
  private void cleanAll() {
    this.database.clear();
    this.portTypeIndex.clear();
    this.typeIndex.clear();
    this.messageIndex.clear();
  }
  
  private void reloadAllWSDLs(Definition def) {
        Iterator it = this.project.imports.values().iterator();
    while (it.hasNext()) {
      ImportedWSDL thisWsdl = (ImportedWSDL) it.next();
      if(thisWsdl.wsdlRetrieveMode.equals(ImportedWSDL.MOD_USERDEF)){
          if(def==null){
             def=this.project.getUserWSDLDefinition(thisWsdl.wsdlReplicaUrl); 
          }
          this.registeWSDL(thisWsdl.wsdlReplicaUrl, def);
      }
      else{
          this.registeWSDL(thisWsdl.wsdlReplicaUrl, this.project.getWSDLDefinition(thisWsdl.wsdlReplicaUrl));
      }
    }
  }
  
  private WSDLRegistryEntry findWSDLRegistryEntry(Iterator it, String ns,
                                                  String localp) {
        while (it.hasNext()) {
      WSDLRegistryEntry wre = (WSDLRegistryEntry) it.next();
      if (wre.namespace.equals(ns) && wre.localName.equals(localp)) {
        return wre;
      }
    }
    return null;
  }
  
  public WSDLRegistryEntry findPortType(String namespace, String localPart) {
    return this.findWSDLRegistryEntry(this.portTypeIndex.iterator(), namespace,
                                      localPart);
  }
  public WSDLRegistryEntry findType(String namespace, String localPart) {
    return this.findWSDLRegistryEntry(this.typeIndex.iterator(), namespace,
                                      localPart);
  }
  public WSDLRegistryEntry findMessage(String namespace, String localPart) {
    return this.findWSDLRegistryEntry(this.messageIndex.iterator(), namespace,
                                      localPart);
  }
  public WSDLRegistryEntry findService(String namespace, String localPart) {
    return this.findWSDLRegistryEntry(this.database.iterator(), namespace,
                                      localPart);
  }
  public void addPortType(WSDLRegistryEntry pt) {
    this.addEntry(pt);
  }
    public void removePortType(WSDLRegistryEntry pt) {
      this.removeEntry(pt);
  }
  
  public void addMessage(WSDLRegistryEntry wre) {
    this.addEntry(wre);
  }
    public void removeMessage(WSDLRegistryEntry wre) {
      this.removeEntry(wre);
  }
  private void judgeActivity(Metaset ss, PortType pt) {
    if (ss instanceof Invoke) {
      Invoke invoke = (Invoke) ss;
      if (invoke.getAtPortTypeValue().indexOf(":") == -1) {
        if (invoke.getAtPortTypeValue().equals(pt.getQName().getLocalPart())) {
          ExtWsdl extWsdl = this.project.getExtWsdl();
          Definition definition = extWsdl.getExtWsdl();
          String prefix = definition.getPrefix(pt.getQName().getNamespaceURI());
          invoke.setAtPortTypeValue(prefix + ":" + pt.getQName().getLocalPart());
          this.project.getProcess().write();
        }
      }
    }
    else if (ss instanceof Receive) {
      Receive receive = (Receive) ss;
      if (receive.getAtPortTypeValue().indexOf(":") == -1) {
        if (receive.getAtPortTypeValue().equals(pt.getQName().getLocalPart())) {
          ExtWsdl extWsdl = this.project.getExtWsdl();
          Definition definition = extWsdl.getExtWsdl();
          String prefix = definition.getPrefix(pt.getQName().getNamespaceURI());
          receive.setAtPortTypeValue(prefix + ":" + pt.getQName().getLocalPart());
          this.project.getProcess().write();
        }
      }
    }
    else if (ss instanceof Reply) {
      Reply reply = (Reply) ss;
      if (reply.getAtPortTypeValue().indexOf(":") == -1) {
        if (reply.getAtPortTypeValue().equals(pt.getQName().getLocalPart())) {
          ExtWsdl extWsdl = this.project.getExtWsdl();
          Definition definition = extWsdl.getExtWsdl();
          String prefix = definition.getPrefix(pt.getQName().getNamespaceURI());
          reply.setAtPortTypeValue(prefix + ":" + pt.getQName().getLocalPart());
          this.project.getProcess().write();
        }
      }
    }
    else if (ss instanceof Sequence || ss instanceof Flow ||
             ss instanceof While || ss instanceof Scope) {
      if (ss.filter(".\\*").getChilds() != null) {
        for (int i = 0; i < ss.filter(".\\*").getChilds().size(); i++) {
          Metaset sst = (Metaset) ss.filter(".\\*").getChilds().get(i);
          judgeActivity(sst, pt);
        }
      }
    }
    else if (ss instanceof Switch) {
      Switch switch1 = (Switch) ss;
      if (switch1.filter(".\\case") != null) {
        Metaset casess = switch1.filter(".\\case");
        for (int i = 0; i < casess.getChilds().size(); i++) {
          Case caseClause = (Case) casess.getChilds().get(i);
          if (caseClause.getActivity() != null) {
            judgeActivity(caseClause.getActivity(), pt);
          }
        }
      }
      OtherWise otherwise = switch1.getOtherWise();
      if (otherwise != null) {
        if (otherwise.getActivity() != null) {
          judgeActivity(otherwise.getActivity(), pt);
        }
      }
    }
    else if (ss instanceof Pick) {
      Pick pick = (Pick) ss;
      if (pick.filter("\\onMessage") != null) {
        Metaset onMessagess = pick.filter(".\\onMessage");
        for (int i = 0; i < onMessagess.getChilds().size(); i++) {
          OnMessage onMessage = (OnMessage) onMessagess.getChilds().get(i);
          if (onMessage.getAtPortTypeValue().indexOf(":") == -1) {
            if (onMessage.getAtPortTypeValue().equals(pt.getQName().
                getLocalPart())) {
              ExtWsdl extWsdl = this.project.getExtWsdl();
              Definition definition = extWsdl.getExtWsdl();
              String prefix = definition.getPrefix(pt.getQName().
                  getNamespaceURI());
              onMessage.setAtPortTypeValue(prefix + ":" +
                                           pt.getQName().getLocalPart());
              this.project.getProcess().write();
            }
          }
          if (onMessage.getActivity() != null) {
            judgeActivity(onMessage.getActivity(), pt);
          }
        }
      }
      if (pick.filter("\\onAlarm") != null) {
        Metaset onAlarmss = pick.filter(".\\onAlarm");
        for (int i = 0; i < onAlarmss.getChilds().size(); i++) {
          OnAlarm onAlarm = (OnAlarm) onAlarmss.getChilds().get(i);
          if (onAlarm.getActivity() != null) {
            judgeActivity(onAlarm.getActivity(), pt);
          }
        }
      }
    }
    else {
    }
      }
}
