
package org.act.wsc.bpel4wsmodeling.resource;
import java.awt.Image;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import javax.swing.ImageIcon;

public class ResourceManager {
	private static Map imagesMap = new HashMap();
	private static final String GRAPHIC_IMAGES_BUNDLE= "org.act.wsc.bpel4wsmodeling.resource.graphicImages";
	private static ResourceBundle graphicImagesBundle = ResourceBundle.getBundle(GRAPHIC_IMAGES_BUNDLE);	
    private static final String IMAGES_ICON_BUNDLE ="org.act.wsc.bpel4wsmodeling.resource.imageIcons";
	private static ResourceBundle imageIconsBundle = ResourceBundle.getBundle(IMAGES_ICON_BUNDLE);
	private static final String IMAGES_BUNDLE ="org.act.wsc.bpel4wsmodeling.resource.images";
	private static ResourceBundle imagesBundle = ResourceBundle.getBundle(IMAGES_BUNDLE);
	
	public static ImageIcon getImageIcon(String key) {
		Object obj = imagesMap.get(key);
		if (obj!=null) {
			return (ImageIcon)obj;
		}
		String value = null;
		try {
			 value = imageIconsBundle.getString(key);
		} catch (MissingResourceException e) {
		}
		if (value==null) {
			value = key;
		}
		URL url = ResourceManager.class.getResource(value);
		if (url!=null) {
			ImageIcon icon = new ImageIcon(url);
			imagesMap.put(key, icon);
			return icon;
		}
		return null;
	}
	
    public static ImageIcon getGraphicImage(String key) {
        Object obj = imagesMap.get(key);
		if (obj!=null) {
			return (ImageIcon)obj;
		}
        String value = null;
        try {
          value = graphicImagesBundle.getString(key);
        }
        catch (MissingResourceException e) {
        }
        if (value == null) {
          value = key;
        }
        URL url = ResourceManager.class.getResource(value);
        if (url != null) {
			ImageIcon image = new ImageIcon(url);
          imagesMap.put(key, image);
          return image;
        }
        return null;
      }
    
    public static ImageIcon getImage(String key) {
		Object obj = imagesMap.get(key);
		if (obj!=null) {
			return (ImageIcon)obj;
		}
		String value = null;
		try {
			 value = imagesBundle.getString(key);
		} catch (MissingResourceException e) {
		}
		if (value==null) {
			value = key;
		}
		URL url = ResourceManager.class.getResource(value);
		if (url!=null) {
			ImageIcon icon = new ImageIcon(url);
			imagesMap.put(key, icon);
			return icon;
		}
		return null;
	}
    
}
