
package org.act.wsc.bpel4wsmodeling.view.action;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.utils.CommonUtils;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class GenerateDeploymentUnitAction implements ActionListener {
    Project project;
    ResourceBundle res = ResChoose.getLanguage();
    BPELProcess process;
        
    public GenerateDeploymentUnitAction(Project proj) {
        this.project = proj;
        this.process = this.project.getProcess();
    }
    
public void actionPerformed(ActionEvent e) {
                String name = this.process.getAtNameValue();
        String projectDir = GetActiveProjectDir.getactiveprodir();
        String barDir = projectDir + File.separator + "output" + File.separator
                + "bar";
        File outputFolder = new File(barDir);
        if (outputFolder.exists()) {
            outputFolder.delete();
        }
        outputFolder.mkdirs();
        String targetFolder = barDir + File.separator + name;
        File temp = new File(targetFolder);
        temp.mkdir();
        String wsdlDir = projectDir + File.separator + "imports"
                + File.separator;
        String bpelDir = projectDir + File.separator + "output"
                + File.separator + "bpel" + File.separator;
        try {
            String bpOutputFolder = targetFolder + File.separator
                    + "\\META-INF\\" + File.separator;
            File metaFolder = new File(bpOutputFolder);
            metaFolder.mkdirs();
            java.util.List listSpe = new Vector();
            listSpe.add("wsdl");
            listSpe.add("bpel");
            
            CommonUtils.copyDirectorySpecFiles(wsdlDir, bpOutputFolder,
                    listSpe, false);
            CommonUtils.copyDirectorySpecFiles(bpelDir, bpOutputFolder,
                    listSpe, false);
            
                        for (int i = 0; i < metaFolder.listFiles().length; i++) {
                File file = metaFolder.listFiles()[i];
                if(file.getName().equals("userDefined.wsdl")){
                    file.renameTo(new File(bpOutputFolder+name+".wsdl"));
                    break;
                }
            }
            this.generateBarFile(name, barDir);
            this.removeRubbish( targetFolder+File.separator );
            JOptionPane.showMessageDialog(MainFrame.getmainFrame(),res.getString("underTheDirectory")+barDir+res.getString("executableArchiveCreated")+name+".bar",res.getString("prompt"),JOptionPane.PLAIN_MESSAGE);
            Print.showMessage(res.getString("executableArchive")+name+res.getString("barCreated"));
        } catch (Exception e1) {
                        e1.printStackTrace();
        }
    }
    
    private void generateBarFile(String name, String path) {
        
                String wsarFile = path + File.separator + name + ".bar";
        FileOutputStream out = null;
        try {
            out = new FileOutputStream(wsarFile);
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }
                String curPath = path + File.separator + name + File.separator;
        String curParentPath = path + File.separator + name;
        java.util.zip.ZipOutputStream zos = new java.util.zip.ZipOutputStream(
                out);
        try {
            CommonUtils.addFile2Zip(zos, curPath, curParentPath, "bar");
            zos.close();
        } catch (Exception ex1) {
            ex1.printStackTrace();
        }
    }
    
    private void removeRubbish(String bpThisProcessFolder) {
        CommonUtils.deleteDirectory(bpThisProcessFolder);
    }
}
