
package org.act.wsc.bpel4wsmodeling.view.action;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ResourceBundle;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.utils.WSFilter;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.gui.OpenProjectDialog;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class OpenProjectAction
    implements ActionListener {
	ResourceBundle res = ResChoose.getLanguage();
  
  public OpenProjectAction() {
    super();
      }
  
  public void actionPerformed(ActionEvent e) {
      if(!new CloseProjectAction().closeProject()){
                    return;
      }
                  WSFilter filter = new WSFilter();
      filter.addExtension("awp");
      filter.setDescription("ACT WSWorkflow Project");
      JFileChooser fileChooser = new JFileChooser(System
              .getProperty("user.dir"));
      fileChooser.setFileFilter(filter);
      fileChooser.setMultiSelectionEnabled(true);
      int state = fileChooser.showOpenDialog(MainFrame.getmainFrame());
      if (state == JFileChooser.APPROVE_OPTION) {
          File file = fileChooser.getSelectedFile();
          String projectRealName = file.getAbsolutePath();
          if(projectRealName!=null&&projectRealName!=""){
              String projectName = projectRealName.substring(projectRealName
                      .lastIndexOf(File.separator) + 1, projectRealName
                      .lastIndexOf('.'));
              if (projectName != "") {
                  if (WorkSpace.getInstance().getProjects().containsKey(
                          projectName)) {
                      Print.showMessage(res.getString("sameName_projectExist"),Print.MESSAGE_TYPE_WARNING  );
                      JOptionPane.showMessageDialog(null, res.getString("sameName_WithOtheProject"),
                              res.getString("sameName_projectExist"), JOptionPane.WARNING_MESSAGE);
                      return;
                  } else {
                      
                                            String projectDir = projectRealName.substring(0, projectRealName.lastIndexOf(File.separator));
                                            GetActiveProjectDir.setdir(projectDir);
                      WorkSpace.getInstance().openProject(projectRealName);
                      Print.showMessage(res.getString("project")+projectName+" "+res.getString("opened"));
                  }
              }
          }
          
      }
  }
}
