
package org.act.wsc.bpel4wsmodeling.view.graphic;
import java.awt.event.MouseEvent;
import org.act.wsc.bpel4wsmodeling.debug.engine.WSWF;
import org.act.wsc.bpel4wsmodeling.global.Application;
import org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty.AbstractLeftProperty;
import org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty.AddPropertyByType;
import org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty.LeftPropertyFactory;
import org.act.wsc.bpel4wsmodeling.view.graphic.rightbuttonmenu.AbstractRightMenu;
import org.act.wsc.bpel4wsmodeling.view.graphic.rightbuttonmenu.RightMenuFactory;

public class CommonClicker extends AClicker {
    AbstractLeftProperty property;
    
    public CommonClicker(FigureViewer myViewer) {
        super(myViewer);
            }
    
    void singleClicked(MouseEvent e) {
        if (this.property == null) {
            property = LeftPropertyFactory.createLeftPropertyByFigure(myViewer
                    .getFigure());
        }
        if (property != null) {
            property.setAttTable();
        }
        AddPropertyByType.addPropertyToFrameByType(myViewer.getFigure(),
                property);
    }
    
    void doubleClicked(MouseEvent e) {
                        if (myViewer.figure.getOwner().isInDebug()) {
            String debugId=myViewer.getFigure().getDebugId();
            if(debugId!=null){
                if(WSWF.setDebug(debugId)){
                    myViewer.getFigure().resetBreakpoint();
                }
            }
        }
    }
    
    void rightClicked(MouseEvent e) {
                AbstractRightMenu popMenu = RightMenuFactory
                .createRightMenuByFigure(myViewer.getFigure());
        popMenu.show(myViewer, e.getX(), e.getY());
    }
}
