
package org.act.wsc.bpel4wsmodeling.view.graphic;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ResourceBundle;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import org.act.wsc.bpel4wsmodeling.projectdata.*;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.FlowFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.MetaFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.PickFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.ScopeFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.SequenceFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.SwitchFigure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.WhileFigure;
import org.act.wsc.bpel4wsmodeling.resource.ResourceManager;
import org.act.wsc.bpel4wsmodeling.resource.StandardImageIcon;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import javax.swing.BorderFactory;

public class GraphicToolBar extends AGraphicToolBar {
	ResourceBundle res = ResChoose.getLanguage();
    
    public GraphicToolBar() {
        super(HORIZONTAL);
                jbInit();
    }
    
    private void jbInit() {
                classes = new Class[] { null, MetaFigure.class, MetaFigure.class,
                MetaFigure.class, MetaFigure.class, MetaFigure.class,
                MetaFigure.class, MetaFigure.class, MetaFigure.class,
                SequenceFigure.class, SwitchFigure.class, WhileFigure.class,
                PickFigure.class, FlowFigure.class, ScopeFigure.class,
                MetaFigure.class };
        toolTips = new String[] { res.getString("chooseobject"), "receive", "reply", "invoke", "assign", "throw", "empty", "wait", "terminate", "sequence",
                "switch", "while", "pick", "flow", "scope", "transaction" };
        types = new int[] { 0, Figure.LABLE_RECEIVE, Figure.LABLE_REPLY,
                Figure.LABLE_INVOKE, Figure.LABLE_ASSIGN, Figure.LABLE_THROW,
                Figure.LABLE_EMPTY, Figure.LABLE_WAIT, Figure.LABLE_TERMINATE,
                Figure.LABLE_SEQUENCE, Figure.LABLE_SWITCH, Figure.LABLE_WHILE,
                Figure.LABLE_PICK, Figure.LABLE_FLOW, Figure.LABLE_SCOPE,
                Figure.LABLE_TRANSACTION };
        imageIcons = new ImageIcon[] {
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_SELECT),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_RECEIVE),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_REPLY),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_INVOKE),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_ASSIGN),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_THROW),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_EMPTY),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_WAIT),
                ResourceManager
                        .getImageIcon(StandardImageIcon.GRAPHIC_TERMINATE),
                ResourceManager
                        .getImageIcon(StandardImageIcon.GRAPHIC_SEQUENCE),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_SWITCH),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_WHILE),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_PICK),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_FLOW),
                ResourceManager.getImageIcon(StandardImageIcon.GRAPHIC_SCOPE),
                ResourceManager
                        .getImageIcon(StandardImageIcon.GRAPHIC_TRANSACTION) };
        toggleButtons = new MyToggledButton[] { new MyToggledButton(this),
                new MyToggledButton(this), new MyToggledButton(this),
                new MyToggledButton(this), new MyToggledButton(this),
                new MyToggledButton(this), new MyToggledButton(this),
                new MyToggledButton(this), new MyToggledButton(this),
                new MyToggledButton(this), new MyToggledButton(this),
                new MyToggledButton(this), new MyToggledButton(this),
                new MyToggledButton(this), new MyToggledButton(this),
                new MyToggledButton(this) };
        buttonGroup = new ButtonGroup();
        for (int i = 0; i < toggleButtons.length; i++) {
            toggleButtons[i].setMinimumSize(new Dimension(35, 30));
            toggleButtons[i].setPreferredSize(new Dimension(35, 30));
            toggleButtons[i].setIcon(imageIcons[i]);
            toggleButtons[i].setToolTipText(toolTips[i]);
            toggleButtons[i].addMouseListener(new MouseAdapter() {
                public void mouseClicked(MouseEvent e) {
                    if (e.getButton() == 1 && e.getClickCount() == 2) {
                        GraphicToolBar.this.doublePressed = true;
                    } else if (e.getButton() == 1 && e.getClickCount() == 1) {
                        GraphicToolBar.this.doublePressed = false;
                    }
                }
            });
            this.add(toggleButtons[i], null);
            buttonGroup.add(toggleButtons[i]);
        }
        toggleButtons[0].setSelected(true);
        this.setBorder(BorderFactory.createEmptyBorder(6, 6, 6, 6));                            }
}
