package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;
import org.act.wsc.bpel4wsmodeling.def.process.Assign;
import org.act.wsc.bpel4wsmodeling.def.process.Copy;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
public class AssignProperty
    extends AbstractActProperty {
	
	 ResourceBundle res = ResChoose.getLanguage();
	 
  Assign assign;
  List copies = new Vector();
  JTable jCopyTable;
  DefaultTableModel defaultCopyTableModel;
  String name = null;
  String joinCondition = null;
  String suppressJoinFailure = null;
  public AssignProperty(Figure f) {
    super(f);
    assign = (Assign)this.act;
    this.defaultCopyTableModel = new DefaultTableModel() {
      public boolean isCellEditable(int row, int column) {
        return false;
      }
    };
    initAttTable();
    initCopyTable();
  }
  
  void initAttTable() {
    name = this.act.getAtNameValue();
    joinCondition = this.act.getAtJoinConditionValue();
    suppressJoinFailure = this.act.getAtsuppressJoinFailureValue();
    defaultAttTableModel.setDataVector(
        new Object[][] { {"name", name}
        , {"joinCondition", joinCondition}
        , {"suppressJoinFailure", suppressJoinFailure}
    }
        ,
        new Object[] {
        res.getString("propertyname"), res.getString("propertyvalue")});
    txtname = new JTextField();
    txtname.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtNameValue(txtname.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.txtjoinCondition = new JTextField();
    txtjoinCondition.addKeyListener(new KeyListener() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          act.setAtJoinConditionValue(txtjoinCondition.getText());
          process.write();
        }
      }
      public void keyReleased(KeyEvent e) {
      }
      public void keyTyped(KeyEvent e) {
      }
    }
    );
    this.comBoxsuppressJoinFailure = new JComboBox();
    this.comBoxsuppressJoinFailure.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(comBoxsuppressJoinFailure)) {
          act.setAtSuppressJoinFailureValue(comBoxsuppressJoinFailure.
                                            getSelectedItem().toString());
          process.write();
        }
      }
    });
    
    EachRowRenderer rowRenderer = new EachRowRenderer();
    
    EachRowEditor rowEditor = new EachRowEditor(jAttTable);
    DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
    DefaultCellEditor txtJoinConditionEditor = new DefaultCellEditor(
        txtjoinCondition);
    DefaultCellEditor txtSuppressJoinFailureEditor = new DefaultCellEditor(
        comBoxsuppressJoinFailure);
    rowEditor.setEditorAt(0, txtnameEditor);
    rowEditor.setEditorAt(1, txtJoinConditionEditor);
    rowEditor.setEditorAt(2, txtSuppressJoinFailureEditor);
    this.jAttTable.getColumn("ֵ").setCellRenderer(rowRenderer);
    this.jAttTable.getColumn("ֵ").setCellEditor(rowEditor);
  }
  void initCopyTable() {
    this.defaultCopyTableModel.setDataVector(
        new Object[][] {
    }
        ,
        new Object[] {
        "Copies"});
        if (this.assign.getCopies() != null) {
      for (int i = 0; i < this.assign.getCopies().getChilds().size(); i++) {
        Copy copy = (Copy)this.assign.getCopies().getChilds().get(i);
        this.copies.add(copy);
        
        Object[] data = new Object[] {
            "copy"};
        this.defaultCopyTableModel.addRow(data);
      }
    }
    this.jCopyTable = new JTable(defaultCopyTableModel);
    this.jCopyTable.addMouseListener(new MouseAdapter() {       public void mouseClicked(MouseEvent e) {
        if (e.getButton() == 3) {
          int i = jCopyTable.getSelectedRow();
          if (i != -1) {
            Copy copy = (Copy) copies.get(i);
            AssignPropertyRightMenu rightMenu = new AssignPropertyRightMenu(
                copy, figure);
            rightMenu.show(jCopyTable, e.getX(), e.getY());
          }
        }
      }
    });
  }
  
  public void addCopy(Copy c) {
    if (!this.copies.contains(c)) {
      this.copies.add(c);
      Object[] data = new Object[] {
          "copy"};
      this.defaultCopyTableModel.addRow(data);
    }
  }
  
  public void deleteCopy(Copy c) {
    if (this.copies.contains(c)) {
      this.defaultCopyTableModel.removeRow(this.copies.indexOf(
          c));
      this.copies.remove(c);
    }
  }
  public JTable getCopyTable() {
    return this.jCopyTable;
  }
  
  public void setAttTable() {
    List it6 = new Vector();
    int j6 = this.comBoxsuppressJoinFailure.getActionListeners().length - 1;
    for (int i = j6; i >= 0; i--) {
      ActionListener it = this.comBoxsuppressJoinFailure.getActionListeners()[i];
      it6.add(it);
      this.comBoxsuppressJoinFailure.removeActionListener(it);
    }
    comBoxsuppressJoinFailure.removeAllItems();
    comBoxsuppressJoinFailure.addItem("yes");
    comBoxsuppressJoinFailure.addItem("no");
    if (assign != null) {
      this.txtname.setText(this.name);
      this.txtjoinCondition.setText(this.joinCondition);
      for (int f = 0; f < this.comBoxsuppressJoinFailure.getItemCount(); f++) {
        String txtcon = (String)this.comBoxsuppressJoinFailure.getItemAt(f);
        if (this.suppressJoinFailure.equals(txtcon)) {
          this.comBoxsuppressJoinFailure.setSelectedIndex(f);
          break;
        }
      }
    }
    for (int i = 0; i < it6.size(); i++) {
      ActionListener it = (ActionListener) it6.get(i); ;
      this.comBoxsuppressJoinFailure.addActionListener(it);
    }
  }

public void addCorrelation(Correlation c) {
		
}

public void deleteCorrelation(Correlation correlation) {
		
}

public void correlatinNameUpdate(Correlation c, String s) {
		
}
}
