package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
//<p></p><p></p><p></p><p></p>
public class LeftPropertyFactory {
  public LeftPropertyFactory() {
  }
  public static AbstractLeftProperty createLeftPropertyByFigure(Figure figure) {
    switch (figure.getType()) {
      case Figure.LABLE_RECEIVE:
        return new ReceiveProperty(figure);
      case Figure.LABLE_ONMESSAGE:
        return new OnMessageProperty(figure);
      case Figure.LABLE_INVOKE:
        return new InvokeProperty(figure);
      case Figure.LABLE_REPLY:
        return new ReplyProperty(figure);
      case Figure.LABLE_SWITCH:
        return new SwitchProperty(figure);
      case Figure.LABLE_CASE:
        return new CaseProperty(figure);
      case Figure.LABLE_THROW:
        return new ThrowProperty(figure);
      case Figure.LABLE_EMPTY:
        return new EmptyProperty(figure);
      case Figure.LABLE_TERMINATE :
        return new TerminateProperty(figure);
      case Figure.LABLE_FLOW:
        return new FlowProperty(figure);
      case Figure.LABLE_ONALARM:
        return new OnAlarmProperty(figure);
      case Figure.LABLE_PICK:
        return new PickProperty(figure);
      case Figure.LABLE_SCOPE:
        return new ScopeProperty(figure);
      case Figure.LABLE_SEQUENCE:
        return new SequenceProperty(figure);
      case Figure.LABLE_WAIT:
        return new WaitProperty(figure);
      case Figure.LABLE_WHILE:
        return new WhileProperty(figure);
      case Figure.LABLE_ASSIGN:
        return new AssignProperty(figure);
      case Figure.LABLE_COMPENSATE :
        return new CompensateProperty(figure);
      case Figure.LABLE_TRANSACTION:
          return new TransactionProperty(figure);
      default:
        return null;
    }
  }
}
