
package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.ResourceBundle;
import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;
import org.act.wsc.bpel4wsmodeling.def.process.OnAlarm;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class OnAlarmProperty
    extends AbstractLeftProperty {
	 ResourceBundle res = ResChoose.getLanguage();
  OnAlarm label;
  JTable jTable = new JTable();
  JTextField forField = new JTextField();
  JTextField untilField = new JTextField();
  String forCondition = null;
  String untilCondition = null;
  
  public OnAlarmProperty(Figure figure) {
    super(figure);
    label = (OnAlarm) figure.getServicesSet();
    this.initAttTable();
  }
  
  void initAttTable() {
    forCondition = label.getAtForTimesValue();
    untilCondition = label.getAtUntilValue();
    defaultAttTableModel.setDataVector(new Object[][] { {"for", forCondition}
                                       , {"Until", untilCondition}
    }
                                       ,
                                       new Object[] {res.getString("propertyname"), res.getString("propertyvalue")});
    this.forField.addKeyListener(new KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          label.setAtForTimeValue(forField.getText());
          process.write();
        }
        if (forField.getText() == null || forField.getText().equals("")) {
          untilField.setEditable(true);
        }
        else {
          untilField.setEditable(false);
        }
      }
    });
    this.untilField.addKeyListener(new KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
          label.setAtUntilValue(untilField.getText());
          process.write();
        }
        if (untilField.getText() == null || untilField.getText().equals("")) {
          forField.setEditable(true);
        }
        else {
          forField.setEditable(false);
        }
      }
    });
    EachRowRenderer rowRenderer = new EachRowRenderer();
    EachRowEditor rowEditor = new EachRowEditor(jAttTable);
    DefaultCellEditor txtForEditor = new DefaultCellEditor(this.forField);
    DefaultCellEditor txtUntilEditor = new DefaultCellEditor(
        this.untilField);
    rowEditor.setEditorAt(0, txtForEditor);
    rowEditor.setEditorAt(1, txtUntilEditor);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
  }
  
  public void setAttTable() {
    if(this.label !=null){
      this.forField .setText(this.forCondition ) ;
      this.untilField .setText(this.untilCondition ) ;
    }
  }
}
