package org.act.wsc.bpel4wsmodeling.view.graphic.leftbuttonproperty;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.wsdl.Definition;
import javax.wsdl.Message;
import javax.wsdl.Operation;
import javax.wsdl.PortType;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.INoActivityChildListener;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.PartnerLink;
import org.act.wsc.bpel4wsmodeling.def.process.PartnerLinks;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.ExtWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.OperationWrapper;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PartnerLinkType;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistry;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistryEntry;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
//<p></p><p></p><p></p><p></p>
public class OnMessageProperty
    extends AbstractLeftProperty
    implements
    INoActivityChildListener {
	 ResourceBundle res = ResChoose.getLanguage();
  JComboBox jComboxPartnerLink;
  JComboBox jComboxPortType;
  JComboBox jComboxOperation;
  JComboBox jComboxVariable;
  PartnerLinkType plinkType;
  OnMessage onMessage;
  Project project;
  MainFrame frame = MainFrame.getmainFrame();
  String partnerLink = null;
  String portType = null;
  String operation = null;
  String variable = null;
  JTable jCorrelationTable;
  DefaultTableModel defaultCorrelationTableModel;
  List correlations = new Vector();
  public OnMessageProperty(Figure f) {
    super(f);
    onMessage = (OnMessage) f.getServicesSet();
    onMessage.addChildListeners(this);
    project = this.frame.getProject();
    initAttTable();
    this.defaultCorrelationTableModel = new DefaultTableModel() {
      public boolean isCellEditable(int row, int column) {
        return false;
      }
    };
    initCorrelationTable();
  }
  
  void initAttTable() {
    partnerLink = onMessage.getAtPartnerLinkValue();
    portType = onMessage.getAtPortTypeValue();
    operation = onMessage.getAtOperationValue();
    variable = onMessage.getAtVariableValue();
    defaultAttTableModel.setDataVector(new Object[][] { {"partnerLink",
                                       partnerLink}
                                       , {"portType", portType}
                                       , {"operation", operation}
                                       , {"variable", variable}
    }
        , new Object[] {
    		res.getString("propertyname"), res.getString("propertyvalue")});
            this.jComboxPartnerLink = new JComboBox();
    this.jComboxPortType = new JComboBox();
    this.jComboxOperation = new JComboBox();
    this.jComboxVariable = new JComboBox();
    this.jComboxPartnerLink.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxPartnerLink)) {
          if (jComboxPartnerLink.getSelectedItem() != null) {
            String plinkSelectedName = (String) jComboxPartnerLink
                .getSelectedItem();
            onMessage.setAtPartnerLinkValue(plinkSelectedName);
            process.write();
            if (plinkSelectedName != null
                && plinkSelectedName != "") {
              PartnerLinks plinks = (PartnerLinks) process
                  .getPartnerLinks().car();
              PartnerLink plink = plinks
                  .getPartnerLinkByName(plinkSelectedName);
              String plinktypename = plink
                  .getAtPartnerLinkTypeValue();
              if (plinktypename.startsWith("tns:")) {
                plinktypename = plinktypename.substring(plinktypename.indexOf(
                    ":") + 1, plinktypename.length());
              }
              PartnerLinkType plinkType = (PartnerLinkType) MainFrame
                  .getmainFrame().getProject()
                  .getPLinkTypeByName(plinktypename);
              jComboxPortType.removeAllItems();
              PortType pt = plinkType.getPartnerRole()
                  .getPortType();
              WSDLRegistry wsdlRegistry = project
                  .getWSDLRegistry();
              WSDLRegistryEntry wre = wsdlRegistry.findPortType(
                  pt.getQName().getNamespaceURI(), pt
                  .getQName().getLocalPart());
              jComboxPortType.addItem(wre);
            }
          }
          else {
            onMessage.setAtPartnerLinkValue("");
            process.write();
          }
        }
      }
    });
    this.jComboxPortType.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxPortType)) {
          if (jComboxPortType.getSelectedItem() != null) {
            WSDLRegistryEntry wre = (WSDLRegistryEntry) jComboxPortType
                .getSelectedItem();
            ExtWsdl extWsdl = project.getExtWsdl();
            Definition definition = extWsdl.getExtWsdl();
            String strPrefix = definition.getPrefix(wre.namespace);
            String portTypeName;
                        if (strPrefix == null) {
              portTypeName = wre.localName;             }
            else {
              portTypeName = strPrefix + ":" + wre.localName;             }
            onMessage.setAtPortTypeValue(portTypeName);
            process.write();
            PortType pt = (PortType) wre.userObject;
            if (pt != null) {
              jComboxOperation.removeAllItems();
              List ops = pt.getOperations();
              for (int j = 0; j < ops.size(); j++) {
                Operation op = (Operation) ops.get(j);
                OperationWrapper opw = new OperationWrapper(op);
                jComboxOperation.addItem(opw);
              }
            }
          }
          else {
            onMessage.setAtPortTypeValue("");
            process.write();
          }
        }
      }
    });
    this.jComboxOperation.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxOperation)) {
          if (jComboxOperation.getSelectedItem() != null) {
            OperationWrapper opw = (OperationWrapper) jComboxOperation
                .getSelectedItem();
            Operation op = opw.getWrappedOperation();
            String opName = op.getName();
            onMessage.setAtOperationValue(opName);
            process.write();
            if (opw != null) {
              jComboxVariable.removeAllItems();
              List tempvs = figure.getCorrelationSetList();
              for (int i = 0; i < tempvs.size(); i++) {
                Variable v = (Variable) tempvs.get(i);
                String variablename = v.getAtNameValue();
                if (v.getAtMessageTypeValue().indexOf(":") == -1) {
                  if (v.getAtMessageTypeValue().equals(
                      op.getInput().getMessage()
                      .getQName()
                      .getLocalPart())) {
                    jComboxVariable
                        .addItem(variablename);
                  }
                }
                else {
                  ExtWsdl extWsdl = project.getExtWsdl();
                  Definition definition = extWsdl
                      .getExtWsdl();
                  Message message = op.getInput()
                      .getMessage();
                  String strPrefix = definition
                      .getPrefix(message.getQName()
                                 .getNamespaceURI());
                  if (v
                      .getAtMessageTypeValue()
                      .equals(
                      strPrefix
                      + ":"
                      + op
                      .getInput()
                      .getMessage()
                      .getQName()
                      .getLocalPart())) {
                    jComboxVariable
                        .addItem(variablename);
                  }
                }
              }
            }
          }
          else {
            onMessage.setAtOperationValue("");
            process.write();
          }
        }
      }
    });
    this.jComboxVariable.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(jComboxVariable)) {
          onMessage.setAtVariableValue( (String) jComboxVariable
                                       .getSelectedItem());
          process.write();
        }
      }
    });
    
    EachRowRenderer rowRenderer = new EachRowRenderer();
    
    EachRowEditor rowEditor = new EachRowEditor(jAttTable);
    DefaultCellEditor jComboxPartnerLinkEditor = new DefaultCellEditor(
        jComboxPartnerLink);
    DefaultCellEditor jComboxPortTypeEditor = new DefaultCellEditor(
        jComboxPortType);
    DefaultCellEditor jComboxOperationEditor = new DefaultCellEditor(
        jComboxOperation);
    DefaultCellEditor jComboxVariableEditor = new DefaultCellEditor(
        jComboxVariable);
    rowEditor.setEditorAt(0, jComboxPartnerLinkEditor);
    rowEditor.setEditorAt(1, jComboxPortTypeEditor);
    rowEditor.setEditorAt(2, jComboxOperationEditor);
    rowEditor.setEditorAt(3, jComboxVariableEditor);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
    this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
  }
  
  public void setAttTable() {
    List it1 = new Vector();
    List it2 = new Vector();
    List it3 = new Vector();
    List it4 = new Vector();
    int j1 = this.jComboxPartnerLink.getActionListeners().length - 1;
    int j2 = this.jComboxPortType.getActionListeners().length - 1;
    int j3 = this.jComboxOperation.getActionListeners().length - 1;
    int j4 = this.jComboxVariable.getActionListeners().length - 1;
    for (int i = j1; i >= 0; i--) {
      ActionListener it = this.jComboxPartnerLink.getActionListeners()[i];
      it1.add(it);
      this.jComboxPartnerLink.removeActionListener(it);
    }
    for (int i = j2; i >= 0; i--) {
      ActionListener it = this.jComboxPortType.getActionListeners()[i];
      it2.add(it);
      this.jComboxPortType.removeActionListener(it);
    }
    for (int i = j3; i >= 0; i--) {
      ActionListener it = this.jComboxOperation.getActionListeners()[i];
      it3.add(it);
      this.jComboxOperation.removeActionListener(it);
    }
    for (int i = j4; i >= 0; i--) {
      ActionListener it = this.jComboxVariable.getActionListeners()[i];
            it4.add(it);
      this.jComboxVariable.removeActionListener(it);
    }
    jComboxPartnerLink.removeAllItems();
    jComboxPortType.removeAllItems();
    jComboxOperation.removeAllItems();
    jComboxVariable.removeAllItems();
    if (this.process.getPartnerLinks() != null
        && this.process.getPartnerLinks().getChilds().size() > 0) {
      Metaset plinks = this.process.getPartnerLinks().car();
      List tempPlinks = plinks.getChilds();
            for (int i = 0; i < tempPlinks.size(); i++) {
        PartnerLink plink = (PartnerLink) tempPlinks.get(i);
        String plinkName = plink.getAtNameValue();
        jComboxPartnerLink.addItem(plinkName);
        String plinktypename;
        if (plink.getAtPartnerLinkTypeValue().startsWith("tns:")) {
            plinktypename = plink.getAtPartnerLinkTypeValue().substring(plink.
                getAtPartnerLinkTypeValue().indexOf(":") + 1,
                plink.getAtPartnerLinkTypeValue().length());
          }
          else {
            plinktypename = plink.getAtPartnerLinkTypeValue();
          }
        PartnerLinkType plinkType = (PartnerLinkType) MainFrame
            .getmainFrame().getProject().getPLinkTypeByName(
            plinktypename);
        PortType pt = plinkType.getPartnerRole().getPortType();
        WSDLRegistry wsdlRegistry = project.getWSDLRegistry();
        WSDLRegistryEntry wre = wsdlRegistry.findPortType(pt.getQName()
            .getNamespaceURI(), pt.getQName().getLocalPart());
        jComboxPortType.addItem(wre);
        List ops = pt.getOperations();
        for (int j = 0; j < ops.size(); j++) {
          Operation op = (Operation) ops.get(j);
          OperationWrapper opw = new OperationWrapper(op);
          jComboxOperation.addItem(opw);
          List tempvs = figure.getVariableList();
          for (int m = 0; m < tempvs.size(); m++) {
            Variable v = (Variable) tempvs.get(m);
            String variablename = v.getAtNameValue();
            if (v.getAtMessageTypeValue().indexOf(":") == -1) {
              if (v.getAtMessageTypeValue().equals(
                  op.getInput().getMessage().getQName()
                  .getLocalPart())) {
                jComboxVariable.addItem(variablename);
              }
            }
            else {
              ExtWsdl extWsdl = project.getExtWsdl();
              Definition definition = extWsdl.getExtWsdl();
              Message message = op.getInput().getMessage();
              String strPrefix = definition.getPrefix(message
                  .getQName().getNamespaceURI());
              if (v.getAtMessageTypeValue().equals(
                  strPrefix
                  + ":"
                  + op.getInput().getMessage()
                  .getQName()
                  .getLocalPart())) {
                jComboxVariable.addItem(variablename);
              }
            }
          }
        }
      }
    }
    if (onMessage != null) {
      if (this.partnerLink != null && this.partnerLink != "") {
        for (int a = 0; a < this.jComboxPartnerLink.getItemCount(); a++) {
          String plinkName = (String)this.jComboxPartnerLink
              .getItemAt(a);
          if (this.partnerLink.equals(plinkName)) {
            this.jComboxPartnerLink.setSelectedIndex(a);
            break;
          }
        }
      }
      if (this.portType != null && this.portType != "") {
        for (int b = 0; b < this.jComboxPortType.getItemCount(); b++) {
          WSDLRegistryEntry wre = (WSDLRegistryEntry) jComboxPortType
              .getItemAt(b);
          ExtWsdl extWsdl = project.getExtWsdl();
          Definition definition = extWsdl.getExtWsdl();
          if (portType.indexOf(":") != -1) {
            String strPrefix = portType.substring(0, portType
                                                  .lastIndexOf(":"));
            String nameSpace = definition.getNamespace(strPrefix);
            String localName = portType.substring(portType
                                                  .lastIndexOf(":") + 1,
                                                  portType.length());
            if (nameSpace.equals(wre.namespace)
                && localName.equals(wre.localName)) {
              this.jComboxPortType.setSelectedIndex(b);
              break;
            }
          }
          else {
            if (portType.equals(wre.localName)) {
              this.jComboxPortType.setSelectedIndex(b);
              break;
            }
          }
        }
      }
      if (this.operation != null && this.operation != "") {
        for (int c = 0; c < this.jComboxOperation.getItemCount(); c++) {
          OperationWrapper opw = (OperationWrapper)this.jComboxOperation
              .getItemAt(c);
          if (opw.getOperationName().equals(this.operation)) {
            this.jComboxOperation.setSelectedIndex(c);
            break;
          }
        }
      }
      if (this.variable != null && this.variable != "") {
        for (int d = 0; d < this.jComboxVariable.getItemCount(); d++) {
          String inName = (String)this.jComboxVariable.getItemAt(d);
          if (inName.equals(this.variable)) {
            this.jComboxVariable.setSelectedIndex(d);
            break;
          }
        }
      }
    }
    for (int i = 0; i < it1.size(); i++) {
      ActionListener it = (ActionListener) it1.get(i);
      this.jComboxPartnerLink.addActionListener(it);
    }
    for (int i = 0; i < it2.size(); i++) {
      ActionListener it = (ActionListener) it2.get(i);
      this.jComboxPortType.addActionListener(it);
    }
    for (int i = 0; i < it3.size(); i++) {
      ActionListener it = (ActionListener) it3.get(i);
      this.jComboxOperation.addActionListener(it);
    }
    for (int i = 0; i < it4.size(); i++) {
      ActionListener it = (ActionListener) it4.get(i);
      this.jComboxVariable.addActionListener(it);
    }
  }
  
  private void initCorrelationTable() {
    this.defaultCorrelationTableModel.setDataVector(new Object[][] {}
        ,
        new Object[] {"Correlations"});
    if (this.onMessage.getCorrelations() != null) {
      for (int i = 0; i < this.onMessage.getCorrelations().getChilds()
           .size(); i++) {
        Correlation correlation = (Correlation)this.onMessage
            .getCorrelations().getChilds().get(i);
        this.correlations.add(correlation);
        Object[] data = new Object[] {
            correlation.getAtSetValue()};
        this.defaultCorrelationTableModel.addRow(data);
      }
    }
    this.jCorrelationTable = new JTable(this.defaultCorrelationTableModel);
    this.jCorrelationTable.addMouseListener(new MouseAdapter() {                   public void mouseClicked(MouseEvent e) {
        if (e.getButton() == 3) {
          int i = jCorrelationTable.getSelectedRow();
          if (i != -1) {
            Correlation correlation = (Correlation) correlations
                .get(i);
            OnMessagePropertyRightMenu rightMenu = new
                OnMessagePropertyRightMenu(
                correlation, figure);
            rightMenu.show(jCorrelationTable, e.getX(), e
                           .getY());
          }
        }
      }
    });
  }
  
  public void deleteCorrelation(Correlation correlation) {
    if (this.correlations.contains(correlation)) {
            this.defaultCorrelationTableModel.removeRow(this.correlations
                                                  .indexOf(correlation));
      this.correlations.remove(correlation);
    }
  }
  
  public void addCorrelation(Correlation c) {
    if (!this.correlations.contains(c)) {
      this.correlations.add(c);
      Object[] data = new Object[] {
          c.getAtSetValue()};
      this.defaultCorrelationTableModel.addRow(data);
          }
  }
  
  public JTable getCorrelationTable() {
    return this.jCorrelationTable;
  }
}
