package org.act.wsc.bpel4wsmodeling.view.graphic.processeditor;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JTextField;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IProcessPropertyListener;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IProcessChildListener;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowEditor;
import org.act.wsc.bpel4wsmodeling.view.graphic.table.EachRowRenderer;
import javax.swing.DefaultCellEditor;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.util.List;
import java.util.Properties;
import java.util.ResourceBundle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Vector;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import javax.wsdl.Definition;
import javax.wsdl.xml.WSDLWriter;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import javax.wsdl.*;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.act.wsc.bpel4wsmodeling.projectdata.process.GraphLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.ExtWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PartnerLinkType;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Role;
import java.io.File;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IVariablePropertyListener;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IPartnerLinkPropertyListener;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.ICorrelationSetPropertyListener;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSet;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSets;
import org.act.wsc.bpel4wsmodeling.def.process.PartnerLink;
import org.act.wsc.bpel4wsmodeling.def.process.PartnerLinks;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;
import org.act.wsc.bpel4wsmodeling.def.process.Variables;
import org.w3c.dom.Document;

public class ProcessProperty implements IProcessChildListener,
        IProcessPropertyListener, IVariablePropertyListener,
        IPartnerLinkPropertyListener, ICorrelationSetPropertyListener {
    GraphLayer myLayer;
    BPELProcess process;
    DefaultTableModel defaultAttTableModel;
    DefaultTableModel defaultPartnerLinkTableModel;
    DefaultTableModel defaultVariablesTableModel;
    DefaultTableModel defaultCorrelationSetTableModel;
    JTable jAttTable;
    JTable jPartnerLinksTable;
    JTable jVariablesTable;
    JTable jCorrelationSetTable;
        JTextField txtname;
    JTextField txttargetNamespace;
    JTextField txtqueryLanguage;
    JTextField txtexpressionLanguage = new JTextField();
        JTextField txtsuppressJoinFailure;     JTextField txtenableInstanceCompensation;     JTextField txtabstractProcess;     JTextField txtxmlns;
    MainFrame frame = MainFrame.getmainFrame();
    List partnerLinks = new Vector();
    List variables = new Vector();
    List correlationSets = new Vector();
    
    ResourceBundle res = ResChoose.getLanguage();
    public ProcessProperty(GraphLayer graphLayer) {
        this.myLayer = graphLayer;
        process = this.myLayer.getBPELProcess();
        defaultAttTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return column == 1;
            }
        };
        this.defaultPartnerLinkTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        this.defaultVariablesTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        this.defaultCorrelationSetTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        initAttTable();
        initPartnerLinkeTable();
        initVariablesTable();
        this.initCorrelationSetTable();
        this.process.addPropertyListeners(this);
        this.process.addChildListeners(this);
    }
    private void initAttTable() {
        String name = this.process.getAtNameValue();
        String targetNamespace = this.process.getAtTargetNamespaceValue();
        String queryLanguage = this.process.getAtQueryLanguageValue();
        String expressionLanguage = this.process.getAtExpressionLanguageValue();
        String suppressJoinFailure = this.process
                .getAtSuppressJoinFailureValue();
        String enableInstanceCompensation = this.process
                .getAtEnableInstanceCompensationValue();
        String abstractProcess = this.process.getAtAbstractProcessValue();
        String xmlns = this.process.getAtXmlnsValue();
        defaultAttTableModel.setDataVector(new Object[][] { { "name", name },
                { "targetNamespace", targetNamespace },
                { "queryLanguage", queryLanguage },
                { "expressionLanguage", expressionLanguage },
                { "suppressJoinFailure", suppressJoinFailure },
                { "enableInstanceCompensation", enableInstanceCompensation },
                { "abstractProcess", abstractProcess }, { "xmlns", xmlns }
        }, new Object[] { res.getString("propertyname"), res.getString("propertyvalue") });
        jAttTable = new JTable(defaultAttTableModel);
                txtname = new JTextField();
        txtname.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    process.setAtNameValue(txtname.getText());
                }
            }
            public void keyReleased(KeyEvent e) {
            }
            public void keyTyped(KeyEvent e) {
            }
        });
        txttargetNamespace = new JTextField();
        txtqueryLanguage = new JTextField();
        JTextField txtexpressionLanguage = new JTextField();
                txtsuppressJoinFailure = new JTextField();         txtenableInstanceCompensation = new JTextField();         txtabstractProcess = new JTextField();         txtxmlns = new JTextField();
        EachRowRenderer rowRenderer = new EachRowRenderer();
        EachRowEditor rowEditor = new EachRowEditor(jAttTable);
        DefaultCellEditor txtnameEditor = new DefaultCellEditor(txtname);
        DefaultCellEditor txtNamespaceEditor = new DefaultCellEditor(
                txttargetNamespace);
        DefaultCellEditor txtqueryLangEditor = new DefaultCellEditor(
                txtqueryLanguage);
        DefaultCellEditor txtexprLangEditor = new DefaultCellEditor(
                txtexpressionLanguage);
        DefaultCellEditor txtsuppressJoinFailureEditor = new DefaultCellEditor(
                txtsuppressJoinFailure);
        DefaultCellEditor txtenableInstanceCompensationEditor = new DefaultCellEditor(
                txtenableInstanceCompensation);
        DefaultCellEditor txtabstractProcessEditor = new DefaultCellEditor(
                txtabstractProcess);
        DefaultCellEditor txtxmlnsEditor = new DefaultCellEditor(txtxmlns);
        rowEditor.setEditorAt(0, txtnameEditor);
        rowEditor.setEditorAt(1, txtNamespaceEditor);
        rowEditor.setEditorAt(2, txtqueryLangEditor);
        rowEditor.setEditorAt(3, txtexprLangEditor);
        rowEditor.setEditorAt(4, txtsuppressJoinFailureEditor);
        rowEditor.setEditorAt(5, txtenableInstanceCompensationEditor);
        rowEditor.setEditorAt(6, txtabstractProcessEditor);
        rowEditor.setEditorAt(7, txtxmlnsEditor);
        this.jAttTable.getColumn(res.getString("propertyvalue")).setCellRenderer(rowRenderer);
        this.jAttTable.getColumn(res.getString("propertyvalue")).setCellEditor(rowEditor);
        this.setExtWsdlTargetNameSpace();
    }
    public void initPartnerLinkeTable() {
        defaultPartnerLinkTableModel.setDataVector(new Object[][] {},
                new Object[] { "PartnerLinks" });
                if (this.process.getPartnerLinks() != null) {
            PartnerLinks partnerlinks = (PartnerLinks) this.process
                    .getPartnerLinks().car();
            for (int i = 0; i < partnerlinks.getChilds().size(); i++) {
                PartnerLink plink = (PartnerLink) partnerlinks.getChilds().get(
                        i);
                this.addPartnerLink(plink);
            }
        }
        this.jPartnerLinksTable = new JTable(defaultPartnerLinkTableModel);
        this.jPartnerLinksTable.addMouseListener(new MouseAdapter() {                                                                                                                                                                 public void mouseClicked(MouseEvent e) {
                        if (e.getButton() == 3) {
                            int i = jPartnerLinksTable.getSelectedRow();
                            if (i != -1) {
                                PartnerLink plink = (PartnerLink) partnerLinks
                                        .get(i);
                                ProcessPropertyRightMenu rightMenu = new ProcessPropertyRightMenu(
                                        (Object) plink, myLayer);
                                rightMenu.show(jPartnerLinksTable, e.getX(), e
                                        .getY());
                            }
                        }
                    }
                });
    }
    public void initVariablesTable() {
        defaultVariablesTableModel.setDataVector(new Object[][] {},
                new Object[] { "Variables" });
                if (this.process.getVariables() != null) {
            Variables variables = (Variables) this.process.getVariables().car();
            for (int i = 0; i < variables.getChilds().size(); i++) {
                Variable var = (Variable) variables.getChilds().get(i);
                this.addVariable(var);
            }
        }
        this.jVariablesTable = new JTable(defaultVariablesTableModel);
        this.jVariablesTable.addMouseListener(new MouseAdapter() {                                                                                                                                                           public void mouseClicked(MouseEvent e) {
                        if (e.getButton() == 3) {
                            int i = jVariablesTable.getSelectedRow();
                            if (i != -1) {
                                Variable variable = (Variable) variables.get(i);
                                ProcessPropertyRightMenu rightMenu = new ProcessPropertyRightMenu(
                                        (Object) variable, myLayer);
                                rightMenu.show(jVariablesTable, e.getX(), e
                                        .getY());
                            }
                        }
                    }
                });
    }
    public void initCorrelationSetTable() {
        defaultCorrelationSetTableModel.setDataVector(new Object[][] {},
                new Object[] { "CorrelationSets" });
                if (this.process.getCorrelationSets() != null) {
            CorrelationSets correlationSets = (CorrelationSets) this.process
                    .getCorrelationSets().car();
            for (int i = 0; i < correlationSets.getChilds().size(); i++) {
                CorrelationSet correlationSet = (CorrelationSet) correlationSets
                        .getChilds().get(i);
                this.addCorrelationSet(correlationSet);
            }
        }
        this.jCorrelationSetTable = new JTable(defaultCorrelationSetTableModel);
        this.jCorrelationSetTable.addMouseListener(new MouseAdapter() {                                                                                                                                                                     public void mouseClicked(MouseEvent e) {
                        if (e.getButton() == 3) {
                            int i = jCorrelationSetTable.getSelectedRow();
                            if (i != -1) {
                                CorrelationSet correlationSet = (CorrelationSet) correlationSets
                                        .get(i);
                                ProcessPropertyRightMenu rightMenu = new ProcessPropertyRightMenu(
                                        (Object) correlationSet, myLayer);
                                rightMenu.show(jCorrelationSetTable, e.getX(),
                                        e.getY());
                            }
                        }
                    }
                });
    }
    public JTable getAttributeTable() {
        return this.jAttTable;
    }
    public JTable getPartnerLinksTable() {
        return this.jPartnerLinksTable;
    }
    public JTable getVariablesTable() {
        return this.jVariablesTable;
    }
    public JTable getCorrelationSetTable() {
        return this.jCorrelationSetTable;
    }
    
    public void addVariable(Variable var) {
        if (!this.variables.contains(var)) {
            this.variables.add(var);
            Object[] data = new Object[] { var.getAtNameValue() };
            this.defaultVariablesTableModel.addRow(data);
            var.addPropertyListeners(this);
        }
    }
    
    public void deleteVariable(Variable var) {
        if (this.variables.contains(var)) {
            var.removePropertyListner(this);
            this.defaultVariablesTableModel.removeRow(this.variables
                    .indexOf(var));
            this.variables.remove(var);
        }
    }
    public void varNameUpdate(Variable v, String name) {
        if (this.variables.contains(v)) {
            this.defaultVariablesTableModel.setValueAt(name, this.variables
                    .indexOf(v), 0);         }
    }
    
    public void addPartnerLink(PartnerLink plink) {
        if (!this.partnerLinks.contains(plink)) {
            this.partnerLinks.add(plink);
            Object[] data = new Object[] { plink.getAtNameValue() };
            this.defaultPartnerLinkTableModel.addRow(data);
            plink.addPropertyListeners(this);
        }
    }
    
    public void deletePartnerLink(PartnerLink plink) {
        if (this.partnerLinks.contains(plink)) {
            this.defaultPartnerLinkTableModel.removeRow(this.partnerLinks
                    .indexOf(plink));
            this.partnerLinks.remove(plink);
        }
    }
    public void plinkNameUpdate(PartnerLink plink, String name) {
        if (this.partnerLinks.contains(plink)) {
            this.defaultPartnerLinkTableModel.setValueAt(name,
                    this.partnerLinks.indexOf(plink), 0);         }
    }
    
    public void addPartner() {
    }
    
    public void deletePartner() {
    }
    public void nameUpdate(String name) {
        this.txtname.setText(name);
        this.process.write();
                this.setExtWsdlTargetNameSpace();
    }
    public void targetNamespaceUpdate() {
    }
    public void queryLanguageUpdate() {
    }
    public void expressionLanguageUpdate() {
    }
    public void suppressJoinFailureUpdate() {
    }
    public void enableInstanceCompensationUpdate() {
    }
    public void abstractProcessUpdate() {
    }
    public void xmlnsUpdate() {
    }
    public void setExtWsdlTargetNameSpace() {
                Project project = this.frame.getProject();
        ExtWsdl extWsdl = project.getExtWsdl();
        Definition definition = null;
        if (extWsdl == null) {
            extWsdl = new ExtWsdl();
            project.setExtWsdl(extWsdl);
            definition = extWsdl.getExtWsdl();
            definition.setTargetNamespace(this.process
                    .getAtTargetNamespaceValue());
            definition.addNamespace("plnk",
                    "http://schemas.xmlsoap.org/ws/2003/05/partner-link/");
        } else {
            definition = extWsdl.getExtWsdl();
            definition.setTargetNamespace(this.process
                    .getAtTargetNamespaceValue());
        }
        WSDLWriter wsdlWriter = extWsdl.getWSDLFactory().newWSDLWriter();
		String fileName;
        try {
            String path = GetActiveProjectDir.getactiveprodir()
                    + java.io.File.separator + "output"
                    + java.io.File.separator + "bpel" + java.io.File.separator
                    + this.process.getAtNameValue() + "_ext.wsdl";
                                    Document doc = wsdlWriter.getDocument(definition);
            try {
                writeXmlFile(path, doc);
                            } catch (Exception e1) {
                                e1.printStackTrace();
            }
                    } catch (WSDLException ex) {
        }
    }
    public long writeXmlFile(String name, Document document) throws Exception {
        DOMSource doms = new DOMSource(document);
        File file = new File(name);
        StreamResult result = new StreamResult(file);
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer transformer = tf.newTransformer();
        Properties properties = transformer.getOutputProperties();
        properties.setProperty(OutputKeys.ENCODING, "GB2312");
        properties.setProperty(OutputKeys.METHOD, "xml");
        properties.setProperty(OutputKeys.INDENT, "yes");
        transformer.setOutputProperties(properties);
        transformer.transform(doms, result);
        return 0;
    }
    
    public void addCorrelationSet(CorrelationSet correlationSet) {
        if (!this.correlationSets.contains(correlationSet)) {
            this.correlationSets.add(correlationSet);
            Object[] data = new Object[] { correlationSet.getAtNameValue() };
            this.defaultCorrelationSetTableModel.addRow(data);
            correlationSet.addPropertyListeners(this);
        }
    }
    
    public void deleteCorrelationSet(CorrelationSet correlationSet) {
        if (this.correlationSets.contains(correlationSet)) {
            correlationSet.removePropertyListner(this);
            this.defaultCorrelationSetTableModel.removeRow(this.correlationSets
                    .indexOf(correlationSet));
            this.correlationSets.remove(correlationSet);
        }
    }
    public void correlationSetNameUpdate(CorrelationSet c, String name) {
        if (this.correlationSets.contains(c)) {
            this.defaultCorrelationSetTableModel.setValueAt(name,
                    this.correlationSets.indexOf(c), 0);
        }
    }
}
