
package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.ResourceBundle;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;
import org.act.wsc.bpel4wsmodeling.debug.operate.DebugOp;
import org.act.wsc.bpel4wsmodeling.debug.operate.IDebugStateListener;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.resource.ResourceManager;
import org.act.wsc.bpel4wsmodeling.resource.StandardImageIcon;
import org.act.wsc.bpel4wsmodeling.view.action.AboutAction;
import org.act.wsc.bpel4wsmodeling.view.action.CloseProjectAction;
import org.act.wsc.bpel4wsmodeling.view.action.CreateProjectAction;
import org.act.wsc.bpel4wsmodeling.view.action.OpenProjectAction;
import org.act.wsc.bpel4wsmodeling.view.action.QuitAppAction;
import org.act.wsc.bpel4wsmodeling.view.action.SaveProjectAction;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class MainToolBar extends JToolBar implements IDebugStateListener {
	  ResourceBundle res = ResChoose.getLanguage();
	    
    JButton jButtonNewProject = new JButton();
    JButton jButtonOpenProject = new JButton();
    JComboBox jComboBoxImportedProject = new JComboBox();
    JButton jButtonSaveProject = new JButton();
    JButton jButtonCloseProject = new JButton();
    JButton jButtonQuit = new JButton();
    JButton jButtonHelp = new JButton();
    private JToggleButton switchButton = new JToggleButton(res.getString("debug"), false);
    private JButton startButton;
    private JButton resumeButton;
    private JButton stepIntoButton;
    private JButton stepOverButton;
    private JButton stepOutButton;
    private JButton terminateButton;
    
  
    JButton[] debugButtons = new JButton[] { startButton = new JButton(),            resumeButton = new JButton(),            terminateButton = new JButton(),            stepIntoButton = new JButton(),            stepOverButton = new JButton(),            stepOutButton = new JButton(),    };
    Border toolBarButBorder;
        MainFrame mainFrame;
    
    public MainToolBar(MainFrame frame) {
        super();
        this.mainFrame = frame;
        DebugOp.getInstance().addListener(this);
        jbInit();
    }
    
    private void jbInit() {
        ImageIcon image[] = new ImageIcon[12];
        image[0] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_NEW);
        image[1] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_OPEN);
        image[2] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_SAVE);
        image[3] = ResourceManager
                .getImageIcon(StandardImageIcon.PROJECT_CLOSE);
        image[4] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_QUIT);
        image[5] = ResourceManager.getImageIcon(StandardImageIcon.PROJECT_HELP);
        image[6] = ResourceManager.getImageIcon(StandardImageIcon.DEBUG_START);
        image[7] = ResourceManager.getImageIcon(StandardImageIcon.DEBUG_RESUME);
        image[8] = ResourceManager
                .getImageIcon(StandardImageIcon.DEBUG_TERMINATE);
        image[9] = ResourceManager
                .getImageIcon(StandardImageIcon.DEBUG_STEPINTO);
        image[10] = ResourceManager
                .getImageIcon(StandardImageIcon.DEBUG_STOPOVER);
        image[11] = ResourceManager
                .getImageIcon(StandardImageIcon.DEBUG_STEPOUT);
                        this.toolBarButBorder = BorderFactory.createEmptyBorder(6, 6, 6, 6);
        if (WorkSpace.getInstance().getProjects().isEmpty()) {
            this.jComboBoxImportedProject.setEnabled(false);
        } else {
            this.jComboBoxImportedProject.setEnabled(true);
            for (Iterator iter = WorkSpace.getInstance().getProjects().keySet()
                    .iterator(); iter.hasNext();) {
                String projectName = (String) iter.next();
                this.jComboBoxImportedProject.addItem(projectName);
            }
            if (WorkSpace.getInstance().getActiveProject() != null) {
                this.jComboBoxImportedProject.setSelectedItem(WorkSpace
                        .getInstance().getActiveProject().getProjectName());
            } else {
                this.jComboBoxImportedProject.setSelectedIndex(-1);
            }
        }
        jComboBoxImportedProject.setBackground(Color.LIGHT_GRAY);
        jComboBoxImportedProject.setMaximumSize(new Dimension(100, 30));
        jComboBoxImportedProject.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                WorkSpace.getInstance().openProject(
                        (String) MainToolBar.this.jComboBoxImportedProject
                                .getSelectedItem(), true);
            }
        });
        this.add(jComboBoxImportedProject);
        this.jButtonNewProject.setIcon(image[0]);
        this.jButtonNewProject.setMargin(new Insets(2, 14, 2, 14));
        this.jButtonNewProject.setBorder(this.toolBarButBorder);
        this.jButtonNewProject.setMaximumSize(new Dimension(30, 30));
        this.jButtonNewProject.setToolTipText(res.getString("new"));               this.jButtonNewProject.addActionListener(new CreateProjectAction(
                mainFrame));
        this.add(this.jButtonNewProject);
        this.jButtonOpenProject.setIcon(image[1]);
        this.jButtonOpenProject.setMargin(new Insets(2, 14, 2, 14));
        this.jButtonOpenProject.setBorder(this.toolBarButBorder);
        this.jButtonOpenProject.setMaximumSize(new Dimension(30, 30));
        this.jButtonOpenProject.setToolTipText(res.getString("open"));               this.jButtonOpenProject.addActionListener(new OpenProjectAction());
        this.add(this.jButtonOpenProject);
        this.jButtonSaveProject.setIcon(image[2]);
        this.jButtonSaveProject.setMargin(new Insets(2, 14, 2, 14));
        this.jButtonSaveProject.setBorder(this.toolBarButBorder);
        this.jButtonSaveProject.setMaximumSize(new Dimension(30, 30));
        this.jButtonSaveProject.setToolTipText(res.getString("save"));                  this.jButtonSaveProject.addActionListener(new SaveProjectAction());
        this.add(this.jButtonSaveProject);
        this.jButtonCloseProject.setIcon(image[3]);
        this.jButtonCloseProject.setMargin(new Insets(2, 14, 2, 14));
        this.jButtonCloseProject.setBorder(this.toolBarButBorder);
        this.jButtonCloseProject.setMaximumSize(new Dimension(30, 30));
        this.jButtonCloseProject.setToolTipText(res.getString("close"));                this.jButtonCloseProject.addActionListener(new CloseProjectAction());
        this.add(this.jButtonCloseProject);
        this.jButtonQuit.setIcon(image[4]);
        this.jButtonQuit.setMargin(new Insets(2, 14, 2, 14));
        this.jButtonQuit.setBorder(this.toolBarButBorder);
        this.jButtonQuit.setMaximumSize(new Dimension(30, 30));
        this.jButtonQuit.setToolTipText(res.getString("quit"));                         this.jButtonQuit.addActionListener(new QuitAppAction());
        this.add(this.jButtonQuit);
        this.jButtonHelp.setIcon(image[5]);
        this.jButtonHelp.setMargin(new Insets(2, 14, 2, 14));
        this.jButtonHelp.setBorder(this.toolBarButBorder);
        this.jButtonHelp.setMaximumSize(new Dimension(30, 30));
        this.jButtonHelp.setToolTipText(res.getString("help"));                       this.jButtonHelp.addActionListener(new AboutAction());
        this.add(this.jButtonHelp);
                this.switchButton.setToolTipText(res.getString("switchDebug"));                                this.switchButton.setMargin(new Insets(2, 14, 2, 14));
        this.switchButton.setBorder(this.toolBarButBorder);
        this.switchButton.setMaximumSize(new Dimension(70, 30));
        this.add(this.switchButton);
        String[] toolTips = new String[] { "start", "resume", "stop",
                "stepInto", "stepOver", "stepOut" };
        for (int i = 0; i < debugButtons.length; i++) {
            JButton button = debugButtons[i];
            button.setToolTipText(toolTips[i]);
            button.setIcon(image[i + 6]);
            button.setMargin(new Insets(2, 14, 2, 14));
            button.setBorder(this.toolBarButBorder);
            button.setMaximumSize(new Dimension(30, 30));
        }
        enterDebug();
        quitDebug();
        switchButton
                .addActionListener(new DebugToolBar_switchButton_actionAdapter(
                        this));
        startButton
                .addActionListener(new DebugToolBar_startButton_actionAdapter(
                        this));
        stepIntoButton
                .addActionListener(new DebugToolBar_stepIntoButton_actionAdapter(
                        this));
        stepOverButton
                .addActionListener(new DebugToolBar_stepOverButton_actionAdapter(
                        this));
        stepOutButton
                .addActionListener(new DebugToolBar_stepOutButton_actionAdapter(
                        this));
        resumeButton
                .addActionListener(new DebugToolBar_resumeButton_actionAdapter(
                        this));
        terminateButton
                .addActionListener(new DebugToolBar_terminateButton_actionAdapter(
                        this));
    }
    private void enterDebug() {
        for (int i = 0; i < debugButtons.length; i++) {
            JButton button = debugButtons[i];
            if(i==2){
                continue;
            }
            this.add(button);
        }
        this.updateUI();
    }
    private void quitDebug() {
        for (int i = 0; i < debugButtons.length; i++) {
            JButton button = debugButtons[i];
            this.remove(button);
        }
        this.updateUI();
    }
    
    public void entered() {
        enterDebug();
    }
    
    public void start() {
        debugOperable(false);
    }
    
    public void running() {
        debugOperable(false);
    }
    
    public void pause() {
        debugOperable(true);
    }
    
    public void terminate() {
        debugOperable(true);
    }
    
    public void quited() {
        quitDebug();
    }
    private void debugOperable(boolean isOperable) {
        for (int i = 0; i < debugButtons.length; i++) {
            JButton button = debugButtons[i];
            button.setEnabled(isOperable);
        }
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                MainToolBar.this.updateUI();
            }
        });
    }
    public void switchButton_actionPerformed(ActionEvent e) {
        if (WorkSpace.getInstance().getActiveProject() == null) {
            return;
        }
        if (switchButton.isSelected()) {
            DebugOp.getInstance().enterDebug();
                    } else {
            DebugOp.getInstance().quitDebug();
                    }
    }
    public void startButton_actionPerformed(ActionEvent e) {
        DebugOp.getInstance().startDebug();
    }
    public void stepIntoButton_actionPerformed(ActionEvent e) {
        DebugOp.getInstance().stepInto();
    }
    public void stepOverButton_actionPerformed(ActionEvent e) {
        DebugOp.getInstance().stepOver();
    }
    public void stepOutButton_actionPerformed(ActionEvent e) {
        DebugOp.getInstance().stepOut();
    }
    public void terminateButton_actionPerformed(ActionEvent e) {
        DebugOp.getInstance().terminateDebug();
    }
    public void resumeButton_actionPerformed(ActionEvent e) {
        DebugOp.getInstance().resume();
    }
    
    public JComboBox getJComboBoxImportedProject() {
        return jComboBoxImportedProject;
    }
    
    public void setJComboBoxImportedProject(JComboBox comboBoxImportedProject) {
        jComboBoxImportedProject = comboBoxImportedProject;
    }
}
class DebugToolBar_resumeButton_actionAdapter implements ActionListener {
    private MainToolBar adaptee;
    DebugToolBar_resumeButton_actionAdapter(MainToolBar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.resumeButton_actionPerformed(e);
    }
}
class DebugToolBar_terminateButton_actionAdapter implements ActionListener {
    private MainToolBar adaptee;
    DebugToolBar_terminateButton_actionAdapter(MainToolBar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.terminateButton_actionPerformed(e);
    }
}
class DebugToolBar_stepOutButton_actionAdapter implements ActionListener {
    private MainToolBar adaptee;
    DebugToolBar_stepOutButton_actionAdapter(MainToolBar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.stepOutButton_actionPerformed(e);
    }
}
class DebugToolBar_stepOverButton_actionAdapter implements ActionListener {
    private MainToolBar adaptee;
    DebugToolBar_stepOverButton_actionAdapter(MainToolBar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.stepOverButton_actionPerformed(e);
    }
}
class DebugToolBar_stepIntoButton_actionAdapter implements ActionListener {
    private MainToolBar adaptee;
    DebugToolBar_stepIntoButton_actionAdapter(MainToolBar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.stepIntoButton_actionPerformed(e);
    }
}
class DebugToolBar_startButton_actionAdapter implements ActionListener {
    private MainToolBar adaptee;
    DebugToolBar_startButton_actionAdapter(MainToolBar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.startButton_actionPerformed(e);
    }
}
class DebugToolBar_switchButton_actionAdapter implements ActionListener {
    private MainToolBar adaptee;
    DebugToolBar_switchButton_actionAdapter(MainToolBar adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.switchButton_actionPerformed(e);
    }
}
