
package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.swing.Icon;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import org.act.wsc.bpel4wsmodeling.projectdata.ModelNode;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.listener.ILayerListener;
import org.act.wsc.bpel4wsmodeling.projectdata.process.GraphLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Layer;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdl12define.WSDLLayer;
import org.act.wsc.bpel4wsmodeling.resource.ResourceManager;
import org.act.wsc.bpel4wsmodeling.resource.StandardImageIcon;
import org.act.wsc.bpel4wsmodeling.view.processassist.ProjectProperty;

public class NavigationPane
    extends JScrollPane
    implements
    ILayerListener, MouseListener {
  Project project;
  ProjectProperty projectProperty=null;
  JTree navigationTree = new JTree();
  Map nodeToLayer = new HashMap();
  IconNode rootNode;
  IconNode processNode;
  MainFrame mainFrame;
  private Icon projectIcon;
  private Icon processIcon;
  
  protected NavigationPane(Project project) {
    super();
    this.project = project;
    this.project.addListener(this);
    jbInit();
  }
  
  private void jbInit() {
        this.projectIcon = ResourceManager.getImageIcon(StandardImageIcon.
        TREE_PROJECT);
    this.processIcon = ResourceManager.getImageIcon(StandardImageIcon.
        TREE_PROCESS);
    rootNode = new IconNode(new ModelNode(ModelNode.NODE_TYPE_PROJECT));
    rootNode.setIcon(this.projectIcon);
    processNode = new IconNode(new ModelNode(ModelNode.NODE_TYPE_PROCESS));
    processNode.setIcon(this.processIcon);
    rootNode.add(processNode);
    DefaultTreeModel treemodel = new DefaultTreeModel(rootNode);
    this.navigationTree.setModel(treemodel);
    this.navigationTree.setCellRenderer(new IconNodeRenderer());
    this.getViewport().add(this.navigationTree);
    this.navigationTree.updateUI();
    this.navigationTree.addMouseListener(this);
  }
  
  public void layerCreated(Layer layer) {
      if(layer instanceof WSDLLayer){
          IconNode wsdlNode=new IconNode(new ModelNode(ModelNode.NODE_TYPE_WSDLDEFINE));
                    wsdlNode.setIcon(this.processIcon);
          rootNode.add(wsdlNode);
          this.navigationTree.updateUI();
          
          this.nodeToLayer.put(wsdlNode,layer);
      }
  }
  
  public void layerOpened(Layer layer) {
      }
  
  public void layerClosed(Layer layer) {
      }
  
  public void layerRemoved(Layer layer) {
      }
  
  public void mouseClicked(MouseEvent e) {
        TreePath path = this.navigationTree.getPathForLocation(e.getX(), e.getY());
    if (path == null) {
        return;
    }
    else {
      IconNode node = (IconNode) path.getLastPathComponent();
      
      
            if (e.getButton() == MouseEvent.BUTTON1 && e.getClickCount() == 1) {
                if (node.equals(this.processNode)) {
          if (!this.nodeToLayer.containsKey(node)) {
            GraphLayer graphLayer = this.project.createGraphLayer();
            this.nodeToLayer.put(node, graphLayer);
          }
          else {
            Layer layer = (Layer)this.nodeToLayer.get(node);
            this.project.openLayer(layer);
          }
        }
                else if(this.nodeToLayer.get(node)!=null&&this.nodeToLayer.get(node) instanceof WSDLLayer){
            this.project.openLayer((WSDLLayer)this.nodeToLayer.get(node));
        }
        else if(((ModelNode)node.getUserObject()).getNodeType()==ModelNode.NODE_TYPE_PROJECT){
            List jpanes=new Vector();
            this.projectProperty=new ProjectProperty(project);
            jpanes.add(new JScrollPane(this.projectProperty.getJRoleTable()));
            jpanes.add(new JScrollPane(this.projectProperty.getJPartnerLinkTypeTable()));
            jpanes.add(new JScrollPane(this.projectProperty.getJPropertyTable()));
            jpanes.add(new JScrollPane(this.projectProperty.getJPropertyAliasTable()));
            this.mainFrame.setProperty(jpanes);
        }
      }
            else if (e.getButton() == 3) {
                if (node.equals(this.rootNode)) {
          NavigationTreeRightMenu navigationTreeRightMenu = new
              NavigationTreeRightMenu(this, this.rootNode,this.project );
          navigationTreeRightMenu.show(e.getComponent(), e.getX(), e.getY());
        }
      }
    }
  }
  
  public void mouseEntered(MouseEvent e) {
      }
  
  public void mouseExited(MouseEvent e) {
      }
  
  public void mousePressed(MouseEvent e) {
      }
  
  public void mouseReleased(MouseEvent e) {
      }
  public void setMainFrame(MainFrame mainFrame) {
    this.mainFrame = mainFrame;
  }
  public MainFrame getMainFrame() {
    return this.mainFrame;
  }
}
