package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.tree.DefaultMutableTreeNode;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.view.action.AddPartnerLinkTypeAction;
import org.act.wsc.bpel4wsmodeling.view.action.AddRoleAction;
import org.act.wsc.bpel4wsmodeling.view.action.AddPropertyAction;
import org.act.wsc.bpel4wsmodeling.view.action.AddPropertyAliasAction;
import org.act.wsc.bpel4wsmodeling.view.action.GenerateDeploymentUnitAction;
import org.act.wsc.bpel4wsmodeling.view.action.ImportLocalWSDLAction;
import org.act.wsc.bpel4wsmodeling.view.action.ImportUDDIWSDLAction;
import org.act.wsc.bpel4wsmodeling.view.action.UserDefineWSDLAction;
import org.act.wsc.bpel4wsmodeling.view.processassist.PortTypeDesignDialog;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class NavigationTreeRightMenu extends JPopupMenu {
    private JPopupMenu projectPop = null;     private JMenu importWSDL;
    private JMenuItem itemLOCALWSDL;
    private JMenuItem itemUDDIWSDL;
    private JMenuItem UserDefineWSDL;
    private JMenuItem createWSAR;
    private JMenuItem addType;
    private JMenuItem addMessage;
    private JMenuItem addPortType;
    private JMenuItem addBinding;
    private JMenu design;
    private JMenuItem designPortType;
    private JMenuItem addRole;
    private JMenuItem addPartnerLinkType;
    private JMenuItem addProperty;
    private JMenuItem addPropertyAlias;
    NavigationPane tree;
    DefaultMutableTreeNode treeNode;
    Project project;
    ResourceBundle res = ResChoose.getLanguage();
    
    
    
    public NavigationTreeRightMenu(NavigationPane tree,
            DefaultMutableTreeNode treeNode, Project proj) {
        this.tree = tree;
        this.treeNode = treeNode;
        this.project = proj;
                try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    public void jbInit() {
        if (treeNode.getLevel() == 0) {
            this.projectPop = new JPopupMenu();
            importWSDL = new JMenu(res.getString("importWsdlFile"));
            itemLOCALWSDL = new JMenuItem(res.getString("lacalImport"));
            itemLOCALWSDL.addActionListener(new ImportLocalWSDLAction(project));
            this.importWSDL.add(this.itemLOCALWSDL);
            itemUDDIWSDL = new JMenuItem(res.getString("fromUDDI"));
            itemUDDIWSDL.addActionListener(new ImportUDDIWSDLAction(project));
            this.importWSDL.add(this.itemUDDIWSDL);
            UserDefineWSDL = new JMenuItem(res.getString("user_defined"));
            this.UserDefineWSDL.addActionListener(new UserDefineWSDLAction(
                    project));
            this.add(this.importWSDL);
            this.add(this.UserDefineWSDL);
            this.design = new JMenu(res.getString("design"));
            this.add(this.design);
            this.designPortType = new JMenuItem("portType");
            this.designPortType.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    PortTypeDesignDialog portTypeDesignDialog = new PortTypeDesignDialog(
                            project);
                    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                    Dimension dlgSize = portTypeDesignDialog.getSize();
                    if (dlgSize.height > screenSize.height) {
                      dlgSize.height = screenSize.height;
                    }
                    if (dlgSize.width > screenSize.width) {
                      dlgSize.width = screenSize.width;
                    }
                    portTypeDesignDialog.setLocation( (screenSize.width - dlgSize.width) / 2,
                                           (screenSize.height - dlgSize.height) / 2);
                    portTypeDesignDialog.show();
                }
            });
            this.design.add(this.designPortType);
            
            this.addRole = new JMenuItem("role");
            this.addRole.addActionListener(new AddRoleAction(project));
            this.design.add(this.addRole);
            this.addPartnerLinkType = new JMenuItem("partnerLinkType");
            this.addPartnerLinkType
                    .addActionListener(new AddPartnerLinkTypeAction(project));
            this.design.add(this.addPartnerLinkType);
            this.addProperty = new JMenuItem("property");
            this.addProperty.addActionListener(new AddPropertyAction(project));
            this.design.add(this.addProperty);
            this.addPropertyAlias = new JMenuItem("propertyAlias");
            this.addPropertyAlias.addActionListener(new AddPropertyAliasAction(
                    project));
            this.design.add(this.addPropertyAlias);
            createWSAR = new JMenuItem(res.getString("createWSAR"));
            this.add(this.createWSAR);
            this.createWSAR.addActionListener(new GenerateDeploymentUnitAction(
                    project));
        }
    }
}
