
package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.HeadlessException;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Iterator;
import java.util.ResourceBundle;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.utils.WSFilter;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class OpenProjectDialog extends JDialog {
	
	
	static ResourceBundle res = ResChoose.getLanguage();      
    public OpenProjectDialog() throws HeadlessException {
        super(MainFrame.getmainFrame(), res.getString("openItem"), true);
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        this.getContentPane().setLayout(null);
        
        jRadioButtonInside.setText(res.getString("chooseItemFromWorkspace"));
        jRadioButtonInside.setBounds(new Rectangle(20, 26, 145, 25));
        jRadioButtonInside
                .addActionListener(new OpenProjectDialog_jRadioButton_actionAdapter(
                        this));
        
        
        jRadioButtonOutside.setText(res.getString("importItem"));
        jRadioButtonOutside.setBounds(new Rectangle(20, 74, 146, 25));
        jRadioButtonOutside
                .addActionListener(new OpenProjectDialog_jRadioButton_actionAdapter(
                        this));
        
        
        buttonGroup.add(jRadioButtonInside);
        buttonGroup.add(jRadioButtonOutside);
        jTextFieldOutside.setBounds(new Rectangle(41, 108, 221, 25));
        jButtonBrowse.setBounds(new Rectangle(261, 108, 60, 25));
        jButtonBrowse.setText(res.getString("scan"));
        jButtonBrowse
                .addActionListener(new OpenProjectDialog_jButtonBrowse_actionAdapter(
                        this));
        jButtonCancel.setBounds(new Rectangle(191, 164, 60, 25));
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel
                .addActionListener(new OpenProjectDialog_jButtonCancel_actionAdapter(
                        this));
        jButtonOk.setBounds(new Rectangle(86, 166, 60, 25));
        jButtonOk.setText(res.getString("yes"));
        jButtonOk
                .addActionListener(new OpenProjectDialog_jButtonOk_actionAdapter(
                        this));
        jComboBoxInside.setBounds(new Rectangle(165, 27, 157, 25));
        for (Iterator iter = WorkSpace.getInstance().getProjects(). keySet().iterator(); iter.hasNext();) {
            String projectName = (String) iter.next();
            jComboBoxInside.addItem(projectName);
        }
        jComboBoxInside.setSelectedIndex(-1);
        
        jRadioButtonInside.setSelected(true);
        jRadioButtonOutside.setSelected(false);
        jComboBoxInside.setEnabled(true);
        jTextFieldOutside.setEnabled(false);
        jButtonBrowse.setEnabled(false);
        this.getContentPane().add(jRadioButtonInside);
        this.getContentPane().add(jRadioButtonOutside);
        this.getContentPane().add(jTextFieldOutside);
        this.getContentPane().add(jButtonBrowse);
        this.getContentPane().add(jButtonOk);
        this.getContentPane().add(jButtonCancel);
        this.getContentPane().add(jComboBoxInside);
        this.setSize(351, 240);
        this.setLocation(this.getOwner().getWidth() / 2 - this.getWidth() / 2,
                this.getOwner().getHeight() / 2 - this.getHeight() / 2);
    }
    JRadioButton jRadioButtonInside = new JRadioButton();
    JComboBox jComboBoxInside = new JComboBox();
    JRadioButton jRadioButtonOutside = new JRadioButton();
    JTextField jTextFieldOutside = new JTextField();
    JButton jButtonBrowse = new JButton();
    JButton jButtonCancel = new JButton();
    JButton jButtonOk = new JButton();
    ButtonGroup buttonGroup = new ButtonGroup();
    public void jButtonBrowse_actionPerformed(ActionEvent e) {
                                WSFilter filter = new WSFilter();
        filter.addExtension("awp");
        filter.setDescription("ACT WSWorkflow Project");
        JFileChooser fileChooser = new JFileChooser(System
                .getProperty("user.dir"));
        fileChooser.setFileFilter(filter);
        fileChooser.setMultiSelectionEnabled(true);
        int state = fileChooser.showOpenDialog(MainFrame.getmainFrame());
        if (state == JFileChooser.APPROVE_OPTION) {
            File file = fileChooser.getSelectedFile();
            String projectRealName = file.getAbsolutePath();
            this.jTextFieldOutside.setText(projectRealName);
        }
    }
    public void jButtonOk_actionPerformed(ActionEvent e) {
        if (jRadioButtonInside.isSelected()) {
            if (jComboBoxInside.getSelectedIndex() != -1) {
                String projectName = (String) jComboBoxInside.getSelectedItem();
                WorkSpace.getInstance().openProject(projectName, true);
            }
        } else if (jRadioButtonOutside.isSelected()) {
            String projectRealName = this.jTextFieldOutside.getText();
            String projectName = projectRealName.substring(projectRealName
                    .lastIndexOf(File.separator) + 1, projectRealName
                    .lastIndexOf('.'));
            if (projectRealName != "") {
                if (WorkSpace.getInstance().getProjects().containsKey(
                        projectName)) {
                    Print.showMessage(res.getString("failure"),Print.MESSAGE_TYPE_ERROR);
                    JOptionPane.showMessageDialog(null, res.getString("sameName_WithOtheProject"),
                    		res.getString("sameName_projectExist"), JOptionPane.WARNING_MESSAGE);
                    return;
                } else {
                    
                                        int position = projectRealName.lastIndexOf('\\');
                    String projectDir = projectRealName.substring(0, position);
                                        GetActiveProjectDir.setdir(projectDir);
                    WorkSpace.getInstance().openProject(projectRealName);
                }
            }
        }
        this.dispose();
    }
    public void jButtonCancel_actionPerformed(ActionEvent e) {
        this.dispose();
    }
    public void jRadioButton_actionPerformed(ActionEvent e) {
        if (jRadioButtonInside.isSelected()) {
            jComboBoxInside.setEnabled(true);
            jTextFieldOutside.setEnabled(false);
            jButtonBrowse.setEnabled(false);
        } else if (jRadioButtonOutside.isSelected()) {
            jComboBoxInside.setEnabled(false);
            jTextFieldOutside.setEnabled(true);
            jButtonBrowse.setEnabled(true);
        }
    }
}
class OpenProjectDialog_jRadioButton_actionAdapter implements ActionListener {
    private OpenProjectDialog adaptee;
    OpenProjectDialog_jRadioButton_actionAdapter(OpenProjectDialog adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jRadioButton_actionPerformed(e);
    }
}
class OpenProjectDialog_jButtonCancel_actionAdapter implements ActionListener {
    private OpenProjectDialog adaptee;
    OpenProjectDialog_jButtonCancel_actionAdapter(OpenProjectDialog adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonCancel_actionPerformed(e);
    }
}
class OpenProjectDialog_jButtonOk_actionAdapter implements ActionListener {
    private OpenProjectDialog adaptee;
    OpenProjectDialog_jButtonOk_actionAdapter(OpenProjectDialog adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonOk_actionPerformed(e);
    }
}
class OpenProjectDialog_jButtonBrowse_actionAdapter implements ActionListener {
    private OpenProjectDialog adaptee;
    OpenProjectDialog_jButtonBrowse_actionAdapter(OpenProjectDialog adaptee) {
        this.adaptee = adaptee;
    }
    public void actionPerformed(ActionEvent e) {
        adaptee.jButtonBrowse_actionPerformed(e);
    }
}
