
package org.act.wsc.bpel4wsmodeling.view.gui;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.HeadlessException;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;
import java.util.Vector;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.wsdl.Message;
import javax.wsdl.Part;
import org.act.metaset.utils.MetasetUtil;
import org.act.wsc.bpel4wsmodeling.debug.engine.WSWF;
import org.act.wsc.bpel4wsmodeling.debug.operate.DebugOp;
import org.act.wsc.bpel4wsmodeling.debug.operate.WatchVariable;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.WorkSpace;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class WatchPane extends JList implements MouseListener{
    
	
	
	  ResourceBundle res = ResChoose.getLanguage();  	  
    DefaultListModel listModel=new DefaultListModel();
    
    public WatchPane() {
        this.setModel(listModel);
        this.addMouseListener(this);
    }
    
    public void updateWatch(){
        for (int i = 0; i < listModel.toArray().length; i++) {
            WatchVariable watchVariable = (WatchVariable) listModel.toArray()[i];
            if(watchVariable.getVarName()!=null&&watchVariable.getPartName()!=null){
                watchVariable.setValue(WSWF.getVarPartValue(watchVariable.getVarName(),watchVariable.getPartName()));
            }
        }
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                WatchPane.this.validate();
                WatchPane.this.updateUI();
            }
        });
    }
    
    
    public void mouseClicked(MouseEvent e) {
        if(e.getButton()==3&&e.getClickCount()==1){
                        JPopupMenu menu=new JPopupMenu();
            JMenuItem addItem=new JMenuItem(res.getString("addWatch"));
            JMenuItem removeItem=new JMenuItem(res.getString("delete"));
            JMenuItem clearItem=new JMenuItem(res.getString("clean"));
            menu.add(addItem);
            menu.add(removeItem);
            menu.add(clearItem);
            addItem.addActionListener(new ActionListener(){
                
                public void actionPerformed(ActionEvent e) {
                    AddWatchDialog addWatchDialog=new AddWatchDialog();
                    addWatchDialog.show();
                    String varName=addWatchDialog.getVName();
                    String partName=addWatchDialog.getPName();
                    if(varName!=null){
                        WatchVariable watchVariable=new WatchVariable(varName,partName);
                        if(varName!=null&&partName!=null){
                            String variableValue=WSWF.getVarPartValue(varName,partName);
                            watchVariable.setValue(variableValue);
                        }
                        listModel.addElement(watchVariable);
                    }
                }});
            removeItem.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    WatchVariable selItem=(WatchVariable) WatchPane.this.getSelectedValue();
                    if(selItem!=null){
                        listModel.removeElement(selItem);
                    }
                }});
            
            clearItem.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e) {
                    listModel.removeAllElements();
                }});
            
            menu.show(e.getComponent(),e.getX(),e.getY());
        }
    }
    
    public void mouseEntered(MouseEvent e) {
                
    }
    
    public void mouseExited(MouseEvent e) {
                
    }
    
    public void mousePressed(MouseEvent e) {
                
    }
    
    public void mouseReleased(MouseEvent e) {
            }
}
//<p></p><p></p><p></p><p></p> 
class AddWatchDialog extends JDialog {
    
    String vName=null;
    String pName=null;
    Project project=WorkSpace.getInstance().getActiveProject();
    public AddWatchDialog() throws HeadlessException {
        super(MainFrame.getmainFrame(),true);
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        this.getContentPane().setLayout(gridBagLayout1);
        
        
        ResourceBundle res = ResChoose.getLanguage();          
        
		        jLabelPName.setText("Part Name:");
                jLabelVName.setText("Variable Name:");
        jTextFieldVName.setText("");
        jTextFieldVName.addActionListener(new
                AddWatchDialog_jTextFieldVName_actionAdapter(this));
        jButtonC.setText(res.getString("no"));
        jButtonC.addActionListener(new AddWatchDialog_jButtonC_actionAdapter(this));
        jButtonOk.setSelectedIcon(null);
        jButtonOk.setText(res.getString("yes"));
        jButtonOk.addActionListener(new AddWatchDialog_jButtonOk_actionAdapter(this));
        this.getContentPane().add(jLabelVName,
                                  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(15, 19, 0, 0), 17, 6));
        this.setModal(true);
        this.getContentPane().add(jLabelPName,
                                  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(9, 19, 0, 0), 41, 6));
        this.getContentPane().add(jComboBoxPName,
                                  new GridBagConstraints(1, 1, 2, 1, 1.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
                new Insets(8, 0, 0, 28), 82, 3));
        this.getContentPane().add(jButtonOk,
                                  new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(11, 42, 32, 0), 8, 0));
        this.getContentPane().add(jButtonC,
                                  new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                new Insets(12, 26, 32, 52), 8, 0));
        this.getContentPane().add(jTextFieldVName,
                                  new GridBagConstraints(1, 0, 2, 1, 1.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
                new Insets(15, 0, 0, 28), 96, 2));
        this.setSize(290,170);
        this.setTitle(res.getString("addWatch"));
        this.setLocation(MainFrame.getmainFrame().getWidth()/2-this.getWidth()/2,MainFrame.getmainFrame().getHeight()/2-this.getHeight()/2);
    }
    JLabel jLabelPName = new JLabel();
    JLabel jLabelVName = new JLabel();
    JTextField jTextFieldVName = new JTextField();
    JComboBox jComboBoxPName = new JComboBox();
    JButton jButtonC = new JButton();
    JButton jButtonOk = new JButton();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    
    public String getPName() {
        return pName;
    }
    
    public String getVName() {
        return vName;
    }
    public void jButtonC_actionPerformed(ActionEvent e) {
        vName=null;
        pName=null;
        this.dispose();
    }
    public void jTextFieldVName_actionPerformed(ActionEvent e) {
                vName=this.jTextFieldVName.getText();       
        Vector variables=new Vector();
        if(DebugOp.getInstance().getStopFigure()!=null){
            variables.addAll(DebugOp.getInstance().getStopFigure().getVariableList());
            for (Iterator iter = variables.iterator(); iter.hasNext();) {
                Variable variable = (Variable) iter.next();
                if(variable.getAtNameValue().equals(vName)){
                    String prefix=null;
                    if(variable.getAtMessageTypeValue().indexOf(':')!=-1){
                        prefix=variable.getAtMessageTypeValue().substring(0,variable.getAtMessageTypeValue().indexOf(':'));
                    }
                    String localPart=variable.getAtMessageTypeValue().substring(variable.getAtMessageTypeValue().indexOf(':')+1);
                    List parts=((Message)(project.getWSDLRegistry().findMessage(MetasetUtil.getActualNamespace(project.getProcess().getProcess(),prefix),localPart).userObject)).getOrderedParts(null);
                    for (Iterator iterator = parts.iterator(); iterator.hasNext();) {
                        Part part = (Part) iterator.next();
                        this.jComboBoxPName.addItem(part.getName());
                    }
                    break;
                }
            }
        }
        
    }
    public void jButtonOk_actionPerformed(ActionEvent e) {
        vName=this.jTextFieldVName.getText();
        pName=(String) this.jComboBoxPName.getSelectedItem();
        this.dispose();
    }
    class AddWatchDialog_jButtonOk_actionAdapter implements ActionListener {
        private AddWatchDialog adaptee;
        AddWatchDialog_jButtonOk_actionAdapter(AddWatchDialog adaptee) {
            this.adaptee = adaptee;
        }
        public void actionPerformed(ActionEvent e) {
            adaptee.jButtonOk_actionPerformed(e);
        }
    }
    class AddWatchDialog_jTextFieldVName_actionAdapter implements ActionListener {
        private AddWatchDialog adaptee;
        AddWatchDialog_jTextFieldVName_actionAdapter(AddWatchDialog adaptee) {
            this.adaptee = adaptee;
        }
        public void actionPerformed(ActionEvent e) {
            adaptee.jTextFieldVName_actionPerformed(e);
        }
    }
    class AddWatchDialog_jButtonC_actionAdapter implements ActionListener {
        private AddWatchDialog adaptee;
        AddWatchDialog_jButtonC_actionAdapter(AddWatchDialog adaptee) {
            this.adaptee = adaptee;
        }
        public void actionPerformed(ActionEvent e) {
            adaptee.jButtonC_actionPerformed(e);
        }
    }
    
}
