package org.act.wsc.bpel4wsmodeling.view.processassist;
import javax.swing.*;
import java.awt.*;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import java.awt.event.ActionEvent;
import java.util.ResourceBundle;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.def.process.Correlation;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSet;
import org.act.wsc.bpel4wsmodeling.def.process.CorrelationSets;
import org.act.wsc.bpel4wsmodeling.def.process.Correlations;
import org.act.wsc.bpel4wsmodeling.def.process.Invoke;
import org.act.wsc.bpel4wsmodeling.def.process.OnMessage;
import org.act.wsc.bpel4wsmodeling.def.process.Receive;
import org.act.wsc.bpel4wsmodeling.def.process.Reply;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class CorrelationDialog extends JDialog {
    JPanel jPanel1 = new JPanel();
    JLabel jLabel1 = new JLabel();
    JLabel jLabelInitiate = new JLabel();
    JComboBox jComboBoxSet = new JComboBox();
    JComboBox jComboBoxInitiate = new JComboBox();
    JButton jButtonOK = new JButton();
    JButton jButtonCancel = new JButton();
    JLabel jLabelSet = new JLabel();
    Figure figure;
    Invoke invoke = null;
    Receive receive = null;
    Reply reply = null;
    JLabel jLabelPattern = new JLabel();
    JComboBox jComboBoxPattern = new JComboBox();
    Correlation correlation = null;
    BPELProcess process;
    OnMessage onMessage = null;
    static ResourceBundle res = ResChoose.getLanguage();
    
    public CorrelationDialog(MainFrame frame, Figure f) {
        super(frame, res.getString("setCorrelation"), true);
        figure = f;
        process = this.figure.getOwner().getBPELProcess();
        int type = figure.getType();
        switch (type) {
        case Figure.LABLE_INVOKE:
            this.invoke = (Invoke) figure.getServicesSet();
            break;
        case Figure.LABLE_RECEIVE:
            this.receive = (Receive) figure.getServicesSet();
            break;
        case Figure.LABLE_REPLY:
            this.reply = (Reply) figure.getServicesSet();
            break;
        case Figure.LABLE_ONMESSAGE:
            this.onMessage = (OnMessage) figure.getServicesSet();
        default:
            break;
        }
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        jPanel1.setLayout(null);
        jLabelInitiate.setText("Initiate");
        jLabelInitiate.setBounds(new Rectangle(31, 98, 60, 33));
        jComboBoxSet.setBounds(new Rectangle(92, 53, 266, 27));
        jComboBoxInitiate.setBounds(new Rectangle(91, 104, 266, 27));
        jButtonOK.setBounds(new Rectangle(169, 192, 76, 27));
        jButtonOK.setText(res.getString("yes"));
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonOK_actionPerformed(e);
            }
        });
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.setBounds(new Rectangle(261, 192, 77, 27));
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonCancel_actionPerformed(e);
            }
        });
        jLabelSet.setBounds(new Rectangle(29, 52, 60, 33));
        jLabelSet.setText("Set");
        jLabelPattern.setText("Pattern");
        jLabelPattern.setBounds(new Rectangle(28, 155, 52, 25));
        jComboBoxPattern.setBounds(new Rectangle(91, 152, 266, 27));
        this.getContentPane().add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jLabelInitiate, null);
        jPanel1.add(jComboBoxSet, null);
        jPanel1.add(jComboBoxInitiate, null);
        jPanel1.add(jLabelSet, null);
        if (this.invoke != null) {
            jPanel1.add(jLabelPattern, null);
            jPanel1.add(jComboBoxPattern, null);
        }
        jPanel1.add(jButtonOK, null);
        jPanel1.add(jButtonCancel, null);
    }
    public void setCorrelation(Correlation correlation) {
        this.correlation = correlation;
 //       <correlation set="ncname" initiate="yes|no"?

        this.jComboBoxSet.removeAllItems();
        this.jComboBoxInitiate.removeAllItems();
        this.jComboBoxPattern.removeAllItems();
        if (this.process.getCorrelationSets() != null) {
            CorrelationSets correlationSets = (CorrelationSets) this.process
                    .getCorrelationSets().car();
            for (int i = 0; i < correlationSets.getChilds().size(); i++) {
                CorrelationSet correlationSet = (CorrelationSet) correlationSets
                        .getChilds().get(i);
                String correlationSetName = correlationSet.getAtNameValue();
                this.jComboBoxSet.addItem(correlationSetName);
            }
        }
        this.jComboBoxInitiate.addItem("yes");
        this.jComboBoxInitiate.addItem("no");
        this.jComboBoxPattern.addItem("in");
        this.jComboBoxPattern.addItem("out");
        this.jComboBoxPattern.addItem("out-in");
        if (this.correlation != null) {
            for (int i = 0; i < this.jComboBoxSet.getItemCount(); i++) {
                String name = (String) this.jComboBoxSet.getItemAt(i);
                if (this.correlation.getAtSetValue() != null
                        && this.correlation.getAtSetValue() != "") {
                    if (this.correlation.getAtSetValue().equals(name)) {
                        this.jComboBoxSet.setSelectedIndex(i);
                    }
                }
            }
            for (int j = 0; j < this.jComboBoxInitiate.getItemCount(); j++) {
                String initiateName = (String) this.jComboBoxInitiate
                        .getItemAt(j);
                if (this.correlation.getAtInitiateValue() != null
                        && this.correlation.getAtInitiateValue() != "") {
                    if (this.correlation.getAtInitiateValue().equals(
                            initiateName)) {
                        this.jComboBoxInitiate.setSelectedIndex(j);
                    }
                }
            }
            for (int k = 0; k < this.jComboBoxPattern.getItemCount(); k++) {
                String patternName = (String) this.jComboBoxPattern
                        .getItemAt(k);
                if (this.correlation.getAtPatternValue() != null
                        && this.correlation.getAtPatternValue() != "") {
                    if (this.correlation.getAtPatternValue()
                            .equals(patternName)) {
                        this.jComboBoxPattern.setSelectedIndex(k);
                    }
                }
            }
        }
    }
    void jButtonOK_actionPerformed(ActionEvent e) {
        Correlations correlations;
        if (this.correlation == null) {
            this.correlation = new Correlation();
            this.correlation.setAtSetValue((String) this.jComboBoxSet
                    .getSelectedItem());
            this.correlation.setAtIntiateValue((String) this.jComboBoxInitiate
                    .getSelectedItem());
            if (this.invoke != null) {
                this.correlation
                        .setAtPatternValue((String) this.jComboBoxPattern
                                .getSelectedItem());
                if (this.invoke.getCorrelations() == null) {
                    correlations = new Correlations();
                    this.invoke.addCorrelations(correlations);
                } else {
                    correlations = (Correlations) this.invoke.getCorrelations()
                            .car();
                }
                if (correlations.getChilds().size() > 0) {
                    if (!correlations.getChilds().contains(this.correlation)) {
                        this.invoke.addCorrelation(correlation);
                    }
                } else {
                    this.invoke.addCorrelation(correlation);
                }
            } else if (this.receive != null) {
                if (this.receive.getCorrelations() == null) {
                    correlations = new Correlations();
                    this.receive.addCorrelations(correlations);
                } else {
                    correlations = (Correlations) this.receive
                            .getCorrelations().car();
                }
                if (correlations.getChilds().size() > 0) {
                    if (!correlations.getChilds().contains(this.correlation)) {
                        this.receive.addCorrelation(correlation);
                    }
                } else {
                    this.receive.addCorrelation(correlation);
                }
            } else if (this.reply != null) {
                if (this.reply.getCorrelations() == null) {
                    correlations = new Correlations();
                    this.reply.addCorrelations(correlations);
                } else {
                    correlations = (Correlations) this.reply.getCorrelations()
                            .car();
                }
                if (correlations.getChilds().size() > 0) {
                    if (!correlations.getChilds().contains(this.correlation)) {
                        this.reply.addCorrelation(correlation);
                    }
                } else {
                    this.reply.addCorrelation(correlation);
                }
            } else if (this.onMessage != null) {
                if (this.onMessage.getCorrelations() == null) {
                    correlations = new Correlations();
                    this.onMessage.addCorrelations(correlations);
                } else {
                    correlations = (Correlations) this.onMessage
                            .getCorrelations().car();
                }
                if (correlations.getChilds().size() > 0) {
                    if (!correlations.getChilds().contains(this.correlation)) {
                        this.onMessage.addCorrelation(correlation);
                    }
                } else {
                    this.onMessage.addCorrelation(correlation);
                }
            }
        } else {
            Correlation corTemp = new Correlation();
            corTemp.setAtSetValue((String) this.jComboBoxSet.getSelectedItem());
            corTemp.setAtIntiateValue((String) this.jComboBoxInitiate
                    .getSelectedItem());
            if (this.invoke != null) {
                corTemp.setAtPatternValue((String) this.jComboBoxPattern
                        .getSelectedItem());
                if (this.invoke.getCorrelations() == null) {
                    correlations = new Correlations();
                    this.invoke.addCorrelations(correlations);
                } else {
                    correlations = (Correlations) this.invoke.getCorrelations()
                            .car();
                }
                if (correlations.getChilds().size() > 0) {
                    if (!correlations.getChilds().contains(corTemp)) {
                        this.correlation
                                .setAtSetValue((String) this.jComboBoxSet
                                        .getSelectedItem());
                        this.correlation
                                .setAtIntiateValue((String) this.jComboBoxInitiate
                                        .getSelectedItem());
                        this.correlation
                                .setAtPatternValue((String) this.jComboBoxPattern
                                        .getSelectedItem());
                    }
                }
            } else if (this.receive != null) {
                if (this.receive.getCorrelations() == null) {
                    correlations = new Correlations();
                    this.receive.addCorrelations(correlations);
                } else {
                    correlations = (Correlations) this.receive
                            .getCorrelations().car();
                }
                if (correlations.getChilds().size() > 0) {
                    if (!correlations.getChilds().contains(corTemp)) {
                        this.correlation
                                .setAtSetValue((String) this.jComboBoxSet
                                        .getSelectedItem());
                        this.correlation
                                .setAtIntiateValue((String) this.jComboBoxInitiate
                                        .getSelectedItem());
                    }
                }
            } else if (this.reply != null) {
                if (this.reply.getCorrelations() == null) {
                    correlations = new Correlations();
                    this.reply.addCorrelations(correlations);
                } else {
                    correlations = (Correlations) this.reply.getCorrelations()
                            .car();
                }
                if (correlations.getChilds().size() > 0) {
                    if (!correlations.getChilds().contains(corTemp)) {
                        this.correlation
                                .setAtSetValue((String) this.jComboBoxSet
                                        .getSelectedItem());
                        this.correlation
                                .setAtIntiateValue((String) this.jComboBoxInitiate
                                        .getSelectedItem());
                    }
                }
            } else if (this.onMessage != null) {
                if (this.onMessage.getCorrelations() == null) {
                    correlations = new Correlations();
                    this.onMessage.addCorrelations(correlations);
                } else {
                    correlations = (Correlations) this.onMessage
                            .getCorrelations().car();
                }
                if (correlations.getChilds().size() > 0) {
                    if (!correlations.getChilds().contains(corTemp)) {
                        this.correlation
                                .setAtSetValue((String) this.jComboBoxSet
                                        .getSelectedItem());
                        this.correlation
                                .setAtIntiateValue((String) this.jComboBoxInitiate
                                        .getSelectedItem());
                    }
                }
            }
        }
        this.process.write();
        dispose();
    }
    void jButtonCancel_actionPerformed(ActionEvent e) {
        dispose();
    }
}
