package org.act.wsc.bpel4wsmodeling.view.processassist;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import org.act.wsc.bpel4wsmodeling.projectdata.GetActiveProjectDir;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.ExtWsdl;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PartnerLinkType;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Property;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Role;
import org.act.wsc.bpel4wsmodeling.utils.Print;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;
import javax.wsdl.Definition;
import javax.wsdl.extensions.ExtensibilityElement;
import javax.wsdl.extensions.UnknownExtensibilityElement;
import javax.wsdl.factory.WSDLFactory;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import java.util.Iterator;
import java.util.Properties;
import java.util.ResourceBundle;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.ImportedWSDL;
import javax.wsdl.xml.WSDLWriter;
import javax.wsdl.*;
import java.io.FileOutputStream;
import java.io.*;
import java.util.Vector;
import javax.wsdl.Import;
import javax.xml.namespace.QName;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class PartnerLinkTypeDialog extends JDialog {
    JPanel jPanelPartnerLinkType = new JPanel();
    JLabel jLabelParnerLinkType = new JLabel();
    JLabel jLabelPartnerRole = new JLabel();
    JLabel jLabelMyRole = new JLabel();
    JButton jButtonOK = new JButton();
    JButton jButtonCancel = new JButton();
    JTextField jTextFieldPLT = new JTextField();
    JComboBox jComboBoxPRole = new JComboBox();
    JComboBox jComboBoxMyRole = new JComboBox();
    Project project;
    PartnerLinkType partnerLinkType=null;
    
    ExtWsdl wsdlExtClass = null;
    Definition wsdlExt = null;
    WSDLFactory wsdlFactory = null;
    
    
    ResourceBundle res = ResChoose.getLanguage();
    
    
        public PartnerLinkTypeDialog(Project proj, MainFrame mainframe) {
        super(mainframe);
        this.project = proj;
        this.wsdlExtClass = this.project.getExtWsdl();
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public PartnerLinkTypeDialog(Project proj, JFrame mainframe,PartnerLinkType partnerLinkType) {
        super(mainframe);
        this.project = proj;
        this.partnerLinkType=partnerLinkType;
        this.wsdlExtClass = this.project.getExtWsdl();
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private void jbInit() throws Exception {
        jLabelParnerLinkType.setText("partnerLinkType");
        jLabelParnerLinkType.setBounds(new Rectangle(24, 43, 100, 37));
        jPanelPartnerLinkType.setLayout(null);
        jLabelPartnerRole.setBounds(new Rectangle(24, 108, 86, 37));
        jLabelPartnerRole.setText("PartnerRole");
        jLabelMyRole.setBounds(new Rectangle(27, 184, 86, 37));
        jLabelMyRole.setText("MyRole");
        jButtonOK.setBounds(new Rectangle(180, 262, 74, 31));
        jButtonOK.setText(res.getString("yes"));
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonOK_actionPerformed(e);
            }
        });
        jButtonCancel.setText(res.getString("no"));
        jButtonCancel.setBounds(new Rectangle(283, 262, 74, 31));
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonCancel_actionPerformed(e);
            }
        });
        jTextFieldPLT.setBounds(new Rectangle(148, 48, 205, 37));
        jComboBoxPRole.setBounds(new Rectangle(149, 112, 206, 36));
        jComboBoxMyRole.setBounds(new Rectangle(149, 186, 206, 36));
        this.getContentPane().add(jPanelPartnerLinkType, BorderLayout.CENTER);
        jPanelPartnerLinkType.add(jLabelMyRole, null);
        jPanelPartnerLinkType.add(jLabelParnerLinkType, null);
        jPanelPartnerLinkType.add(jLabelPartnerRole, null);
        jPanelPartnerLinkType.add(jButtonOK, null);
        jPanelPartnerLinkType.add(jButtonCancel, null);
        jPanelPartnerLinkType.add(jTextFieldPLT, null);
        jPanelPartnerLinkType.add(jComboBoxPRole, null);
        jPanelPartnerLinkType.add(jComboBoxMyRole, null);
        setSize(400, 350);
    }
    public void setDialog() {
        if (this.project.getRoles().size() != 0) {
            for (int i = 0; i < this.project.getRoles().size(); i++) {
                Role r = (Role) this.project.getRoles().get(i);
                                jComboBoxPRole.addItem(r);
                jComboBoxMyRole.addItem(r);
            }
        }
        if(this.partnerLinkType!=null){
            jTextFieldPLT.setText(this.partnerLinkType.getName());
            jComboBoxPRole.setSelectedItem(this.partnerLinkType.getPartnerRole());
            jComboBoxMyRole.setSelectedItem(this.partnerLinkType.getMyRole());
        }
    }
        public void jButtonOK_actionPerformed(ActionEvent e) {
        if(this.partnerLinkType==null){
            PartnerLinkType plt = new PartnerLinkType();
            plt.setName(this.jTextFieldPLT.getText());
            if (this.jComboBoxMyRole.getSelectedItem() != null
                    && this.jComboBoxMyRole.getSelectedItem() != "") {
                plt.addMyRole((Role) this.jComboBoxMyRole.getSelectedItem());
            }
            if (this.jComboBoxPRole.getSelectedItem() != null
                    && this.jComboBoxPRole.getSelectedItem() != "") {
                plt.addPartnerRole((Role) this.jComboBoxPRole.getSelectedItem());
            }
            plt.setElementType(new javax.xml.namespace.QName(plt.getNameSpace(),
                    plt.getName()));
            if(this.project.addPlinkType(plt)==false){
                Print.showMessage(res.getString("add_partnerlintype_failure"),Print.MESSAGE_TYPE_ERROR);
                JOptionPane.showMessageDialog(MainFrame.getmainFrame(),res.getString("samenamepartnerlinktype"),res.getString("no"),JOptionPane.WARNING_MESSAGE);
            }
        }else{
            this.partnerLinkType.setName(this.jTextFieldPLT.getText());
            this.partnerLinkType.addMyRole((Role) this.jComboBoxMyRole.getSelectedItem());
            this.partnerLinkType.addPartnerRole((Role) this.jComboBoxPRole.getSelectedItem());
            this.partnerLinkType.setElementType(new QName(this.partnerLinkType.getNameSpace(),this.partnerLinkType.getName()));
            this.project.modifyPartnerLinkType();
                    }
        dispose();
    }
    void jButtonCancel_actionPerformed(ActionEvent e) {
        dispose();
    }
}
