
package org.act.wsc.bpel4wsmodeling.view.processassist;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import org.act.wsc.bpel4wsmodeling.bpeldata.listener.IProjectChildListener;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PartnerLinkType;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Property;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyAlias;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Role;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;

public class ProjectProperty implements IProjectChildListener{
    Project project;
    DefaultTableModel roleTableModel;
    DefaultTableModel partnerLinkTypeTableModel;
    DefaultTableModel propertyTableModel;
    DefaultTableModel propertyAliasTableModel;
    JTable jRoleTable;
    JTable jPartnerLinkTypeTable;
    JTable jPropertyTable;
    JTable jPropertyAliasTable;
        
    public ProjectProperty(Project project) {
        this.project = project;
        this.project.addPropertyListener(this);
        initRoleTable();
        initPartnerLinkTypeTable();
        initPropertyTable();
        initPropertyAliasTable();
    }
    private void initRoleTable() {
        roleTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        roleTableModel.setDataVector(new Object[][]{},new Object[]{"roles"});
        for (Iterator iter = project.getRoles().iterator(); iter.hasNext();) {
            Role role = (Role) iter.next();
            roleTableModel.addRow(new Object[]{role});
        }
        jRoleTable=new JTable(roleTableModel);
        jRoleTable.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e) {
                if(e.getButton()==3&&e.getClickCount()==1){
                   Role role= (Role) roleTableModel.getValueAt(jRoleTable.getSelectedRow(),0);
                   ProjectPropertyRightMenu rightMenu=new ProjectPropertyRightMenu(role,project);
                   rightMenu.show(jRoleTable,e.getX(),e.getY());
                }
            }});
    }
    
    private void initPartnerLinkTypeTable() {
        partnerLinkTypeTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        partnerLinkTypeTableModel.setDataVector(new Object[][]{},new Object[]{"partnerLinkTypes"});
        for (Iterator iter = project.getPlinkType().iterator(); iter.hasNext();) {
            PartnerLinkType partnerLinkType = (PartnerLinkType) iter.next();
            partnerLinkTypeTableModel.addRow(new Object[]{partnerLinkType});
        }
        jPartnerLinkTypeTable=new JTable(partnerLinkTypeTableModel);
        jPartnerLinkTypeTable.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e) {
                if(e.getButton()==3&&e.getClickCount()==1){
                   PartnerLinkType partnerLinkType= (PartnerLinkType) partnerLinkTypeTableModel.getValueAt(jPartnerLinkTypeTable.getSelectedRow(),0);
                   ProjectPropertyRightMenu rightMenu=new ProjectPropertyRightMenu(partnerLinkType,project);
                   rightMenu.show(jPartnerLinkTypeTable,e.getX(),e.getY());
                }
            }});
    }
    
    private void initPropertyTable() {
        propertyTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        propertyTableModel.setDataVector(new Object[][]{},new Object[]{"properties"});
        for (Iterator iter = project.getProperties().iterator(); iter.hasNext();) {
            Property property = (Property) iter.next();
            propertyTableModel.addRow(new Object[]{property});
        }
        jPropertyTable=new JTable(propertyTableModel);
        jPropertyTable.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e) {
                if(e.getButton()==3&&e.getClickCount()==1){
                   Property property= (Property) propertyTableModel.getValueAt(jPropertyTable.getSelectedRow(),0);
                   ProjectPropertyRightMenu rightMenu=new ProjectPropertyRightMenu(property,project);
                   rightMenu.show(jPropertyTable,e.getX(),e.getY());
                }
            }});
    }
    
    private void initPropertyAliasTable() {
        propertyAliasTableModel = new DefaultTableModel() {
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        propertyAliasTableModel.setDataVector(new Object[][]{},new Object[]{"propertyAlias"});
        for (Iterator iter = project.getPropertyAliases().iterator(); iter.hasNext();) {
            PropertyAlias propertyAlias = (PropertyAlias) iter.next();
            propertyAliasTableModel.addRow(new Object[]{propertyAlias});
        }
        jPropertyAliasTable=new JTable(propertyAliasTableModel);
        jPropertyAliasTable.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e) {
                if(e.getButton()==3&&e.getClickCount()==1){
                   PropertyAlias propertyAlias= (PropertyAlias) propertyAliasTableModel.getValueAt(jPropertyAliasTable.getSelectedRow(),0);
                   ProjectPropertyRightMenu rightMenu=new ProjectPropertyRightMenu(propertyAlias,project);
                   rightMenu.show(jPropertyAliasTable,e.getX(),e.getY());
                }
            }});
    }
    
    
    
    public JTable getJRoleTable() {
        return jRoleTable;
    }
    
    
    
    public JTable getJPartnerLinkTypeTable() {
        return jPartnerLinkTypeTable;
    }
    
    public JTable getJPropertyAliasTable() {
        return jPropertyAliasTable;
    }
    
    public JTable getJPropertyTable() {
        return jPropertyTable;
    }
    
    public void addRole(Role role) {
        this.roleTableModel.addRow(new Object[]{role});
    }
    
    public void deleteRole(Role role) {
        for (int i = 0; i < this.roleTableModel.getDataVector().size(); i++) {
            Vector element = (Vector) this.roleTableModel.getDataVector().elementAt(i);
            if(role.equals(element.elementAt(0))){
                this.roleTableModel.removeRow(i);
                return;
            }
        }
    }
    
    public void addPartnerLinkType(PartnerLinkType partnerLinkType) {
        this.partnerLinkTypeTableModel.addRow(new Object[]{partnerLinkType});
    }
    
    public void deletePartnerLinkType(PartnerLinkType partnerLinkType) {
        for (int i = 0; i < this.partnerLinkTypeTableModel.getDataVector().size(); i++) {
            Vector element = (Vector) this.partnerLinkTypeTableModel.getDataVector().elementAt(i);
            if(partnerLinkType.equals(element.elementAt(0))){
                this.partnerLinkTypeTableModel.removeRow(i);
                return;
            }
        }
    }
    
    public void addProperty(Property property) {
        this.propertyTableModel.addRow(new Object[]{property});
    }
    
    public void deleteProperty(Property property) {
        for (int i = 0; i < this.propertyTableModel.getDataVector().size(); i++) {
            Vector element = (Vector) this.propertyTableModel.getDataVector().elementAt(i);
            if(property.equals(element.elementAt(0))){
                this.propertyTableModel.removeRow(i);
                return;
            }
        }
    }
    
    public void addPropertyAlias(PropertyAlias propertyAlias) {
        this.propertyAliasTableModel.addRow(new Object[]{propertyAlias});
    }
    
    public void deletePropertyAlias(PropertyAlias propertyAlias) {
        for (int i = 0; i < this.propertyAliasTableModel.getDataVector().size(); i++) {
            Vector element = (Vector) this.propertyAliasTableModel.getDataVector().elementAt(i);
            if(propertyAlias.equals(element.elementAt(0))){
                this.propertyAliasTableModel.removeRow(i);
                return;
            }
        }
    }
}
