
package org.act.wsc.bpel4wsmodeling.view.processassist;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PartnerLinkType;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Property;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.PropertyAlias;
import org.act.wsc.bpel4wsmodeling.projectdata.processassist.Role;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class ProjectPropertyRightMenu extends JPopupMenu{
	
	 
	 ResourceBundle res = ResChoose.getLanguage();
	 
    private JMenuItem editProperty = new JMenuItem(res.getString("editproperty"));
    private JMenuItem delete = new JMenuItem(res.getString("delete"));
    
    private Role role=null;
    
    private PartnerLinkType partnerLinkType=null;
    
    private Property property=null;
    
    private PropertyAlias propertyAlias=null;
    
    Project project;
    
    public ProjectPropertyRightMenu(Object object,Project p){
        if(object instanceof Role){
            this.role=(Role) object;
        }else if(object instanceof PartnerLinkType){
            this.partnerLinkType=(PartnerLinkType) object;
        }
        else if(object instanceof Property){
            this.property=(Property) object;
        }
        else if(object instanceof PropertyAlias){
            this.propertyAlias=(PropertyAlias) object;
        }
        this.project=p;
        
        this.editProperty.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                if(role!=null){
                    RoleDialog dialog=new RoleDialog(MainFrame.getmainFrame(),project,role);
                    dialog.setDialog();
                    dialog.pack();
                    dialog.setSize(445,230);
                    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                    Dimension dlgSize = dialog.getSize();
                    if (dlgSize.height > screenSize.height) {
                      dlgSize.height = screenSize.height;
                    }
                    if (dlgSize.width > screenSize.width) {
                      dlgSize.width = screenSize.width;
                    }
                    dialog.setLocation( (screenSize.width - dlgSize.width) / 2,
                                           (screenSize.height - dlgSize.height) / 2);
                    dialog.show();
                }
                else if(partnerLinkType!=null){
                    PartnerLinkTypeDialog pltDialog = new PartnerLinkTypeDialog(project,MainFrame.getmainFrame(),partnerLinkType);
                    pltDialog.setDialog();
                                                            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                    Dimension dlgSize = pltDialog.getSize();
                    if (dlgSize.height > screenSize.height) {
                      dlgSize.height = screenSize.height;
                    }
                    if (dlgSize.width > screenSize.width) {
                      dlgSize.width = screenSize.width;
                    }
                    pltDialog.setLocation( (screenSize.width - dlgSize.width) / 2,
                                           (screenSize.height - dlgSize.height) / 2);
                    pltDialog.show();
                }
                else if(property!=null){
                    PropertyDialog pDialog=new PropertyDialog(project,MainFrame.getmainFrame(),property);
                    pDialog.setDialog();
                    pDialog.pack();
                    pDialog.setSize(400, 350);
                    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                    Dimension dlgSize = pDialog.getSize();
                    if (dlgSize.height > screenSize.height) {
                      dlgSize.height = screenSize.height;
                    }
                    if (dlgSize.width > screenSize.width) {
                      dlgSize.width = screenSize.width;
                    }
                    pDialog.setLocation( (screenSize.width - dlgSize.width) / 2,
                                          (screenSize.height - dlgSize.height) / 2);
                    pDialog.show();
                }
                else if(propertyAlias!=null){
                    PropertyAliasDialog pDialog=new PropertyAliasDialog(project,MainFrame.getmainFrame(),propertyAlias);
                    pDialog.setDialog();
                    pDialog.pack();
                    pDialog.setSize(400, 350);
                    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                    Dimension dlgSize = pDialog.getSize();
                    if (dlgSize.height > screenSize.height) {
                      dlgSize.height = screenSize.height;
                    }
                    if (dlgSize.width > screenSize.width) {
                      dlgSize.width = screenSize.width;
                    }
                    pDialog.setLocation( (screenSize.width - dlgSize.width) / 2,
                                          (screenSize.height - dlgSize.height) / 2);
                    pDialog.show();
                }
            }});
        this.add(editProperty);
        
        this.delete.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                if(role!=null){
                    project.deleteRole(role);
                }
                else if(partnerLinkType!=null){
                    project.deletePartnerLinkType(partnerLinkType);
                }
                else if(property!=null){
                    project.deleteProperty(property);
                }
                else if(propertyAlias!=null){
                    project.deletePropertyAlias(propertyAlias);
                }
            }});
        this.add(delete);
    }
}
