package org.act.wsc.bpel4wsmodeling.view.processassist;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import java.util.ResourceBundle;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.wsdl.Message;
import org.act.metaset.utils.MetasetUtil;
import org.act.wsc.bpel4wsmodeling.def.process.BPELProcess;
import org.act.wsc.bpel4wsmodeling.def.process.Scope;
import org.act.wsc.bpel4wsmodeling.def.process.Variable;
import org.act.wsc.bpel4wsmodeling.def.process.Variables;
import org.act.wsc.bpel4wsmodeling.projectdata.Project;
import org.act.wsc.bpel4wsmodeling.projectdata.process.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.process.GraphLayer;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.ImportedWSDL;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistry;
import org.act.wsc.bpel4wsmodeling.projectdata.wsdlregistry.WSDLRegistryEntry;
import org.act.wsc.bpel4wsmodeling.view.gui.MainFrame;
import org.act.wsc.bpel4wsmodeling.view.resource.ResChoose;

public class VariableDialog
    extends JDialog {
  private JPanel jPanelVariable = new JPanel();
  private JLabel jLabelName = new JLabel();
  private JTextField txtName = new JTextField();
  private JLabel jLabelMessageType = new JLabel();
  private JComboBox comboMessageType = new JComboBox();
  private JButton jButtonOK = new JButton();
  private JButton jButtonCancel = new JButton();
  private MainFrame frame;
  JLabel jLabel3 = new JLabel();
  JComboBox comboWSDL = new JComboBox();
  private Variable variable;
  private Variables variables;
  private GraphLayer mylayer;
  private Figure figure;
  private BPELProcess process;
  private Scope scope;
  Project project;
  private java.util.Vector messages;
  
  
  static ResourceBundle res = ResChoose.getLanguage();
  
  public VariableDialog(MainFrame frame, Object obj, Variable var) {
    super(frame, res.getString("setVariable"), true);
    this.frame = frame;
    project = this.frame.getProject();
    this.variable = var;
        if (obj instanceof GraphLayer) {
      this.mylayer = (GraphLayer) obj;
      this.process = this.mylayer.getBPELProcess();
      if (process.getVariables() != null) {
        this.variables = (Variables) process.getVariables().car();
      }
    }
    else if (obj instanceof Figure) {
      this.figure = (Figure) obj;
      this.scope = (Scope)this.figure.getServicesSet();
      if (scope.getVariables() != null) {
        this.variables = (Variables) scope.getVariables().car();
      }
    }
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    jPanelVariable.setLayout(null);
    jLabelName.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabelName.setText(res.getString("variableName"));
    jLabelName.setBounds(new Rectangle(14, 15, 84, 28));
    txtName.setBounds(new Rectangle(90, 16, 567, 26));
        jLabel3.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel3.setText("WSDL");
    jLabel3.setBounds(new Rectangle(14, 48, 87, 26));
    comboWSDL.setBounds(new Rectangle(16, 77, 643, 27));
    jLabelMessageType.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabelMessageType.setText(res.getString("messageType"));
    jLabelMessageType.setBounds(new Rectangle(14, 109, 78, 21));
    comboMessageType.setBounds(new Rectangle(13, 134, 647, 30));
        java.util.Map wsdls = this.frame.getProject().imports;
    java.util.Iterator it = wsdls.values().iterator();
    comboWSDL.addItem(res.getString("allwsdl"));
    while (it.hasNext()) {
      comboWSDL.addItem(it.next());
    }
    comboWSDL.setSelectedItem(res.getString("allwsdl"));
    comboWSDL.addActionListener(new ActionListener(){
        public void actionPerformed(ActionEvent e) {
            comboMessageType_actionPerformed(e);
        }});
    jButtonOK.setBounds(new Rectangle(241, 188, 83, 25));
    jButtonOK.setFont(new java.awt.Font("Dialog", 0, 14));
    jButtonOK.setText(res.getString("VariableDialog_yes"));
    jButtonOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonOK_actionPerformed(e);
      }
    });
    jButtonCancel.setBounds(new Rectangle(384, 187, 84, 26));
    jButtonCancel.setFont(new java.awt.Font("Dialog", 0, 14));
    jButtonCancel.setText(res.getString("VariableDialog_cancel"));
    jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonCancel_actionPerformed(e);
      }
    });
    getContentPane().add(jPanelVariable);
    jPanelVariable.add(jLabelName, null);
    jPanelVariable.add(txtName, null);
    jPanelVariable.add(jLabel3, null);
    jPanelVariable.add(comboWSDL, null);
    jPanelVariable.add(comboMessageType, null);
    jPanelVariable.add(jLabelMessageType, null);
    jPanelVariable.add(jButtonCancel, null);
    jPanelVariable.add(jButtonOK, null);
  }
  public void comboMessageType_actionPerformed(ActionEvent e){
      this.comboMessageType.removeAllItems();
      WSDLRegistry wsdlRegistry = project.getWSDLRegistry();
      List messages=null;
      if(comboWSDL.getSelectedIndex()!=-1){
          if(comboWSDL.getSelectedItem() instanceof ImportedWSDL){
              messages = wsdlRegistry.findMessages((ImportedWSDL) comboWSDL.getSelectedItem());
          }else{
              messages = wsdlRegistry.findMessages();
          }
          for (int i = 0; i < messages.size(); i++) {
              WSDLRegistryEntry wre = (WSDLRegistryEntry) messages.get(i);
              this.comboMessageType.addItem(wre);
            }
      }
  }
  public void setDialog() {
    this.comboMessageType.removeAllItems();
    WSDLRegistry wsdlRegistry = project.getWSDLRegistry();
    List messages = wsdlRegistry.findMessages();
    for (int i = 0; i < messages.size(); i++) {
      WSDLRegistryEntry wre = (WSDLRegistryEntry) messages.get(i);
      this.comboMessageType.addItem(wre);
    }
    if (this.variable != null) {
      txtName.setText(variable.getAtNameValue());
      for (int i = 0; i < comboMessageType.getItemCount(); i++) {
        WSDLRegistryEntry wre = (WSDLRegistryEntry)this.comboMessageType.
            getItemAt(i);
                if (variable.getAtMessageTypeValue().indexOf(":") != -1) {
          String messageNS = MetasetUtil.getActualNamespace(variable,
              variable.
              getAtMessageTypeValue().substring(0,
                                                variable.getAtMessageTypeValue().
                                                lastIndexOf(":"))
              );
          String message = variable.getAtMessageTypeValue().substring(variable.
              getAtMessageTypeValue().lastIndexOf(":") + 1,
              variable.getAtMessageTypeValue().length());
          if (messageNS.equals(wre.namespace) && message.equals(wre.localName)) {
            this.comboMessageType.setSelectedIndex(i);
          }
        }
        else {
          String message = variable.getAtMessageTypeValue();
          if (message.equals(wre.localName)) {
            this.comboMessageType.setSelectedIndex(i);
          }
        }
      }
    }
  }
  void jButtonOK_actionPerformed(ActionEvent e) {
    if (variables == null) {
      this.variables = new Variables();
    }
    String name = txtName.getText();
    WSDLRegistryEntry wre = (WSDLRegistryEntry)this.comboMessageType.
        getSelectedItem();
    Message message = (Message) wre.userObject;
    String messageType;
        if (this.process != null) {
            Variable tempVar = null;
      tempVar = new Variable();
      String strPrefix = MetasetUtil.getPrefix(this.process .getProcess() , message.getQName().
          getNamespaceURI());
            if (strPrefix == null) {
        messageType = message.getQName().getLocalPart();
      }
      else {
        messageType = strPrefix + ":" + message.getQName().getLocalPart();
      }
      tempVar.setAtNameValue(name);
      tempVar.setAtMessageTypeValue(messageType);
      if (this.variable == null) {
                this.variable = new Variable();
        boolean flag = false;
        for (int i = 0; i < this.variables.getChilds().size(); i++) {
          Variable var = (Variable)this.variables.getChilds().get(i);
          if (var.getAtNameValue().equals(tempVar.getAtNameValue())) {
            flag = true;
          }
          if (flag == true) {
            break;
          }
        }
        if (flag == false) {
          this.variable = tempVar;
          this.process.addVariable(this.variable);
        }
      }
      else {
                boolean flag = false;
        for (int i = 0; i < this.variables.getChilds().size(); i++) {
          Variable var = (Variable)this.variables.getChilds().get(i);
          if (var.getAtNameValue().equals(tempVar.getAtNameValue())) {
            flag = true;
          }
          if (flag == true) {
            break;
          }
        }
        if (flag == false) {
          this.variable.setAtNameValue(name);
        }
        this.variable.setAtMessageTypeValue(messageType);
      }
      this.process.write();
    }
    else if (this.scope != null) {
        Variable tempVar = null;
        tempVar = new Variable();
        String strPrefix=null;
        if(this.figure!=null){
            strPrefix = MetasetUtil.getPrefix(this.figure.getOwner().getBPELProcess().getProcess() , message.getQName(). getNamespaceURI());    
        }
                if (strPrefix == null) {
          messageType = message.getQName().getLocalPart();
        }
        else {
          messageType = strPrefix + ":" + message.getQName().getLocalPart();
        }
        tempVar.setAtNameValue(name);
        tempVar.setAtMessageTypeValue(messageType);
        if (this.variable == null) {
                        this.variable = new Variable();
            boolean flag = false;
            for (int i = 0; i < this.variables.getChilds().size(); i++) {
              Variable var = (Variable)this.variables.getChilds().get(i);
              if (var.getAtNameValue().equals(tempVar.getAtNameValue())) {
                flag = true;
              }
              if (flag == true) {
                break;
              }
            }
            if (flag == false) {
              this.variable = tempVar;
              this.scope.addVariable(this.variable);
            }
          }
          else {
                        boolean flag = false;
            for (int i = 0; i < this.variables.getChilds().size(); i++) {
              Variable var = (Variable)this.variables.getChilds().get(i);
              if (var.getAtNameValue().equals(tempVar.getAtNameValue())) {
                flag = true;
              }
              if (flag == true) {
                break;
              }
            }
            if (flag == false) {
              this.variable.setAtNameValue(name);
            }
            this.variable.setAtMessageTypeValue(messageType);
          }
        if(this.figure!=null){
            this.figure.getOwner().getBPELProcess().write();
        }
    }
    dispose();
  }
  void jButtonCancel_actionPerformed(ActionEvent e) {
    dispose();
  }
}
